/******************************************************************************
*                                                                             *
*  File: AutoConfExceptions.cpp                                               *
*                                                                             *
*  Description: The definition of Exceptions used in the automatic            *
*               configuration subsystem.                                      *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.1.1.2 $
   $Log: AutoConfigExceptions.cpp,v $
   Revision 1.1.1.2  1999/10/15 22:10:19  yamane
   Clean up for native exception support.

   Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
   Version compatible with TAO 1.0

   Revision 1.2  1999/08/11 13:57:24  f-kon
   improved version with most bugs fixed

   Revision 1.1  1999/08/03 22:47:47  f-kon
   Initial version of the Automatic Configuration Systems. It is not yet fully debugged.

******************************************************************************/

#include "AutoConfigExceptions.h"

NotFound::NotFound(const ACE_CString &error)
{
  BaseException::BaseException (error);
}

const char * 
NotFound::type ()
{
  return "Not Found";
}

//////////////////////////////////////////////////////////////////////

ParseError::ParseError(const ACE_CString &error)
{
  BaseException::BaseException (error);
}

const char * 
ParseError::type ()
{
  return "Parse Error";
}


//////////////////////////////////////////////////////////////////////

InitializationFailure::InitializationFailure(const ACE_CString &error)
{
  BaseException::BaseException (error);
}

const char * 
InitializationFailure::type ()
{
  return "Initialization Failure";
}

//////////////////////////////////////////////////////////////////////

Unsupported::Unsupported (const ACE_CString &error)
{
  BaseException::BaseException (error);
}

const char * 
Unsupported::type ()
{
  return "Unsupported in this version";
}


