/******************************************************************************
*                                                                             *
*  File: AutoConfExceptions.h                                                 *
*                                                                             *
*  Description: The definition of Exceptions used in the automatic            *
*               configuration subsystem.                                      *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.1.1.2 $
   $Log: AutoConfigExceptions.h,v $
   Revision 1.1.1.2  1999/10/15 22:10:20  yamane
   Clean up for native exception support.

   Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
   Version compatible with TAO 1.0

   Revision 1.2  1999/08/11 13:57:25  f-kon
   improved version with most bugs fixed

   Revision 1.1  1999/08/03 22:47:47  f-kon
   Initial version of the Automatic Configuration Systems. It is not yet fully debugged.

******************************************************************************/

#ifndef AUTO_CONFIGEXCEPTIONS_H
#define AUTO_CONFIGEXCEPTIONS_H

#include "BaseException.h"

class NotFound : public BaseException
{
public:
  NotFound (const ACE_CString &msg);
  const char *type ();
};

class ParseError : public BaseException
{
public:
  ParseError (const ACE_CString &msg);
  const char *type ();
};

class InitializationFailure : public BaseException
{
public:
  InitializationFailure (const ACE_CString &msg);
  const char *type ();
};


class Unsupported : public BaseException
{
public:
  Unsupported (const ACE_CString &msg);
  const char *type ();
};



#endif

