/******************************************************************************
*                                                                             *
*  File: AutoConfigServer.h                                                   *
*                                                                             *
*  Description: The main() file for the Automatic Configuration Server.       *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.2 $
   $Log: AutoConfigServer.h,v $
   Revision 1.2  2000/01/27 17:41:39  f-kon
   several small improvements

   Revision 1.1.1.4  1999/10/18 03:52:13  yamane
   Cleanup for Linux

   Revision 1.1.1.3  1999/10/17 23:35:46  yamane
   Cleanup for native exceptions and Linux

   Revision 1.1.1.2  1999/10/15 22:10:23  yamane
   Clean up for native exception support.

   Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
   Version compatible with TAO 1.0

   Revision 1.1  1999/08/03 22:47:48  f-kon
   Initial version of the Automatic Configuration Systems. It is not yet fully debugged.

******************************************************************************/

# ifndef AUTOCONFIGSERVER_H
# define AUTOCONFIGSERVER_H

#include "tao/TAO.h"
#include "AutoConfig_i.h"

class AutoConfigServer
{
 public:
  AutoConfigServer ();

  int init (int argc, char**argv);
  int run (CORBA_Environment& ACE_TRY_ENV);

 private:
  int parse_args (int argc, char *argv[]);

  int verbose_; // If set to 1, we print the server IOR on the stdout.
  FILE * ior_output_file_;
  size_t time_; // After how many seconds the server should stop listening to requests.

  TAO_ORB_Manager orbManager_;
  
  AutoConfig_i autoConfigImpl_; // The actual implementation of our server.
  
};

#endif
