/******************************************************************************
*                                                                             *
*  File: BaseException.cpp                                                    *
*                                                                             *
*  Description: Base class for exceptions.                                    *
*                                                                             *
*                                                                             *
*  Project: 2K - Generic utility.                                             *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.2 $

   $Log: BaseException.cpp,v $
   Revision 1.1.1.2  1999/10/15 22:10:26  yamane
   Clean up for native exception support.

   Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
   Version compatible with TAO 1.0

   Revision 1.1  1999/08/03 22:47:48  f-kon
   Initial version of the Automatic Configuration Systems. It is not yet fully debugged.

******************************************************************************/

#include "BaseException.h"

BaseException::BaseException(const ACE_CString &error)
{
  error_ = error;
}

ACE_CString &
BaseException::error()
{
  return error_;
}

const char * 
BaseException::type ()
{
  return "Base Exception";
}
