/******************************************************************************
*                                                                             *
*  File: BaseException.h                                                      *
*                                                                             *
*  Description: Base class for exceptions.                                    *
*                                                                             *
*                                                                             *
*  Project: 2K - Generic utility.                                             *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.2 $

   $Log: BaseException.h,v $
   Revision 1.1.1.2  1999/10/15 22:10:27  yamane
   Clean up for native exception support.

   Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
   Version compatible with TAO 1.0

   Revision 1.1  1999/08/03 22:47:48  f-kon
   Initial version of the Automatic Configuration Systems. It is not yet fully debugged.

******************************************************************************/

#ifndef BASEEXCEPTION_H
#define BASEEXCEPTION_H

#include "ace/SString.h"

class BaseException {
protected:
  ACE_CString error_;

public:
  BaseException (const ACE_CString &msg = "Exception thrown");

  ACE_CString &error ();

  virtual const char *type(); // maybe we can get rid of this and use RTTI? F.
};

#endif
