/******************************************************************************
*                                                                             *
*  File: CachingResolver.h                                                    *
*                                                                             *
*  Description: A simple prerequisite resolver (with caching capabilities).   *
*               It is a subclass of the SimpleResolver.                       *
*                                                                             *
*  Note: The components are loaded in the address space of the                *
*        DynamicConfigurator CORBA object (which may be remote).              *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.2 $
   $Log: CachingResolver.h,v $
   Revision 1.2  2000/10/09 20:26:18  f-kon
   New namespace for CORBA modules combined with Tomo's changes to support Windows.

******************************************************************************/

#ifndef CACHING_RESOLVER_H
#define CACHING_RESOLVER_H

#include "tao/TAO.h"
#include "SimpleResolver.h"

class CachingResolver : public SimpleResolver 
{
 protected: 
  Configuration::ComponentConfigurator_ptr
  resolvePrereq (Configuration::ComponentConfigurator_ptr client,
                 const char *hookName, 
                 TwoK2::Name compSpec,
                 CORBA::Environment &ACE_TRY_ENV) 
    ACE_THROW_SPEC((NotFound, LoadFailure));
};


#endif
