/******************************************************************************
*                                                                             *
*  File: PrereqParser.cpp                                                     *
*                                                                             *
*  Description: Abstract class definition for prerequisite parsers.           *
*                                                                             *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.1.1.3 $
   $Log: PrereqParser.cpp,v $
   Revision 1.1.1.3  1999/10/15 22:10:31  yamane
   Clean up for native exception support.

   Revision 1.1.1.2  1999/10/15 21:49:34  yamane
   Clean up for native exception support

   Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
   Version compatible with TAO 1.0

   Revision 1.2  1999/08/11 13:57:30  f-kon
   improved version with most bugs fixed

   Revision 1.1  1999/08/03 22:47:48  f-kon
   Initial version of the Automatic Configuration Systems. It is not yet fully debugged.

******************************************************************************/

#include "PrereqParser.h"

const char *const PrereqParser::PREREQ_SUFFIX = ".prq";

void 
PrereqParser::init (CORBA::Object_ptr repository, PrereqResolver *resolver,
                    CORBA::Environment& ACE_TRY_ENV)
  ACE_THROW_SPEC((NotFound, InitializationFailure))
{
  resolver_ = resolver;
  if (resolver_ == 0)
     {
       ACE_THROW(InitializationFailure("No Perequisite Resolver"));
      }

  // Note: the repository has to be narrowed (casted) to the proper repository
  // type in a subclass.

}// init ()
