/******************************************************************************
*                                                                             *
*  File: client_i.h                                                           *
*                                                                             *
*  Description: A test client for the AutomaticConfigurationServer.           *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.2 $
 $Log: client_i.h,v $
 Revision 1.2  2000/10/09 20:26:09  f-kon
 New namespace for CORBA modules combined with Tomo's changes to support Windows.

 Revision 1.1.1.2  1999/10/15 22:10:41  yamane
 Clean up for native exception support.

 Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
 Version compatible with TAO 1.0

 Revision 1.1  1999/08/03 22:47:49  f-kon
 Initial version of the Automatic Configuration System. It is not yet fully debugged.

******************************************************************************/
#ifndef AC_CLIENT_I_H
#define AC_CLIENT_I_H

#include "ace/Get_Opt.h"
#include "ace/Profile_Timer.h"
#include "tao/corba.h"
#include "AutoConfigC.h" 

#include "tao/TAO.h"
#include "2k/ComponentConfigurator/Factory_i.h"

class AC_Client
{
public:
  AC_Client (void);
  ~AC_Client (void);

  int  init (int argc, char **argv);
  void run ();
  void fini ();

private:
  int  read_ior (char *filename);
  int  parse_args (int argc, char *argv[]);
  void print_stats (const char *call_name,
                    ACE_Profile_Timer::ACE_Elapsed_Time &elapsed_time);
  void test  (void);

  //member variables

  char *ac_ior_; // IOR of the ac server
  int shutdown_; // Flag to tell server to shutdown.

  TAO_ORB_Manager orb_manager_; // An ORB manager we use to register the CC factory.
  CCFactory_i factory_impl_;  // Implementation object of the ComponentConfigurator factory.
  TwoK::Configuration::CCFactory_ptr factory_ptr_; // a pointer to the factory object.
    
  TwoK2::AutoConfig_var autoConfig_; // Server pointer
  CORBA::ORB_var orb_;        // Remember our orb.
};

#endif
