/******************************************************************************
*                                                                             *
*  File: factory_i.h                                                          *
*                                                                             *
*  Description: The implementation of a ComponentConfigurator factory.        *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.2 $
 $Log: Factory_i.h,v $
 Revision 1.2  2000/10/09 21:02:33  f-kon
 Changes to use new TwoK:: namespace for 2K services integrated with Tomo's
 changes for Windows compilation.

 Revision 1.1.1.2  2000/02/20 07:53:30  yamane
 Using Factory from Resource Manager

 Revision 1.1.1.1  1999/10/12 00:42:46  f-kon
 Version compatible with TAO 1.0

 Revision 1.1.1.1  1999/04/01 18:16:36  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/15 18:03:18  f-kon
 *** empty log message ***


******************************************************************************/
#if !defined (CC_FACTORY_I_H)
#define CC_FACTORY_I_H

#include "ConfigurationS.h"

class CCFactory_i : public POA_TwoK::Configuration::CCFactory
{
 public:
  CCFactory_i (void);
  // Constructor.

  ~CCFactory_i (void);
  // Destructor.

  virtual TwoK::Configuration::ComponentConfigurator_ptr 
      newConfigurator (const char *name,
                       CORBA::Object_ptr implementation,
                       CORBA::Environment &env);
  // Creates a new ComponentConfigurator.

  virtual void shutdown (CORBA::Environment &_tao_environment);

  void poa (PortableServer::POA_ptr poa);
 protected:
  friend class ComponentConfiguratorServer;

 private:
  PortableServer::POA_var poa_;
};

#endif
