/******************************************************************************
*                                                                             *
*  File: server.cpp                                                           *
*                                                                             *
*  Description: A test server for the ComponentConfigurator object.           *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1.1.1 $
 $Log: server.cpp,v $
 Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
 Version compatible with TAO 1.0

 Revision 1.1.1.1  1999/04/01 18:16:36  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/15 18:03:18  f-kon
 *** empty log message ***


******************************************************************************/

#include "server_i.h"

int
main (int argc, char *argv[])
{
  ComponentConfiguratorServer compConfigServ;

  ACE_DEBUG ((LM_DEBUG,
              "\n\tComponentConfigurator:SERVER\n\n"));
  TAO_TRY
    {
      if (compConfigServ.init (argc, argv, TAO_TRY_ENV) == -1)
        return 1;
      else
        {
          compConfigServ.run (TAO_TRY_ENV);
          TAO_CHECK_ENV;
        }
    }
  TAO_CATCH (CORBA::SystemException, sysex)
    {
      ACE_UNUSED_ARG (sysex);
      TAO_TRY_ENV.print_exception ("System Exception");
      return -1;
    }
  TAO_CATCH (CORBA::UserException, userex)
    {
      ACE_UNUSED_ARG (userex);
      TAO_TRY_ENV.print_exception ("User Exception");
      return -1;
    }
  TAO_ENDTRY;
  return 0;
}
