/******************************************************************************
*                                                                             *
*  File: server_i.h                                                           *
*                                                                             *
*  Description: A test server for the ComponentConfigurator object.           *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.2 $
 $Log: server_i.h,v $
 Revision 1.2  2000/10/09 21:02:29  f-kon
 Changes to use new TwoK:: namespace for 2K services integrated with Tomo's
 changes for Windows compilation.

 Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
 Version compatible with TAO 1.0

 Revision 1.2  1999/04/23 22:32:09  f-kon
 *** empty log message ***

 Revision 1.1.1.1  1999/04/01 18:16:36  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/15 18:03:19  f-kon
 *** empty log message ***


******************************************************************************/

#if !defined (CC_SERVER_I_H)
#define CC_SERVER_I_H

#include "ace/Get_Opt.h"
#include "tao/TAO.h"

#include "Factory_i.h"

class ComponentConfiguratorServer
{
public:
  // = Initialization and termination methods.
  ComponentConfiguratorServer (void);
  // Default constructor

  ~ComponentConfiguratorServer (void);
  // Destructor

  int init (int argc,
            char **argv,
	    CORBA::Environment& env);
  // Initialize the ComponentConfiguratorServer state - parsing arguments and ...

  int run (CORBA::Environment& env);
  // Run the orb 

private:
  int parse_args (void);
  // Parses the commandline arguments.

  FILE* ior_output_file_;
  // File to output the cubit factory IOR.

  TAO_ORB_Manager orb_manager_;
  // The ORB manager.

  CCFactory_i factory_impl_;
  // Implementation object of the ComponentConfigurator factory.
       
  int argc_;
  // Number of commandline arguments.

  char **argv_;
  // commandline arguments.
};

#endif /* _C_SERVER_H */
