#include "orbsvcs/Trader/GrmExt_i.h"
#include "orbsvcs/CosNamingS.h"
#include "orbsvcs/CosNamingC.h"
#include "orbsvcs/Naming/Naming_Utils.h"


int main(int argc, char *argv[]) {
  ResourceMgmt::GrmExt_var grmExt;
  CORBA::ORB_var orb;

  try {
    orb = CORBA::ORB_init(argc, argv);

    CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
    PortableServer::POA_var poa = PortableServer::POA::_narrow(obj);

    PortableServer::POAManager_var mgr = poa->the_POAManager();
    mgr->activate();

    GrmExt_i servant(orb);
    grmExt = servant._this();
    

    //
    // Grava IOR num arquivo
    //
    CORBA::String_var ior = orb->object_to_string(grmExt);

    FILE *output_file = ACE_OS::fopen("/tmp/IOR_GrmExt", "w");
    if (! output_file) {
      return 1;
    }
    ACE_OS::fprintf(output_file, "%s", ior.in());
    ACE_OS::fclose(output_file);

    cout << ior.in() << endl;

    //
    // publica no servico de nomes
    //
    CORBA::Object_var name_obj = orb->resolve_initial_references("NameService");

    if (CORBA::is_nil(name_obj.in())) {
      ACE_OS::printf("server_GrmExt::main(): NamingService is nil.\n");
    }
    else {
      CosNaming::NamingContext_var inc;
      CosNaming::NamingContext_var grm_ext;
      CosNaming::Name name;

      name.length(1);
      name[0].id = CORBA::string_dup("grm_ext");
      name[0].kind = CORBA::string_dup("");

      inc = CosNaming::NamingContext::_narrow(name_obj);
      grm_ext = inc->bind_new_context(name);

      name[0].id = CORBA::string_dup(argv[argc - 1]);
      name[0].kind = CORBA::string_dup("");
      grm_ext->rebind(name, grmExt);
    }

    orb->run();
  } catch (const CosNaming::NamingContext::NotFound &n) {
    cerr << "n";
  } catch (const CosNaming::NamingContext::AlreadyBound &a) {
    cerr << "a";
  } catch (const CosNaming::NamingContext::CannotProceed &c) {
    cerr << "c";
  } catch (const CosNaming::NamingContext::InvalidName &i) {
    cerr << "i";
  } catch (const CORBA::Exception &e) {
    cerr << "server_GrmExt::main(): Excessao" << endl;
    return 1;
  }
  
  return 0;
}
