/******************************************************************************
*                                                                             *
*  File: BaseCC.h                                                             *
*                                                                             *
*  Description: Base Component Configurator for loading application           *
*                                                                             *
*  Project: 2K - Resource management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: BaseCC.h,v $
 Revision 1.1  2000/02/19 20:29:37  yamane
 Initial version

 Revision 1.1.1.1  1999/08/30 04:41:29  col
 Initial check-in


 Revision 1.1  1999/02/22 22:29:16  f-kon
 *** empty log message ***


******************************************************************************/

// teste
// Inclui 'TwoK::' e 'TwoK2::' na frente de varias linhas nao especificavam de 
// qual modulo era o tipo desejado, pois tava dando erro na compilacao
// Tambem troquei 'Factory_*' por 'CCFactory_*'. Parece que o anterior nao 
// existe!
// As linhas estao marcadas com MOD

#if !defined (CC_BASECC_I_H)
#define CC_BASECC_I_H

#include "tao/TAO.h"
#include "orbsvcs/CosNamingS.h"
#include "orbsvcs/CosNamingC.h"
#include "orbsvcs/Naming/Naming_Utils.h"

#include "dynamicTAO/src/DynamicConfigurator/dynamicConfigurator_i_.h"
#include "2k/AutoConfig/AutoConfig_i.h"
#include "2k/ComponentConfigurator/Factory_i.h"
#include "2k/ComponentConfigurator/Configuration_i.h"
#include "2k/ComponentConfigurator/ConfigurationS.h"

#include "dynamicTAO/src/ComponentConfigurator/SimpleConfigurator.h"

class BaseCC : public SimpleConfigurator
{
public:
  // = Initialization and termination methods.
  BaseCC (TAO_ORB_Manager &manager_);
  // Constructor

  ~BaseCC (void);
  // Destructor

  TwoK::Configuration::ComponentConfigurator_ptr CORBA_Object() { return domainConfigurator_; } // MOD

  ComponentConfigurator_i* add_component(const char *hook_name,
                                 const char *name,
                                 CORBA::Object *obj,
                                 CORBA::Environment& env);

  int load_component(const char *hook_name,
                      const char *category,
                      const char *component,
                      const char *args);
  // load specified component

private:
  void setup_domainconf(void);
  // setup Domain Configurator (Root Component Configurator)

  void setup_dynconf(void);
  // setup DynamicConfigurator

  void setup_autoconf(void);
  // setup Auto Configurator

  void setup_cc_factory(void);
  // setup Component Configurator Factory

  void setup_crepos(void);
  // setup Component Repository

  void connect_components(void);
  // Connects created cc with hooks

  TAO_ORB_Manager &orb_manager_;
  // The ORB manager.

  int argc_;
  // Number of commandline arguments.

  char **argv_;
  // commandline arguments.

  CORBA::ORB_var orb_;
  // Remember our orb.

  DynamicConfigurator_var dyn_conf_;
  // Dynamic configurator

  TwoK2::AutoConfig_var auto_conf_; // MOD
  AutoConfig_i *autoConfig_impl_; // Auto configurator implementation

  TwoK::Configuration::CCFactory_var cc_factory_; // MOD
  CCFactory_i *cc_factory_impl_; // Component Configurator Factory implementation // MOD

  PortableServer::POA_var poa_;

  TwoK::Configuration::ComponentConfigurator_var domainConfigurator_; // MOD

  DynamicConfigurator_var component_repos_;

  ComponentConfigurator_i *domain_cc_impl_;

  ComponentConfigurator_i *auto_cc_impl_;

  ComponentConfigurator_i *cr_cc_impl_;

  ComponentConfigurator_i *ccf_cc_impl_;

  ComponentConfigurator_i *dynconf_cc_impl_;
};

#endif /* CC_BASECC_I_H */
