/******************************************************************************
*                                                                             *
*  File: createdProcess.cpp                                                   *
*                                                                             *
*  Description: A test server for the Loader_i object.                        *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Resource Management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: BaseProcess.cpp,v $
 Revision 1.1  2000/02/19 20:29:37  yamane
 Initial version

 Revision 1.1.1.1  1999/08/30 04:41:29  col
 Initial check-in

 Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/22 22:29:16  f-kon
 *** empty log message ***

******************************************************************************/

#include "Loader_i.h"

int
main (int argc, char *argv[])
{
  Loader_i Loader_i;

  ACE_OS::printf("newComponent start executed\n");
  for (int i = 0 ; i < argc ; ++i) {
	ACE_OS::printf("argv[%d] = %s\n", i, argv[i]);
  }

  ACE_DEBUG ((LM_DEBUG,
              "\n\tnewComponent:SERVER\n\n"));

  CORBA::Environment ACE_TRY_ENV;

  ACE_TRY
    {
      if (Loader_i.init (argc, argv, ACE_TRY_ENV) == -1)
        return 1;
      else
        {
          Loader_i.run (ACE_TRY_ENV);
          ACE_TRY_CHECK;
        }
    }
  ACE_CATCH (CORBA::SystemException, sysex)
    {
      ACE_UNUSED_ARG (sysex);
      ACE_TRY_ENV.print_exception ("System Exception");
      return -1;
    }
  ACE_CATCH (CORBA::UserException, userex)
    {
      ACE_UNUSED_ARG (userex);
      ACE_TRY_ENV.print_exception ("User Exception");
      return -1;
    }
  ACE_ENDTRY;
  return 0;
}
