
// -*- C++ -*-
// $Id: Cloakroom_Helper.h,v 1.1 2000/02/19 20:31:00 yamane Exp $

// ============================================================================
//
// = LIBRARY
//    RMP/Lrm
//
// = FILENAME
//    checkin.h
//
// = DESCRIPTION
//    This class implements the Cloakroom analogy
//
// = AUTHOR
//    Tomonori Yamane <yamane@uiuc.edu>
//
// ============================================================================

#ifndef CLOAKROOM_I_H
#define CLOAKROOM_I_H

#include "ace/Synch.h"
#include "ace/Map_Manager.h"

template <class ITEM>
class Cloakroom_Helper
{
  // = TITLE
  //    Cloakroom_Helper Implementation
  //
  // = DESCRIPTION
  //    Implementation of a simple object that has all methods of Rrp.
  //
public:
  // = Initialization and termination methods.
  Cloakroom_Helper ();
  // Constructor

  ~Cloakroom_Helper (void);
  // Destructor
  
  long checkin(ITEM &item);
  // Check in the item and receive a unique tag

  ITEM checkout(long tag);
  // Pass the tag and check out the item

  ITEM lookup(long tag);
  // Pass the tag and read the item without checking out it

  void display_all();

private:
  long key_candidate;
  // next tag candidate

  typedef ACE_Map_Manager<long, ITEM, ACE_Null_Mutex> RMAP_TYPE;

  typedef  ACE_Map_Iterator<long, ITEM, ACE_Null_Mutex> ITERATOR;

  typedef ACE_Map_Entry<long, ITEM> ENTRY;

  RMAP_TYPE map;

  Cloakroom_Helper (Cloakroom_Helper &);
  // Copy Constructor added because g++ generates a 
  // bad one if not defined
};

#endif /* CLOAKROOM_I_H */
