/******************************************************************************
*                                                                             *
*  File: CpuApi_i.h                                                           *
*                                                                             *
*  Description: CORBA Wrapper for DSRT API                                          *
*                                                                             *
*  Project: 2K - Resource management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.3 $
 $Log: CpuApi_i.h,v $
 Revision 1.3  2000/09/30 18:37:09  yamane
 Patches for Windows

 Revision 1.2  2000/02/24 06:00:53  yamane
 Bug fix for SunOS5.6

 Revision 1.1  2000/02/19 20:31:00  yamane
 Initial version


******************************************************************************/

#if !defined (CC_CPUAPI_I_H)
#define CC_CPUAPI_I_H

#include "orbsvcs/ResourceMgmtS.h"
#include "orbsvcs/ResourceMgmtC.h"
#include "CpuApi.H"

class CpuApi_i:	public POA_ResourceMgmt::Cpu
{
public:
    CpuApi_i(::CpuApi *);

    ~CpuApi_i();

    virtual CORBA::Long reserve (
        const ResourceMgmt::Cpu::CpuReserve & cr,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long modify (
        const ResourceMgmt::Cpu::CpuReserve & cr,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long free (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long start (
        const ResourceMgmt::Cpu::timeval & begin,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long stop (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void yield (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void svcDestroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long setAdaptStrategy (
        const ResourceMgmt::Cpu::AdaptStrategy & as,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long setApDeadline (
        CORBA::Long deadline,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long probe (
        CORBA::Long period,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long probeEnd (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long probeMatch (
        ResourceMgmt::Cpu::CpuReserve_out cr,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long profileSave (
        const ResourceMgmt::Cpu::Args & args,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long profileGet (
        const ResourceMgmt::Cpu::Args & args,
        CORBA::Float_out util,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long setRecordProcStats (
        const char * fname,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long setRecordSchedStats (
        const char * fname,
        CORBA::Long samplingInterval,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual ResourceMgmt::Cpu::ProcStats getProcStats (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual ResourceMgmt::Cpu::SchedStats getSchedStats (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Long isPermNonconform (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual ResourceMgmt::Cpu::Process getProcess (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

private:
     ::CpuApi *cpu_;
};


#endif /* CC_CPUAPI_I_H */
