/******************************************************************************
*                                                                             *
*  File: DSRT_API.h                                                           *
*                                                                             *
*  Description: Wrapper for DSRT API                                          *
*                                                                             *
*  Project: 2K - Resource management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: DSRT_Helper.h,v $
 Revision 1.1  2000/02/19 20:31:00  yamane
 Initial version


******************************************************************************/

#if !defined (CC_DSRT_HELPER_H)
#define CC_DSRT_HELPER_H

#include "orbsvcs/CosTradingC.h"
#include "CpuApi.H"

class DSRT_Helper
{
public:
  static CpuApi *instance(void);
  // flavor of singleton

  static int parse(CosTrading::PropertySeq& resource_spec);
  // parse DSRT request

  static int reserve(void);
  // reserve CPU according to the resource spec

private:

  static CpuApi *instance_;

  DSRT_Helper(void);

};

#endif /* CC_DSRT_HELPER_H */
