/******************************************************************************
*                                                                             *
*  File: P_Timer.cpp                                                          *
*                                                                             *
*  Description: Timer clock for peformance measurement                        *
*                                                                             *
*  Project: 2K - Resource management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: P_Timer.cpp,v $
 Revision 1.1  2000/02/19 20:31:51  yamane
 Initial version


******************************************************************************/

#if !defined (P_TIMER_CC)
#define P_TIMER_CC

#include "P_Timer.h"
#include <stdio.h>

P_Timer::P_Timer(void)
{
}

P_Timer::P_Timer(P_Timer&)
{
}

P_Timer::~P_Timer()
{
}

void
P_Timer::start()
{
  struct timezone tz;
  gettimeofday(&start_time_, &tz);
}

void
P_Timer::stop()
{
  struct timezone tz;
  gettimeofday(&stop_time_, &tz);
}

void
P_Timer::print()
{
  timeval d;

  if (stop_time_.tv_usec > start_time_.tv_usec) {
	d.tv_usec = stop_time_.tv_usec - start_time_.tv_usec;
	d.tv_sec = stop_time_.tv_sec - start_time_.tv_sec;
  } else {
	d.tv_usec = stop_time_.tv_usec + 1000000 - start_time_.tv_usec;
	d.tv_sec = stop_time_.tv_sec - start_time_.tv_sec -1;
  }

  print_tv("start", &start_time_);
  print_tv("stop", &stop_time_);
  print_tv("total", &d);
}

void
P_Timer::print_tv(char *s, timeval *tv)
{
	printf ("%s sec = %d usec = %d\n", s, tv->tv_sec, tv->tv_usec);
}

#endif /* P_TIMER_CC */
