/******************************************************************************
*                                                                             *
*  File: P_Timer.h                                                            *
*                                                                             *
*  Description: Timer clock for peformance measurement                        *
*                                                                             *
*  Project: 2K - Resource management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: P_Timer.h,v $
 Revision 1.1  2000/02/19 20:31:51  yamane
 Initial version


******************************************************************************/

#if !defined (P_TIMER_H)
#define P_TIMER_H

#include "sys/time.h"
#include "unistd.h"

class P_Timer
{
public:
  P_Timer(void);
  // constructor

  P_Timer(P_Timer &);
  // constructor

  ~P_Timer();

  void start(void);

  void stop(void);

  void print(void);

private:
  void print_tv(char *msg, timeval *value);

  timeval start_time_;
  timeval stop_time_;
};

#endif /* P_TIMER_H */
