/******************************************************************************
*                                                                             *
*  File: server.cpp                                                           *
*                                                                             *
*  Description: A test server for the Lrm object.                             *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Resource Management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: server.cpp,v $
 Revision 1.1  2000/02/20 06:53:37  yamane
 Initial version

 Revision 1.1.1.1  1999/08/30 04:41:29  col
 Initial check-in

 Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/22 22:29:16  f-kon
 *** empty log message ***

******************************************************************************/

#include "Lrm_server_i.h"

// char bbb[10000];

int main (int argc, char *argv[]) {
//  char *p = (char *)malloc(10000);
//  char aaa[10000];

//  aaa[0] = 0;

//  ACE_OS::printf("p = 0x%08x\n", p);
//  ACE_OS::printf("bbb = 0x%08x\n", bbb);

  LrmServer LrmServ;

  ACE_DEBUG((LM_DEBUG, "\n\tLrm:SERVER\n\n"));
  ACE_TRY_NEW_ENV {
    if (LrmServ.init(argc, argv, ACE_TRY_ENV) == -1) {
      ACE_TRY_CHECK;
      return 1;
    }
    else {
      LrmServ.run(ACE_TRY_ENV);
      ACE_TRY_CHECK;
    }
  }
  ACE_CATCH (CORBA::SystemException, sysex) {
    ACE_UNUSED_ARG (sysex);
    ACE_TRY_ENV.print_exception ("System Exception");
    return -1;
  }
  ACE_CATCH (CORBA::UserException, userex) {
    ACE_UNUSED_ARG (userex);
    ACE_TRY_ENV.print_exception ("User Exception");
    return -1;
  }
  ACE_ENDTRY;
  return 0;
}
