/* 
 * Released Date: March 7 99
 * This is the Dynamic Soft CPU Scheduler II release by the 
 *   Monet Group, 
 *   http://cairo.cs.uiuc.edu/
 *   Department of Computer Science, 
 *   University of Illinois at Urbana Champaign.  
 * 
 * This release has been tested under SUN OS 5.6.
 *
 * Contacting Authors:
 *  Hao-hua Chu (h-chu3@cs.uiuc.edu)
 *  Klara Nahrstedt (klara@cs.uiuc.edu)
 */

#ifndef CPU_RESERVE_H
#define CPU_RESERVE_H

#include "Timeval.H"

#define CPU_RT_PCPT 0
#define CPU_RT_PVPT 1
#define CPU_RT_ACPU 2
#define CPU_RT_EVENT 3
#define CPU_RT_PCCPT 4

#define ADAPT_NONE 0
#define ADAPT_EXPO 1
#define ADAPT_EXPO_UP 2
#define ADAPT_EXPO_RANGE 3
#define ADAPT_STAT 4

typedef struct CpuReserve
{
  int serviceClass;
  int period;  // CPU_RT_PCPT, CPU_RT_PVPT, CPU_RT_PCCPT
  int peakProcessingTime;  // CPU_RT_PCPT, CPU_RT_PVPT, CPU_RT_PCCPT
  int sustainableProcessingTime;  // CPU_RT_PVPT
  int burstTolerance;      // CPU_RT_PVPT
  float peakProcessingUtil;  // CPU_RT_ACPU
} CpuReserve;


typedef struct AdaptStrategy
{
  int strategy;
  int windowSize;
  float alpha;
  float max;
  float min;
  float nonconformFreq;
} AdaptStrategy;




#endif CPU_RESERVE_H
