#ifndef LEAKING_BUCKET_H
#define LEAKING_BUCKET_H

#include "MathUtil.H"

#define ALLOW_LB_OVERFLOW 0

class LeakingBucket {
private:
  int _level;
  int _depth;
  int _leak;

public:
  LeakingBucket() { _level = 0; _depth = 0; _leak = 0; };
  void init(int leak, int depth)
    { _level = 0; _depth = depth; _leak = leak; };
  void setLeak(int leak) { _leak = leak; };
  void setDepth(int depth) { _depth = depth; };
  void empty() { _level = 0; };
  void fill(int elapse) { 
    _level += elapse; 
    if (ALLOW_LB_OVERFLOW == 0)
      _level = min(_level, _depth);
  }
  int isNonconform() { if (_level >= _depth) return(1); else return(0); };
  void flush() { _level = max(0, _level - _leak); };
  int isEmpty() { return(_level==0); };
  void print() { printf("(level=%d, depth=%d, leak=%d)", _level, _depth, _leak); }
};


#endif LEAKING_BUCKET_H
