/* 
 * Released Date: March 7 99
 * This is the Dynamic Soft CPU Scheduler II release by the 
 *   Monet Group, 
 *   http://cairo.cs.uiuc.edu/
 *   Department of Computer Science, 
 *   University of Illinois at Urbana Champaign.  
 * 
 * This release has been tested under SUN OS 5.6.
 *
 * Contacting Authors:
 *  Hao-hua Chu (h-chu3@cs.uiuc.edu)
 *  Klara Nahrstedt (klara@cs.uiuc.edu)
 */

#ifndef MATH_UTIL_H
#define MATH_UTIL_H

static int intcompare(const void* a, const void* b)
{
  int i1 = *(int*)a;
  int i2 = *(int*)b;
  if (i1 > i2)
    return (1);
  if (i1 < i2)
    return (-1);
  return (0);
}

inline int max(int i1, int i2) 
{
    if (i1 > i2)
	return(i1);
    else
	return(i2);
};

inline int min(int i1, int i2)
{
    if (i1 < i2)
	return(i1);
    else
	return(i2);
}

static int floatcompare(const void* a, const void* b)
{
  float f1 = *(float*)a;
  float f2 = *(float*)b;
  if (f1 > f2)
    return (1);
  if (f1 < f2)
    return (-1);
  return (0);
}

inline float max(float i1, float i2) 
{
    if (i1 > i2)
	return(i1);
    else
	return(i2);
};

inline float min(float i1, float i2)
{
    if (i1 < i2)
	return(i1);
    else
	return(i2);
}


#endif MATH_UTIL_H
