/* 
 * Released Date: March 7 99
 * This is the Dynamic Soft CPU Scheduler II release by the 
 *   Monet Group, 
 *   http://cairo.cs.uiuc.edu/
 *   Department of Computer Science, 
 *   University of Illinois at Urbana Champaign.  
 * 
 * This release has been tested under SUN OS 5.6.
 *
 * Contacting Authors:
 *  Hao-hua Chu (h-chu3@cs.uiuc.edu)
 *  Klara Nahrstedt (klara@cs.uiuc.edu)
 */

#ifndef SCHED_STATS_BUF_H
#define SCHED_STATS_BUF_H

#include <stdio.h>
#include "Def.H"

class SchedStatsBuf
{
private:
  SchedStats* _buf;
  int _idx;
  int _size;
  FILE* _fd;
  timeval _begin;
  void _writeToFile();
public:
  SchedStatsBuf(int size, char* fname = NULL);
  ~SchedStatsBuf();
  inline void reset() { _writeToFile(); _idx = 0; };
  SchedStats* getLast() { if (_idx == 0) return(&_buf[_size]); else return(&_buf[_idx-1]); }; 
  int update(SchedStats* ss);
};


#endif SCHED_STATS_BUF_H
