#ifndef _SHM_H
#define _SHM_H

#include "Def.H"
#include "ProcStatsBuf.H"

#define SHM_NAME "/tmp/srt.shm"

typedef struct ShmArea {
  Process pArray[MAX_PROCESS];
  int pArrayFlag[MAX_PROCESS];
  SchedStats schedStats;        // read-only by process
} ShmArea;


class Shm {
protected:
  ShmArea* _area;
    
public:
  Shm() {};
  SchedStats* getSchedStats() { return(&(_area->schedStats)); };
  Process* getProcessWithIdx(int idx) {
    if (idx >= 0 && idx < MAX_PROCESS && _area->pArrayFlag[idx])
      return(&(_area->pArray[idx]));
    else
      return(NULL);
  };
  Process* getProcessWithPid(int pid) {
    for (int i=0; i<MAX_PROCESS; i++)
      if (_area->pArrayFlag[i] && 
	  _area->pArray[i].pid == pid)
	return(&(_area->pArray[i]));
    return(NULL);
  }
  static void makeShmFname(char* fname, int pid);
  ShmArea* getArea() { return(_area); };
};


class ShmCli : public Shm {
private:
  WrShmArea* _wrShmArea;
    
public:
  ShmCli() {};
  Process* attach(int pid, int idx);
  void detach();
  WrShmArea* getWrShmArea() { return(_wrShmArea); };
};



class ShmSvc :  public Shm {
private:
  int _free;

public:
  ShmSvc() {};
  int init();
  void destroy();
  Process* allocProcess(int pid);
  void freeProcess(int idx);
  static int setWrShmAreaPcred(Process* p);
};

#endif _SHM_H
