/* 
 * Released Date: March 7 99
 * This is the Dynamic Soft CPU Scheduler II release by the 
 *   Monet Group, 
 *   http://cairo.cs.uiuc.edu/
 *   Department of Computer Science, 
 *   University of Illinois at Urbana Champaign.  
 * 
 * This release has been tested under SUN OS 5.6.
 *
 * Contacting Authors:
 *  Hao-hua Chu (h-chu3@cs.uiuc.edu)
 *  Klara Nahrstedt (klara@cs.uiuc.edu)
 */

#include <stdio.h>
#include "Def.H"
#include "CpuServiceClass.H"


void msgPrint(Msg* msg)
{
  printf("Msg: mtype=%d, callerPid=%d, cmd=%s, idx=%d, res=%d, intArg=%d,%d, ",
	 msg->mtype, msg->callerPid, cmdToString(msg->cmd), msg->idx, msg->res,
	 msg->intArg[0], msg->intArg[1], msg->intArg[2]);
  switch (msg->cmd)
    {
    case CMD_RESERVE: 
    case CMD_IRESERVE: 
    case CMD_MODIFY: 
    case CMD_IMODIFY:
      CpuServiceClass::print(&(msg->cr));
      break;
    case CMD_SET_ADAPT_STRATEGY:
    case CMD_ISET_ADAPT_STRATEGY:
      CpuServiceClass::print(&(msg->as));
      break;
    }
  printf("\n");
}


void processPrint(Process* p) 
{
  printf("idx=%2d, pid=%6d, state=%7s, ",
	 p->idx, p->pid, pstateToString(p->state));
  CpuServiceClass::print(&(p->cpuReserve));
  printf("\n");
  printf("probeFlag=%d, overrunFlag=%d, nonconformFlag=%d, yieldFlag=%d\n",
	 p->probeFlag, p->overrunFlag, p->nonconformFlag, p->yieldFlag);
  printf("resetContSemFlag=%d\n",
	 p->resetContSemFlag); 
  printf("overrunItr=%2d, guaranteed=%d, usage=%d, deadline=%2d:%6d, \n",
	 p->overrunItr, p->guaranteed, p->usage, (p->deadline.tv_sec)%100, p->deadline.tv_usec);
  CpuServiceClass::print(&(p->adaptStrategy));
  printf("\n");
}
