// -*- C++ -*-

#ifndef GRMEXT_I_H
#define GRMEXT_I_H

#include "orbsvcs/ResourceMgmtS.h"
#include "orbsvcs/ResourceMgmtC.h"

// Ia tentar utilizar o bd compartilhado, mas
// talvez seja melhor manter separado o do GrmExt
//#include "SharedProp_Database.h"

#include "Trader_Utils.h"

class GrmExt_i;

#include "Trader_T.h"

class GrmExt_i : public POA_ResourceMgmt::GrmExt {
public:
  GrmExt_i(CORBA::ORB_ptr o);

  ~GrmExt_i(void);

  virtual void test(const char *str,
		    CORBA::Environment &ACE_TRY_ENV);

  virtual void register_parent(const ResourceMgmt::GrmExt_ptr parent, 
			       CORBA::Environment &ACE_TRY_ENV);

  virtual CosTrading::OfferId register_sibling_grm(const ResourceMgmt::Grm_ptr sib,
						   const CosTrading::PropertySeq &props,
						   const CORBA::ULong_out id_prop,
						   CORBA::Environment &ACE_TRY_ENV);

  virtual void register_sibling(const ResourceMgmt::GrmExt_ptr sib,
				CORBA::Environment &ACE_TRY_ENV);

  virtual void search(ResourceMgmt::QueryPacket &query_pkt,
		      CORBA::Environment &ACE_TRY_ENV);

  virtual void update_props(const char *id,
			    const CosTrading::PropertySeq &modify_list,
			    CORBA::Environment &ACE_TRY_ENV);

private:
  CORBA::Environment env;

  // MOD
  ResourceMgmt::GrmExt_var parent;

  // Recursos disponiveis em seus filhos
  CosTrading::PropertySeq resources;

  CORBA::ORB_ptr orb;

  CosTrading::Lookup_ptr lookup_if;

  CosTrading::Register_ptr regis;

  CosTradingRepos::ServiceTypeRepository_var repos;

  CORBA::ULong id_prop; // id deste GRM no seu pai

  CORBA::ULong level_; // nivel deste GRM na arvore

  CosTrading::OfferId_var offer_id;

  int son_is_grm;

  CORBA::ULong num_sons;

  CORBA::ULong max_sons_;

  static const CORBA::ULong NUM_STANDARD_PROPS;
  static const char *standard_props[];
  CORBA::ULong average_values[9];

  virtual void init_trader(CORBA::ORB_ptr orb);

  CORBA::ULong GrmExt_i::get_next_level_ids(const ResourceMgmt::IdSeq &ids,
					    CORBA::ULong ids_next_level[],
					    CORBA::Environment &ACE_TRY_ENV);
  // FIM-MOD

};

#if defined (ACE_TEMPLATES_REQUIRE_SOURCE)
#include "GrmExt_i.cpp"
#endif /* ACE_TEMPLATES_REQUIRE_SOURCE */

#endif /* GRMEXT_I_H */


