// ========================================================================
// $Id: Grm_i.cpp,v 1.2 2000/02/20 08:48:49 yamane Exp $
//
// = LIBRARY
//    orbsvcs
//
// = FILENAME
//    Grm_i.cpp 
//
// = AUTHOR
//    Tomonori Yamane <yamane@cs.uiuc.edu>
//
// ========================================================================

#if !defined (GRM_I_C)
#define GRM_I_C

#include "Grm_i.h"

ACE_RCSID(Grm, Grm_i, "$Id: Grm_i.cpp,v 1.2 2000/02/20 08:48:49 yamane Exp $")

// Constructor

template <class TRADER_LOCK_TYPE, class MAP_LOCK_TYPE>
Grm_i<TRADER_LOCK_TYPE, MAP_LOCK_TYPE>::
Grm_i (TAO_Trader<TRADER_LOCK_TYPE, MAP_LOCK_TYPE> &trader)
  : trader_(trader), shared_db_ (trader_.sharedprop_database ()) {
  ACE_OS::printf("Grm_i constructed\n"); // teste
}

// Destructor

template <class TRADER_LOCK_TYPE, class MAP_LOCK_TYPE>
Grm_i<TRADER_LOCK_TYPE, MAP_LOCK_TYPE>::
~Grm_i (void) {
  // no-op
}


// MOD
template <class TRADER_LOCK_TYPE, class MAP_LOCK_TYPE>
void
Grm_i<TRADER_LOCK_TYPE, MAP_LOCK_TYPE>::
setParent(const ResourceMgmt::GrmExt_ptr grmExt,
	  CORBA::Environment &ACE_TRY_ENV) {
  //  ACE_UNUSED_ARG(ACE_TRY_ENV);
  ACE_OS::printf("Grm_i::setParent()\n");
  grmExt_parent = ResourceMgmt::GrmExt::_duplicate(grmExt);

  ACE_TRY {
    grmExt_parent->test("aaa", ACE_TRY_ENV);

//    CORBA::ORB_var orb;
//
//    CORBA::Object_var obj = orb->string_to_object("file:///tmp/IOR_GrmExt");
//    if (CORBA::is_nil(obj)) {
//      cerr << "Grm_i::setParent(): obj is null" << endl;
//    }
//    ResourceMgmt::GrmExt_var grmExt = ResourceMgmt::GrmExt::_narrow(obj);
//    grmExt->test("aaa", ACE_TRY_ENV);

    ACE_TRY_CHECK;
  } ACE_CATCHANY {
    ACE_TRY_ENV.print_exception("Exception in Grm_i::setParent()");
  } ACE_ENDTRY;
}
// FIM-MOD


template <class TRADER_LOCK_TYPE, class MAP_LOCK_TYPE>
void
Grm_i<TRADER_LOCK_TYPE, MAP_LOCK_TYPE>::
perform_query(const ResourceMgmt::QueryPacket& req, CORBA::Environment &ACE_TRY_ENV) {

// Find the candidate
//
//	servvice	"Lrm"
//      constraint ------ p.constr && p.visited
//      preferences ----- p.pref
//        in_policies ------ p.policies
//        desired_prop ----- p.desired
//        how_many    ------ 1
//        return_offers
//        return_offer_iterator
//        policyname_seq_out
//
//

//
//	Currently we cannot use federation of Trader to create new process
//
//
//
  ACE_OS::printf("Grm_i<>::perform_query()\n");
  ACE_OS::printf("Grm_i::eval_constraint()\n");
  ACE_OS::printf("---------- constr  = %s\n", req.constr.in());
  ACE_OS::printf("---------- pref  = %s\n", req.pref.in());
  ACE_OS::printf("---------- visited = %s\n", req.visited.in());
 
  //
  //	Merge user constraint and visited constraint
  //
  int constr_len = ACE_OS::strlen(req.constr.in());

  int total_len;
  if (constr_len == 0) {
    total_len = ACE_OS::strlen(req.visited.in()) + 1;
  } else {
    total_len = constr_len
      + ACE_OS::strlen(req.visited.in())
      + ACE_OS::strlen("() and ()")
      + 1;
  }

  CORBA::String_var combined_constr = CORBA::string_alloc(total_len);

  if (constr_len == 0) {
    strcpy(combined_constr.inout(), req.visited.in());
  } else {
    ACE_OS::sprintf(combined_constr.inout(),
		    "(%s) and (%s)",
		    req.visited.in(),
		    req.constr.in());
  }

  ACE_OS::printf("------- combined_constr = %s\n", combined_constr.in()); // teste

  // execute query to find Lrm

  ResourceMgmt::Lrm_var lrm_;

  CosTrading::Lookup_ptr lookup_if = this->trader_.trading_components().lookup_if();

  CosTrading::Register_ptr register_if = this->trader_.trading_components().register_if();

  CosTrading::PolicySeq policies; // Empty sequence
  CosTrading::Lookup::SpecifiedProps desired_props; // return hostname
  CosTrading::PropertyNameSeq name_seq;

  //        desired_props._d(CosTrading::Lookup::none);
  desired_props._d(CosTrading::Lookup::some);
  name_seq.length(1);
  name_seq[0] = CORBA::string_dup("hostname");
  desired_props.prop_names(name_seq);

  CosTrading::PolicyNameSeq_var   policies_applied; // out param
  CosTrading::OfferSeq_var        offers;           // out param
  CosTrading::OfferIterator_var   iterator;         // out param

 retry_query:

  ACE_OS::printf("query start\n"); // teste

  ACE_TRY {
    // Run query
    lookup_if->query("ResourceMgmt_Lrm",
		     combined_constr.in(),
		     req.pref.in(),
		     policies,
		     desired_props,
		     1,
		     offers,
		     iterator,
		     policies_applied,
		     ACE_TRY_ENV);
    ACE_OS::printf("perform_query() query returned\n"); // teste
    ACE_TRY_CHECK;
    ACE_OS::printf("query returned without exception\n"); // teste
  }
  ACE_CATCH (CosTrading::IllegalConstraint, ill_constr) {
    // If we fail to the constraint, just return False
    ACE_UNUSED_ARG (ill_constr);
    ACE_OS::printf("perform_query() IllegalConstraint\n");
    ACE_TRY_ENV.print_exception ("IllegalConstraint Exception");
    ACE_TRY_ENV.clear();

    lrm_ = req.sender.in();
    lrm_->NACK(req.sem_tag, ACE_TRY_ENV);
  }
  ACE_CATCH (CosTrading::Lookup::IllegalPreference, ill_pref) {
    ACE_UNUSED_ARG (ill_pref);
    ACE_OS::printf("perform_query() Lookup::IllegalPreference\n");
    ACE_TRY_ENV.print_exception ("Lookup::IllegalPreference Exception");
    exit(1);
  }
  ACE_CATCH (CosTrading::Lookup::IllegalPolicyName, ill_poly) {
    ACE_UNUSED_ARG (ill_poly);
    ACE_OS::printf("perform_query() Lookup::IllegalPolicyName\n");
    ACE_TRY_ENV.print_exception ("Lookup::IllegalPolicyName Exception");
    exit(1);
  }
  ACE_CATCH (CosTrading::Lookup::PolicyTypeMismatch, mismatch_poly) {
    ACE_UNUSED_ARG (mismatch_poly);
    ACE_OS::printf("perform_query() Lookup::PolicyTypeMismatch\n");
    ACE_TRY_ENV.print_exception ("Lookup::PolicyTypeMismatch Exception");
    exit(1);
  }
  ACE_CATCH (CosTrading::Lookup::InvalidPolicyValue, invalid_poly) {
    ACE_UNUSED_ARG (invalid_poly);
    ACE_OS::printf("perform_query() Lookup::InvalidPolicyValue\n");
    ACE_TRY_ENV.print_exception ("Lookup::InvalidPolicyValue Exception");
    exit(1);
  }
  ACE_CATCH (CosTrading::IllegalPropertyName, ill_property) {
    ACE_UNUSED_ARG (ill_property);
    ACE_OS::printf("perform_query() IllegalPropertyName\n");
    ACE_TRY_ENV.print_exception ("IllegalPropertyName Exception");
    ACE_TRY_ENV.clear();

    lrm_ = req.sender.in();
    lrm_->NACK(req.sem_tag, ACE_TRY_ENV);
  }
  ACE_CATCH (CosTrading::DuplicatePropertyName, dup_property) {
    ACE_UNUSED_ARG (dup_property);
    ACE_OS::printf("perform_query() DuplicatePropertyName\n");
    ACE_TRY_ENV.print_exception ("DuplicatePropertyName Exception");
    ACE_TRY_ENV.clear();
    
    lrm_ = req.sender.in();
    lrm_->NACK(req.sem_tag, ACE_TRY_ENV);
  }
  ACE_CATCH (CosTrading::DuplicatePolicyName, dup_policy) {
    ACE_UNUSED_ARG (dup_policy);
    ACE_OS::printf("perform_query() DuplicatePolicyName\n");
    ACE_TRY_ENV.print_exception ("DuplicatePolicyName Exception");
    exit(1);
  }
  ACE_CATCH(CORBA::SystemException, sysex) {
    ACE_UNUSED_ARG(sysex);
    ACE_OS::printf("perform_query() SystemException()\n");
    ACE_TRY_ENV.print_exception("System Exception");
    
    exit(1);
  }
  ACE_CATCH(CORBA::UserException, userex) {
    ACE_UNUSED_ARG(userex);
    ACE_OS::printf("perform_query() UserException\n");
    ACE_TRY_ENV.print_exception("User Exception");
    exit(1);
  }
  ACE_ENDTRY;

  ACE_TRY_EX(CHECK_AVAILABLE) {
    // Clean up iterator
    if (!CORBA::is_nil(iterator.ptr())) {
      iterator->destroy();
    }

    if (offers->length() == 0) {
      // MOD
      ACE_OS::printf("No matching Lrm in this cluster.\n"); // teste
      // procura no GrmExt pai.
      // e' preciso manipular o conteudo da requisicao antes de manda-la
      // para ele. Retirar os nomes dos LRMs da lista, por exemplo
      grmExt_parent->test("*******************", ACE_TRY_ENV);
      ResourceMgmt::QueryPacket copy_query = req;
      grmExt_parent->search(copt_query, ACE_TRY_ENV);
      // FIM-MOD

 
      // nao achou em nenhum lugar
      ACE_OS::printf("No matching Lrm\n"); // teste
      lrm_ = ResourceMgmt::Lrm::_duplicate(req.sender.in());
      lrm_->NACK(req.sem_tag, ACE_TRY_ENV);
      ACE_TRY_CHECK_EX(CHECK_AVAILABLE);
      return;
    }

    /* ORIGINAL
    if (offers->length() == 0) {
      ACE_OS::printf("No matching Lrm\n"); // teste
      lrm_ = ResourceMgmt::Lrm::_duplicate(req.sender.in());
      lrm_->NACK(req.sem_tag, ACE_TRY_ENV);
      ACE_TRY_CHECK_EX(CHECK_AVAILABLE);
      return;
    }
    */
  }
  ACE_CATCH(CORBA::SystemException, sysex2) {
    ACE_UNUSED_ARG(sysex2);
    ACE_OS::printf("perform_query() check_available SystemException()\n");
    ACE_TRY_ENV.print_exception("System Exception");

    exit(1);
  }
  ACE_CATCH(CORBA::UserException, userex2) {
    ACE_UNUSED_ARG(userex2);
    ACE_OS::printf("perform_query() check_available UserException\n");
    ACE_TRY_ENV.print_exception("User Exception");
    exit(1);
  }
  ACE_ENDTRY;


  // extract  hostname for error handling
  char *host;
  offers[0].properties[0].value >>= host;

  ACE_OS::printf("matched host is %s\n", host); // teste

  char withdraw_constraint[1024];
  ACE_OS::sprintf(withdraw_constraint, "hostname == '%s'", host);

  //
  // Contact to the candidate Lrm
  // If it fails, drop the offer from the databse
  // and try query again
  //
  ACE_TRY_EX(FORWARDING) {
    lrm_ = ResourceMgmt::Lrm::_narrow(offers[0].reference.in(), ACE_TRY_ENV);
    ACE_TRY_CHECK_EX(FORWARDING);
    
    if (CORBA::is_nil(lrm_.in())) {
      ACE_OS::printf("Candidate cannot be narrowed\n");
    } else {
      ACE_OS::printf("We found candidate.\n"); // teste

      lrm_->perform_query(req, ACE_TRY_ENV);
      ACE_TRY_CHECK_EX(FORWARDING);
      ACE_OS::printf("Request forwarded to Lrm\n"); // teste
    }
  }
  ACE_CATCH(CORBA::SystemException, sysex3) {
    ACE_UNUSED_ARG(sysex3);
    ACE_OS::printf("perform_query() forwarding SystemException()\n");
    ACE_TRY_ENV.print_exception("System Exception");
    
    ACE_TRY_ENV.clear();

    register_if->withdraw_using_constraint("ResourceMgmt_Lrm",
					   withdraw_constraint,
					   ACE_TRY_ENV);

    ACE_TRY_ENV.clear();

    goto retry_query;
  }
  ACE_CATCH(CORBA::UserException, userex3) {
    ACE_UNUSED_ARG(userex3);
    ACE_OS::printf("perform_query() forwarding UserException\n");
    ACE_TRY_ENV.print_exception("User Exception");
    
    ACE_TRY_ENV.clear();

    register_if->withdraw_using_constraint("ResourceMgmt_Lrm",
					   withdraw_constraint,
					   ACE_TRY_ENV);
    
    ACE_TRY_ENV.clear();
    
    goto retry_query;
  }
  ACE_ENDTRY;
}

// MOD
template <class TRADER_LOCK_TYPE, class MAP_LOCK_TYPE>
void
Grm_i<TRADER_LOCK_TYPE, MAP_LOCK_TYPE>::
send_update(CORBA::Environment &ACE_TRY_ENV) {
  CosTrading::Lookup_ptr lookup_if = this->trader_.trading_components().lookup_if();

  CosTrading::PolicySeq policies; // Empty sequence
  CosTrading::Lookup::SpecifiedProps desired_props;
  CosTrading::PropertyNameSeq name_seq;

  desired_props._d(CosTrading::Lookup::all);
  name_seq.length(1);
  name_seq[0] = CORBA::string_dup("hostname");
  desired_props.prop_names(name_seq);

  CosTrading::PolicyNameSeq_var   policies_applied; // out param
  CosTrading::OfferSeq_var        offers;           // out param
  CosTrading::OfferIterator_var   iterator;         // out param

  ACE_TRY {
    lookup_if->query("ResourceMgmt_Lrm",
		     "TRUE",
		     "",
		     policies,
		     desired_props,
		     0,
		     offers,
		     iterator,
		     policies_applied,
		     ACE_TRY_ENV);
    ACE_OS::printf("Grm_i::send_update: query returned\n"); // teste
    ACE_TRY_CHECK;
    ACE_OS::printf("Grm_i::send_update: query returned without exception\n"); // teste
  }
  ACE_CATCH (CosTrading::Lookup::IllegalPreference, ill_pref) {
    ACE_UNUSED_ARG (ill_pref);
    ACE_OS::printf("perform_query() Lookup::IllegalPreference\n");
    ACE_TRY_ENV.print_exception ("Lookup::IllegalPreference Exception");
  }
  ACE_CATCH (CosTrading::Lookup::IllegalPolicyName, ill_poly) {
    ACE_UNUSED_ARG (ill_poly);
    ACE_OS::printf("perform_query() Lookup::IllegalPolicyName\n");
    ACE_TRY_ENV.print_exception ("Lookup::IllegalPolicyName Exception");
  }
  ACE_CATCH (CosTrading::Lookup::PolicyTypeMismatch, mismatch_poly) {
    ACE_UNUSED_ARG (mismatch_poly);
    ACE_OS::printf("perform_query() Lookup::PolicyTypeMismatch\n");
    ACE_TRY_ENV.print_exception ("Lookup::PolicyTypeMismatch Exception");
  }
  ACE_CATCH (CosTrading::Lookup::InvalidPolicyValue, invalid_poly) {
    ACE_UNUSED_ARG (invalid_poly);
    ACE_OS::printf("perform_query() Lookup::InvalidPolicyValue\n");
    ACE_TRY_ENV.print_exception ("Lookup::InvalidPolicyValue Exception");
  }
  ACE_CATCH (CosTrading::IllegalPropertyName, ill_property) {
    ACE_UNUSED_ARG (ill_property);
    ACE_OS::printf("perform_query() IllegalPropertyName\n");
    ACE_TRY_ENV.print_exception ("IllegalPropertyName Exception");
  }
  ACE_CATCH (CosTrading::DuplicatePropertyName, dup_property) {
    ACE_UNUSED_ARG (dup_property);
    ACE_OS::printf("perform_query() DuplicatePropertyName\n");
    ACE_TRY_ENV.print_exception ("DuplicatePropertyName Exception");
  }
  ACE_CATCH (CosTrading::DuplicatePolicyName, dup_policy) {
    ACE_UNUSED_ARG (dup_policy);
    ACE_OS::printf("perform_query() DuplicatePolicyName\n");
    ACE_TRY_ENV.print_exception ("DuplicatePolicyName Exception");
  }
  ACE_CATCH(CORBA::SystemException, sysex) {
    ACE_UNUSED_ARG(sysex);
    ACE_OS::printf("perform_query() SystemException()\n");
    ACE_TRY_ENV.print_exception("System Exception");
  }
  ACE_CATCH(CORBA::UserException, userex) {
    ACE_UNUSED_ARG(userex);
    ACE_OS::printf("perform_query() UserException\n");
    ACE_TRY_ENV.print_exception("User Exception");
  }
  ACE_ENDTRY;

  // teste
  for (CORBA::ULong i = 0; i < offers->length(); i++) {
    //    CORBA::Any::dump(offers[i].value);
    ACE_OS::printf("\n");
  }
  // fim-teste
}

#endif /* GRM_I_C */

