/******************************************************************************
*                                                                             *
*  File: Lrm_client_i.h                                                       *
*                                                                             *
*  Description: A test client for the Resource Management                     *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Resource Management                                          *
*  Author: Tomonori Yamane (yamane@uiuc.edu)                                  *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1 $
 $Log: Lrm_client_i.h,v $
 Revision 1.1  2000/02/19 20:55:55  yamane
 Initial version

 Revision 1.1.1.2  1999/09/07 13:12:48  col
 *** empty log message ***

 Revision 1.1.1.1  1999/08/30 04:41:29  col
 Initial check-in

 Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/22 22:29:15  f-kon
 *** empty log message ***


******************************************************************************/
#ifndef LRM_CLIENT_I_H
#define LRM_CLIENT_I_H

#include "ace/Get_Opt.h"
#include "tao/corba.h"
#include "orbsvcs/CosNamingS.h"
#include "orbsvcs/CosNamingC.h"
#include "orbsvcs/Naming/Naming_Utils.h"

#include "orbsvcs/ResourceMgmtC.h"

class LrmClient
{
public:
  // = Constructor and destructor.
  LrmClient (void);
  ~LrmClient (void);

  void run(const char *comp_name);
  // Execute client example code.

  CORBA::Object_ptr direct_search(const char *service_id);
 
  int init (int argc, char **argv);
  // Initialize the client communication endpoint with server.

  void fini ();
  // Shuts down the local ORB.

private:
  int parse_args (void);
  // Parses the arguments passed on the command line.

  void kill_newComponents (const char *host, CosNaming::NamingContext *inc);
  // kill registered newComponents.

  void dump_ComponentsList(CORBA::Any& a);
  // List up available components

  int hang_flag;
  // terminate all newComponents

    void test_simpleQuery(const char *comp_name);
  // Test program for Lrm.

  int argc_;
  // # of arguments on the command line.

  char **argv_;
  // arguments from command line.

  char *Lrm_key_;
  // Key of hello obj ref.

  ResourceMgmt::Lrm_var Lrm_;
  // hello pointer.

  CORBA::Environment env_;
  // Environment variable.

  CORBA::ORB_var orb_;
  // Remember our orb.

};

#endif
