/******************************************************************************
*                                                                             *
*  File: NSBroker.h                                                           *
*                                                                             *
*  Description: Facilitates access to the name server.                        *
*                                                                             *
*  Project: 2K                                                                *
*  Author: Christopher Hess (ckhess@cs.uiuc.edu)                              *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.5 $
   $Log: NSBroker.h,v $
   Revision 1.5  2000/10/09 21:02:41  f-kon
   Changes to use new TwoK:: namespace for 2K services integrated with Tomo's
   changes for Windows compilation.

   Revision 1.4  2000/02/28 22:15:52  f-kon
   *** empty log message ***

   Revision 1.3  2000/02/16 18:06:46  ckhess
   Return _ptr instead of _var on resolve.

******************************************************************************/

#ifndef _NS_BROKER_H_
#define _NS_BROKER_H_

#include "tao/TAO.h"
#include "orbsvcs/orbsvcs/CosNamingC.h"
#include "dynamicTAO/src/ace/ACE_2K_OS.h"

/*
 * Class to manage access to the name server.
 */
class DynamicTAO_Export NSBroker {
 private:
  CosNaming::NamingContext_ptr _rootContext;
  
 public:
  NSBroker ();

  int init(CORBA::ORB_var orb);
  int createChainOfContexts(CosNaming::Name &name);
  int bind(CosNaming::Name &name, CORBA::Object_ptr obj);
  int unbind(CosNaming::Name &name);
  CORBA::Object_ptr resolve(CosNaming::Name &name);

  CosNaming::NamingContext_ptr getRootContext ();
};

#endif  // _NS_BROKER_H_
