/******************************************************************************
*                                                                             *
*  File: LoadableHello.cpp                                                    *
*                                                                             *
*  Description: An implementation of hello that can be dynamically loaded.    *
*                                                                             *
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.4 $

   $Log: LoadableHello.cpp,v $
   Revision 1.4  2000/10/09 21:02:50  f-kon
   Changes to use new TwoK:: namespace for 2K services integrated with Tomo's
   changes for Windows compilation.

   Revision 1.3  2000/09/30 18:45:55  yamane
   Patches for Windows

   Revision 1.2  2000/01/24 15:56:48  f-kon
   minor improvements

   Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
   Version compatible with TAO 1.0

   Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.2  1999/03/03 16:06:35  f-kon
   added configure method

   Revision 1.1  1999/02/22 22:29:14  f-kon
   *** empty log message ***

******************************************************************************/

#include "LoadableHello.h"

int LoadableHello_Factory::init (int argc, char *argv[])
{
  localConfigurator (new LockingConfigurator ("The original hello", this));
  localConfigurator ()->info ("Returns a simple hello world string");
  return 0;
}


const char *
LoadableHello_Factory::getHello ()
{
  return "Hello, World!";
}

int LoadableHello_Factory::configure (char *messageString)
{
  ACE_OS::printf("The Hello implementation <%s> received the following configuration message:"
                 "\"%s\"\n", localConfigurator ()->name (), messageString);
  return 0;
}



ACE_FACTORY_DEFINE (LOADABLE_HELLO, LoadableHello_Factory)
