/******************************************************************************
*                                                                             *
*  File: loadableHello.h                                                      *
*                                                                             *
*  Description: An implementation of hello that can be dynamically loaded.    *
*                                                                             *
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.2 $

   $Log: LoadableHello.h,v $
   Revision 1.1.1.2  2000/09/30 18:46:41  yamane
   Patches for Windows

   Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
   Version compatible with TAO 1.0

   Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.2  1999/03/03 16:06:36  f-kon
   added configure method

   Revision 1.1  1999/02/22 22:29:14  f-kon
   *** empty log message ***

******************************************************************************/

#ifndef LOADABLE_HELLO_H
#define LOADABLE_HELLO_H

#include "LoadableHello_export.h"

#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"
#include "dynamicTAO/src/ComponentConfigurator/LockingConfigurator.h"

class LOADABLE_HELLO_Export LoadableHello_Factory : public Simple_Strategy_Factory
{
public:
  virtual int init (int argc, char *argv[]);
  
  virtual const char *getHello ();
  virtual int configure (char *messageString);
};

ACE_FACTORY_DECLARE (LOADABLE_HELLO, LoadableHello_Factory)

#endif
