/******************************************************************************
*                                                                             *
*  File: loadableHello1.cpp                                                   *
*                                                                             *
*  Description: An implementation of another hello that can be dynamically    *
*               loaded.                                                       *
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.1 $

   $Log: LoadableHello1.cpp,v $
   Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
   Version compatible with TAO 1.0

   Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.2  1999/03/03 16:06:37  f-kon
   added configure method

   Revision 1.1  1999/02/22 22:29:14  f-kon
   *** empty log message ***

******************************************************************************/

#include "LoadableHello.h"

class LoadableHello1_Factory : public LoadableHello_Factory
{ 
public:
  int init (int argc, char *argv[]);
  const char *getHello ();
};

int
LoadableHello1_Factory::init (int argc, char *argv[])
{
  localConfigurator (new LockingConfigurator ("An undergroung hello", this));
  localConfigurator ()->info ("Returns an hello string to the Underworld");
  return 0;
}

const char *
LoadableHello1_Factory::getHello ()
{
  return "Hello, Underworld!";  
}

ACE_FACTORY_DEFINE (ACE, LoadableHello1_Factory)
