/******************************************************************************
*                                                                             *
*  File: LoadableHello3.cpp                                                   *
*                                                                             *
*  Description: An implementation of another hello that can be dynamically    *
*               loaded.                                                       *
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1 $

   $Log: LoadableHello3.cpp,v $
   Revision 1.1  2000/11/14 18:00:59  f-kon
   Used in experiments with components of different sizes.


******************************************************************************/

#include "LoadableHello.h"

class LoadableHello3_Factory : public LoadableHello_Factory
{ 
public:
  int init (int argc, char *argv[]);
  const char *getHello ();
};

int
LoadableHello3_Factory::init (int argc, char *argv[])
{
  localConfigurator (new LockingConfigurator ("An undergroung hello", this));
  localConfigurator ()->info ("Returns an hello string to the Underworld");
  return 0;
}

const char *
LoadableHello3_Factory::getHello ()
{
  return "Hello, Underworld!";  
}

ACE_FACTORY_DEFINE (ACE, LoadableHello3_Factory)
