/******************************************************************************
*                                                                             *
*  File: LoadableHelloComp.cpp                                                *
*                                                                             *
*  Description: An implementation of hello that can be dynamically loaded.    *
*               This component creates local and CORBA ComponentConfigurators.*
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.4 $
   $Log: LoadableHelloComp.cpp,v $
   Revision 1.4  2000/10/09 21:02:49  f-kon
   Changes to use new TwoK:: namespace for 2K services integrated with Tomo's
   changes for Windows compilation.

   Revision 1.3  2000/09/30 18:47:16  yamane
   Patches for Windows

   Revision 1.1.1.2  1999/10/17 18:36:06  yamane
   Cleanup for native exception and linux support

   Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
   Version compatible with TAO 1.0

******************************************************************************/

#include "LoadableHelloComp.h"

int
LoadableHelloComp_Factory::init (int argc, char *argv[])
{
  char * args[] = {"The componentized hello", 
                  "Returns a componentized hello world string"};

  // The following init creates local and CORBA ComponentConfigurators.
  Component_Factory::init (2, args);
  return 0;
}


const char *
LoadableHelloComp_Factory::getHello ()
{
  return "Hello, Component World!";
}

int
LoadableHelloComp_Factory::configure (char *messageString)
{
  ACE_OS::printf("The componentized Hello implementation <%s> received the following "
                 "configuration message: <%s>\n", 
                 localConfigurator ()->name (), 
                 messageString);
  return 0;
}



ACE_FACTORY_DEFINE (LOADABLE_HELLO, LoadableHelloComp_Factory)
