/******************************************************************************
*                                                                             *
*  File: LoadableHelloComp1.h                                                  *
*                                                                             *
*  Description: An implementation of hello that can be dynamically loaded.    *
*               It subclasses from Component_Factory so that it creates a     *
*               CORBA ComponentConfigurator.                                  *
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
   Revision Control Information
   $Revision: 1.1.1.2 $
   $Log: LoadableHelloComp1.h,v $
   Revision 1.1.1.2  2000/09/30 18:49:08  yamane
   Patches for Windows

   Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
   Version compatible with TAO 1.0

******************************************************************************/

#ifndef LOADABLE_HELLO_COMP_H
#define LOADABLE_HELLO_COMP_H

#include "LoadableHello_export.h"

#include "dynamicTAO/src/Components/Simple_Component_Factory.h"
//#include "dynamicTAO/src/ComponentConfigurator/LockingConfigurator.h"

class LOADABLE_HELLO_Export LoadableHelloComp1_Factory : public Simple_Component_Factory
{
public:
  virtual int init (int argc, char *argv[]);
  
  virtual const char *getHello ();
  virtual int configure (char *messageString);
};

ACE_FACTORY_DECLARE (LOADABLE_HELLO, LoadableHelloComp1_Factory)

#endif
