/******************************************************************************
*                                                                             *
*  File: loadableHello1.cpp                                                   *
*                                                                             *
*  Description: An implementation of another hello that can be dynamically    *
*               loaded.                                                       *
*                                                                             *
*  Project: 2K - dynamic reconfiguration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.2 $

   $Log: LoadableHelloDelay.cpp,v $
   Revision 1.1.1.2  2000/09/30 18:49:41  yamane
   Patches for Windows

   Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
   Version compatible with TAO 1.0

   Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.2  1999/03/03 16:06:38  f-kon
   added configure method

   Revision 1.1  1999/02/22 22:29:15  f-kon
   *** empty log message ***

******************************************************************************/

#include "LoadableHello.h"

class LOADABLE_HELLO_Export LoadableHelloDelay_Factory : public LoadableHello_Factory
{
public:
  int init (int argc, char *argv[]);
  const char *getHello ();
};

ACE_FACTORY_DECLARE (LOADABLE_HELLO, LoadableHelloDelay_Factory)

int
LoadableHelloDelay_Factory::init (int argc, char *argv[])
{
  localConfigurator (new LockingConfigurator ("A sleepy hello", this));
  localConfigurator ()->info ("Returns a hello world string after sleeping for 10s");
  return 0;
}



const char *
LoadableHelloDelay_Factory::getHello ()
{
  ACE_OS::sleep(10);
  return "Hello, World! I'm so sleepy, my 10s nap was great!";
}


ACE_FACTORY_DEFINE (LOADABLE_HELLO, LoadableHelloDelay_Factory)
