/******************************************************************************
*                                                                             *
*  File: server.cpp                                                           *
*                                                                             *
*  Description: A test server for the Hello object.                           *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1.1.2 $
 $Log: server.cpp,v $
 Revision 1.1.1.2  1999/10/15 22:21:34  yamane
 Clean up for native exception support

 Revision 1.1.1.1  1999/10/12 00:42:47  f-kon
 Version compatible with TAO 1.0

 Revision 1.1.1.1  1999/04/01 18:16:37  f-kon
 This new 2K source tree contains the most up-to-date version of ACE and TAO
 and including the dynamicTAO code as well as some 2K tests and preliminary
 versions of some of its high-level systems.


 Revision 1.1  1999/02/22 22:29:16  f-kon
 *** empty log message ***

******************************************************************************/

#include "server_i.h"

int
main (int argc, char *argv[])
{
  HelloServer helloServ;

  ACE_DEBUG ((LM_DEBUG,
              "\n\tHello:SERVER\n\n"));
  ACE_TRY_NEW_ENV
    {
      if (helloServ.init (argc, argv, ACE_TRY_ENV) == -1)
        return 1;
      else
        {
          helloServ.run (ACE_TRY_ENV);
          ACE_TRY_CHECK;
        }
    }
  ACE_CATCHANY
    {
      ACE_ANY_EXCEPTION._tao_print_exception ("Hello server raised exception.");
      return -1;
    }
  ACE_ENDTRY;
  return 0;
}
