// $Id: tao_marshal_server.h,v 1.1.1.1 1999/10/12 00:42:51 f-kon Exp $

// ============================================================================
//
// = LIBRARY
//    CORBA Marshal Tao Benchmark
//
// = FILENAME
//    tao_marshal_server.h
//
// = AUTHOR
//    Aniruddha Gokhale
//
// ============================================================================

#ifndef _TAO_MARSHAL_SERVER_H_
#define _TAO_MARSHAL_SERVER_H_

// benchmark library includes
#include "benchmark/marshal_options.h"
#include "benchmark/marshal_results.h"
#include "benchmark/marshal_proxy.h"

// implementation classes
#include "tao_marshal_impl.h"

// include Tao specific include files
#include "marshalS.h"  // generated by IDL compiler

class Tao_Marshal_Server_Proxy : public CORBA_Marshal_Proxy
{
public:
  Tao_Marshal_Server_Proxy (void);
  // constructor

  ~Tao_Marshal_Server_Proxy (void);
  // destructor

  virtual int run (CORBA_Marshal_Proxy::OPTIONS &options,
                   CORBA_Marshal_Proxy::RESULTS &results);
  // do the actual work
private:
  CORBA_ORB_ptr orb_;
  // underlying orb;

  CORBA_BOA_ptr boa_;
  // underlying boa;

  Marshal_SSI_Impl *ssi_;
  Marshal_DSI_Impl *dsi_;
  // the implementation (SSI or DSI)
};


#if defined (__ACE_INLINE__)
#include "tao_marshal_server.i"
#endif /* __ACE_INLINE__ */

#endif
