/* -*- C++ -*- */

// ******  Code generated by the The ACE ORB (TAO) IDL Compiler *******
// TAO and the TAO IDL Compiler have been developed by the Center for
// Distributed Object Computing at Washington University, St. Louis.
//
// Information about TAO is available at:
//                 http://www.cs.wustl.edu/~schmidt/TAO.html

#ifndef _TAO_IDL_COSPROPERTYSERVICEC_H_
#define _TAO_IDL_COSPROPERTYSERVICEC_H_

#include "tao/corba.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "orbsvcs_export.h"

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO TAO_ORBSVCS_Export
#if defined (TAO_EXPORT_NESTED_CLASSES)
#  if defined (TAO_EXPORT_NESTED_MACRO)
#    undef TAO_EXPORT_NESTED_MACRO
#  endif /* defined (TAO_EXPORT_NESTED_MACRO) */
#  define TAO_EXPORT_NESTED_MACRO TAO_ORBSVCS_Export
#endif /* TAO_EXPORT_NESTED_CLASSES */
#if defined(_MSC_VER)
#pragma warning(disable:4250)
#endif /* _MSC_VER */

TAO_NAMESPACE  CosPropertyService
{
  typedef char * PropertyName;
  typedef CORBA::String_var PropertyName_var;
  typedef CORBA::String_out PropertyName_out;
    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyName;

  struct TAO_ORBSVCS_Export Property
  {
    TAO_String_Manager property_name;
    CORBA::Any property_value;
  };

  class TAO_ORBSVCS_Export Property_var
  {
  public:
    Property_var (void); // default constructor
    Property_var (Property *);
    Property_var (const Property_var &); // copy constructor
    ~Property_var (void); // destructor
    
    Property_var &operator= (Property *);
    Property_var &operator= (const Property_var &);
    Property *operator-> (void);
    const Property *operator-> (void) const;
    
    operator const Property &() const;
    operator Property &();
    operator Property &() const;
    // in, inout, out, _retn 
    const Property &in (void) const;
    Property &inout (void);
    Property *&out (void);
    Property *_retn (void);
    Property *ptr (void) const;

  private:
    Property *ptr_;
  };

  class TAO_ORBSVCS_Export Property_out
  {
  public:
    Property_out (Property *&);
    Property_out (Property_var &);
    Property_out (const Property_out &);
    Property_out &operator= (const Property_out &);
    Property_out &operator= (Property *);
    operator Property *&();
    Property *&ptr (void);
    Property *operator-> (void);
    
  private:
    Property *&ptr_;
    // assignment from T_var not allowed
    void operator= (const Property_var &);
  };

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_Property;

  enum PropertyModeType
  {
        normal,
        read_only,
        fixed_normal,
        fixed_readonly,
        undefined  };
  typedef PropertyModeType &PropertyModeType_out;
  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyModeType;

  struct TAO_ORBSVCS_Export PropertyDef
  {
    TAO_String_Manager property_name;
    CORBA::Any property_value;
    PropertyModeType property_mode;
  };

  class TAO_ORBSVCS_Export PropertyDef_var
  {
  public:
    PropertyDef_var (void); // default constructor
    PropertyDef_var (PropertyDef *);
    PropertyDef_var (const PropertyDef_var &); // copy constructor
    ~PropertyDef_var (void); // destructor
    
    PropertyDef_var &operator= (PropertyDef *);
    PropertyDef_var &operator= (const PropertyDef_var &);
    PropertyDef *operator-> (void);
    const PropertyDef *operator-> (void) const;
    
    operator const PropertyDef &() const;
    operator PropertyDef &();
    operator PropertyDef &() const;
    // in, inout, out, _retn 
    const PropertyDef &in (void) const;
    PropertyDef &inout (void);
    PropertyDef *&out (void);
    PropertyDef *_retn (void);
    PropertyDef *ptr (void) const;

  private:
    PropertyDef *ptr_;
  };

  class TAO_ORBSVCS_Export PropertyDef_out
  {
  public:
    PropertyDef_out (PropertyDef *&);
    PropertyDef_out (PropertyDef_var &);
    PropertyDef_out (const PropertyDef_out &);
    PropertyDef_out &operator= (const PropertyDef_out &);
    PropertyDef_out &operator= (PropertyDef *);
    operator PropertyDef *&();
    PropertyDef *&ptr (void);
    PropertyDef *operator-> (void);
    
  private:
    PropertyDef *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyDef_var &);
  };

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyDef;

  struct TAO_ORBSVCS_Export PropertyMode
  {
    TAO_String_Manager property_name;
    PropertyModeType property_mode;
  };

  class TAO_ORBSVCS_Export PropertyMode_var
  {
  public:
    PropertyMode_var (void); // default constructor
    PropertyMode_var (PropertyMode *);
    PropertyMode_var (const PropertyMode_var &); // copy constructor
    ~PropertyMode_var (void); // destructor
    
    PropertyMode_var &operator= (PropertyMode *);
    PropertyMode_var &operator= (const PropertyMode_var &);
    PropertyMode *operator-> (void);
    const PropertyMode *operator-> (void) const;
    
    operator const PropertyMode &() const;
    operator PropertyMode &();
    operator PropertyMode &() const;
    // in, inout, out, _retn 
    const PropertyMode &in (void) const;
    PropertyMode &inout (void);
    PropertyMode *&out (void);
    PropertyMode *_retn (void);
    PropertyMode *ptr (void) const;

  private:
    PropertyMode *ptr_;
  };

  class TAO_ORBSVCS_Export PropertyMode_out
  {
  public:
    PropertyMode_out (PropertyMode *&);
    PropertyMode_out (PropertyMode_var &);
    PropertyMode_out (const PropertyMode_out &);
    PropertyMode_out &operator= (const PropertyMode_out &);
    PropertyMode_out &operator= (PropertyMode *);
    operator PropertyMode *&();
    PropertyMode *&ptr (void);
    PropertyMode *operator-> (void);
    
  private:
    PropertyMode *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyMode_var &);
  };

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyMode;


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMES_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMES_CH_

  // *************************************************************
  // PropertyNames
  // *************************************************************
  
  class TAO_ORBSVCS_Export PropertyNames : public 
#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    TAO_Unbounded_String_Sequence
#else /* TAO_USE_SEQUENCE_TEMPLATES */
    TAO_Unbounded_String_Sequence
#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  {
  public:
    PropertyNames (void); // default ctor
    PropertyNames (CORBA::ULong max); // uses max size
    PropertyNames (
      CORBA::ULong max, 
      CORBA::ULong length, 
      char * *buffer, 
      CORBA::Boolean release=0
    );
    PropertyNames (const PropertyNames &); // copy ctor
    ~PropertyNames (void); // dtor
  };
  typedef PropertyNames *PropertyNames_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMES___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMES___VAR_CH_

// *************************************************************
  // class CosPropertyService::PropertyNames_var
  // *************************************************************

  class TAO_ORBSVCS_Export PropertyNames_var
  {
  public:
    PropertyNames_var (void); // default constructor
    PropertyNames_var (PropertyNames *);
    PropertyNames_var (const PropertyNames_var &); // copy constructor
    ~PropertyNames_var (void); // destructor
    
    PropertyNames_var &operator= (PropertyNames *);
    PropertyNames_var &operator= (const PropertyNames_var &);
    PropertyNames *operator-> (void);
    const PropertyNames *operator-> (void) const;
    
    operator const PropertyNames &() const;
    operator PropertyNames &();
    operator PropertyNames &() const;
    TAO_SeqElem_String_Manager operator[] (CORBA::ULong index);
    // in, inout, out, _retn 
    const PropertyNames &in (void) const;
    PropertyNames &inout (void);
    PropertyNames *&out (void);
    PropertyNames *_retn (void);
    PropertyNames *ptr (void) const;

  private:
    PropertyNames *ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMES___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMES___OUT_CH_

  class TAO_ORBSVCS_Export PropertyNames_out
  {
  public:
    PropertyNames_out (PropertyNames *&);
    PropertyNames_out (PropertyNames_var &);
    PropertyNames_out (const PropertyNames_out &);
    PropertyNames_out &operator= (const PropertyNames_out &);
    PropertyNames_out &operator= (PropertyNames *);
    operator PropertyNames *&();
    PropertyNames *&ptr (void);
    PropertyNames *operator-> (void);
    TAO_SeqElem_String_Manager operator[] (CORBA::ULong index);
    
  private:
    PropertyNames *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyNames_var &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyNames;


#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    
#if !defined (__TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTIES_CH_)
#define __TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTIES_CH_

    class TAO_EXPORT_NESTED_MACRO _TAO_Unbounded_Sequence_CosPropertyService_Properties : public TAO_Unbounded_Base_Sequence
    {
    public:
      // = Initialization and termination methods.
      
      _TAO_Unbounded_Sequence_CosPropertyService_Properties (void); // Default constructor.
      _TAO_Unbounded_Sequence_CosPropertyService_Properties (CORBA::ULong maximum); 
      _TAO_Unbounded_Sequence_CosPropertyService_Properties (CORBA::ULong maximum,
        CORBA::ULong length,
        Property *data,
        CORBA::Boolean release = 0);
      _TAO_Unbounded_Sequence_CosPropertyService_Properties (const _TAO_Unbounded_Sequence_CosPropertyService_Properties &rhs);
      _TAO_Unbounded_Sequence_CosPropertyService_Properties &operator= (const _TAO_Unbounded_Sequence_CosPropertyService_Properties &rhs);
      virtual ~_TAO_Unbounded_Sequence_CosPropertyService_Properties (void); // Dtor.
      // = Accessors.
      Property &operator[] (CORBA::ULong i);
      const Property &operator[] (CORBA::ULong i) const;
      // = Static operations.
      static Property *allocbuf (CORBA::ULong size);
      static void freebuf (Property *buffer);
      virtual void _allocate_buffer (CORBA::ULong length);
      virtual void _deallocate_buffer (void);
      // Implement the TAO_Base_Sequence methods (see Sequence.h)
      
      Property *get_buffer (CORBA::Boolean orphan = 0);
      const Property *get_buffer (void) const;
      void replace (CORBA::ULong max,
        CORBA::ULong length,
        Property *data,
        CORBA::Boolean release);
    };

#endif /* end #if !defined */


#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  
#if !defined (_COSPROPERTYSERVICE_PROPERTIES_CH_)
#define _COSPROPERTYSERVICE_PROPERTIES_CH_

  // *************************************************************
  // Properties
  // *************************************************************
  
  class TAO_ORBSVCS_Export Properties : public 
#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    _TAO_Unbounded_Sequence_CosPropertyService_Properties
#else /* TAO_USE_SEQUENCE_TEMPLATES */
    TAO_Unbounded_Sequence<Property>
#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  {
  public:
    Properties (void); // default ctor
    Properties (CORBA::ULong max); // uses max size
    Properties (
      CORBA::ULong max, 
      CORBA::ULong length, 
      Property *buffer, 
      CORBA::Boolean release=0
    );
    Properties (const Properties &); // copy ctor
    ~Properties (void); // dtor
  };
  typedef Properties *Properties_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIES___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTIES___VAR_CH_

// *************************************************************
  // class CosPropertyService::Properties_var
  // *************************************************************

  class TAO_ORBSVCS_Export Properties_var
  {
  public:
    Properties_var (void); // default constructor
    Properties_var (Properties *);
    Properties_var (const Properties_var &); // copy constructor
    ~Properties_var (void); // destructor
    
    Properties_var &operator= (Properties *);
    Properties_var &operator= (const Properties_var &);
    Properties *operator-> (void);
    const Properties *operator-> (void) const;
    
    operator const Properties &() const;
    operator Properties &();
    operator Properties &() const;
    Property &operator[] (CORBA::ULong index);
    // in, inout, out, _retn 
    const Properties &in (void) const;
    Properties &inout (void);
    Properties *&out (void);
    Properties *_retn (void);
    Properties *ptr (void) const;

  private:
    Properties *ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIES___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTIES___OUT_CH_

  class TAO_ORBSVCS_Export Properties_out
  {
  public:
    Properties_out (Properties *&);
    Properties_out (Properties_var &);
    Properties_out (const Properties_out &);
    Properties_out &operator= (const Properties_out &);
    Properties_out &operator= (Properties *);
    operator Properties *&();
    Properties *&ptr (void);
    Properties *operator-> (void);
    Property &operator[] (CORBA::ULong index);
    
  private:
    Properties *&ptr_;
    // assignment from T_var not allowed
    void operator= (const Properties_var &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_Properties;


#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    
#if !defined (__TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTYDEFS_CH_)
#define __TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTYDEFS_CH_

    class TAO_EXPORT_NESTED_MACRO _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs : public TAO_Unbounded_Base_Sequence
    {
    public:
      // = Initialization and termination methods.
      
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs (void); // Default constructor.
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs (CORBA::ULong maximum); 
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs (CORBA::ULong maximum,
        CORBA::ULong length,
        PropertyDef *data,
        CORBA::Boolean release = 0);
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs (const _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs &rhs);
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs &operator= (const _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs &rhs);
      virtual ~_TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs (void); // Dtor.
      // = Accessors.
      PropertyDef &operator[] (CORBA::ULong i);
      const PropertyDef &operator[] (CORBA::ULong i) const;
      // = Static operations.
      static PropertyDef *allocbuf (CORBA::ULong size);
      static void freebuf (PropertyDef *buffer);
      virtual void _allocate_buffer (CORBA::ULong length);
      virtual void _deallocate_buffer (void);
      // Implement the TAO_Base_Sequence methods (see Sequence.h)
      
      PropertyDef *get_buffer (CORBA::Boolean orphan = 0);
      const PropertyDef *get_buffer (void) const;
      void replace (CORBA::ULong max,
        CORBA::ULong length,
        PropertyDef *data,
        CORBA::Boolean release);
    };

#endif /* end #if !defined */


#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYDEFS_CH_)
#define _COSPROPERTYSERVICE_PROPERTYDEFS_CH_

  // *************************************************************
  // PropertyDefs
  // *************************************************************
  
  class TAO_ORBSVCS_Export PropertyDefs : public 
#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    _TAO_Unbounded_Sequence_CosPropertyService_PropertyDefs
#else /* TAO_USE_SEQUENCE_TEMPLATES */
    TAO_Unbounded_Sequence<PropertyDef>
#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  {
  public:
    PropertyDefs (void); // default ctor
    PropertyDefs (CORBA::ULong max); // uses max size
    PropertyDefs (
      CORBA::ULong max, 
      CORBA::ULong length, 
      PropertyDef *buffer, 
      CORBA::Boolean release=0
    );
    PropertyDefs (const PropertyDefs &); // copy ctor
    ~PropertyDefs (void); // dtor
  };
  typedef PropertyDefs *PropertyDefs_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYDEFS___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYDEFS___VAR_CH_

// *************************************************************
  // class CosPropertyService::PropertyDefs_var
  // *************************************************************

  class TAO_ORBSVCS_Export PropertyDefs_var
  {
  public:
    PropertyDefs_var (void); // default constructor
    PropertyDefs_var (PropertyDefs *);
    PropertyDefs_var (const PropertyDefs_var &); // copy constructor
    ~PropertyDefs_var (void); // destructor
    
    PropertyDefs_var &operator= (PropertyDefs *);
    PropertyDefs_var &operator= (const PropertyDefs_var &);
    PropertyDefs *operator-> (void);
    const PropertyDefs *operator-> (void) const;
    
    operator const PropertyDefs &() const;
    operator PropertyDefs &();
    operator PropertyDefs &() const;
    PropertyDef &operator[] (CORBA::ULong index);
    // in, inout, out, _retn 
    const PropertyDefs &in (void) const;
    PropertyDefs &inout (void);
    PropertyDefs *&out (void);
    PropertyDefs *_retn (void);
    PropertyDefs *ptr (void) const;

  private:
    PropertyDefs *ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYDEFS___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYDEFS___OUT_CH_

  class TAO_ORBSVCS_Export PropertyDefs_out
  {
  public:
    PropertyDefs_out (PropertyDefs *&);
    PropertyDefs_out (PropertyDefs_var &);
    PropertyDefs_out (const PropertyDefs_out &);
    PropertyDefs_out &operator= (const PropertyDefs_out &);
    PropertyDefs_out &operator= (PropertyDefs *);
    operator PropertyDefs *&();
    PropertyDefs *&ptr (void);
    PropertyDefs *operator-> (void);
    PropertyDef &operator[] (CORBA::ULong index);
    
  private:
    PropertyDefs *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyDefs_var &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyDefs;


#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    
#if !defined (__TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTYMODES_CH_)
#define __TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTYMODES_CH_

    class TAO_EXPORT_NESTED_MACRO _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes : public TAO_Unbounded_Base_Sequence
    {
    public:
      // = Initialization and termination methods.
      
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes (void); // Default constructor.
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes (CORBA::ULong maximum); 
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes (CORBA::ULong maximum,
        CORBA::ULong length,
        PropertyMode *data,
        CORBA::Boolean release = 0);
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes (const _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes &rhs);
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes &operator= (const _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes &rhs);
      virtual ~_TAO_Unbounded_Sequence_CosPropertyService_PropertyModes (void); // Dtor.
      // = Accessors.
      PropertyMode &operator[] (CORBA::ULong i);
      const PropertyMode &operator[] (CORBA::ULong i) const;
      // = Static operations.
      static PropertyMode *allocbuf (CORBA::ULong size);
      static void freebuf (PropertyMode *buffer);
      virtual void _allocate_buffer (CORBA::ULong length);
      virtual void _deallocate_buffer (void);
      // Implement the TAO_Base_Sequence methods (see Sequence.h)
      
      PropertyMode *get_buffer (CORBA::Boolean orphan = 0);
      const PropertyMode *get_buffer (void) const;
      void replace (CORBA::ULong max,
        CORBA::ULong length,
        PropertyMode *data,
        CORBA::Boolean release);
    };

#endif /* end #if !defined */


#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYMODES_CH_)
#define _COSPROPERTYSERVICE_PROPERTYMODES_CH_

  // *************************************************************
  // PropertyModes
  // *************************************************************
  
  class TAO_ORBSVCS_Export PropertyModes : public 
#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    _TAO_Unbounded_Sequence_CosPropertyService_PropertyModes
#else /* TAO_USE_SEQUENCE_TEMPLATES */
    TAO_Unbounded_Sequence<PropertyMode>
#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  {
  public:
    PropertyModes (void); // default ctor
    PropertyModes (CORBA::ULong max); // uses max size
    PropertyModes (
      CORBA::ULong max, 
      CORBA::ULong length, 
      PropertyMode *buffer, 
      CORBA::Boolean release=0
    );
    PropertyModes (const PropertyModes &); // copy ctor
    ~PropertyModes (void); // dtor
  };
  typedef PropertyModes *PropertyModes_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYMODES___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYMODES___VAR_CH_

// *************************************************************
  // class CosPropertyService::PropertyModes_var
  // *************************************************************

  class TAO_ORBSVCS_Export PropertyModes_var
  {
  public:
    PropertyModes_var (void); // default constructor
    PropertyModes_var (PropertyModes *);
    PropertyModes_var (const PropertyModes_var &); // copy constructor
    ~PropertyModes_var (void); // destructor
    
    PropertyModes_var &operator= (PropertyModes *);
    PropertyModes_var &operator= (const PropertyModes_var &);
    PropertyModes *operator-> (void);
    const PropertyModes *operator-> (void) const;
    
    operator const PropertyModes &() const;
    operator PropertyModes &();
    operator PropertyModes &() const;
    PropertyMode &operator[] (CORBA::ULong index);
    // in, inout, out, _retn 
    const PropertyModes &in (void) const;
    PropertyModes &inout (void);
    PropertyModes *&out (void);
    PropertyModes *_retn (void);
    PropertyModes *ptr (void) const;

  private:
    PropertyModes *ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYMODES___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYMODES___OUT_CH_

  class TAO_ORBSVCS_Export PropertyModes_out
  {
  public:
    PropertyModes_out (PropertyModes *&);
    PropertyModes_out (PropertyModes_var &);
    PropertyModes_out (const PropertyModes_out &);
    PropertyModes_out &operator= (const PropertyModes_out &);
    PropertyModes_out &operator= (PropertyModes *);
    operator PropertyModes *&();
    PropertyModes *&ptr (void);
    PropertyModes *operator-> (void);
    PropertyMode &operator[] (CORBA::ULong index);
    
  private:
    PropertyModes *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyModes_var &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyModes;


#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    
#if !defined (__TAO_UNBOUNDED_OBJECT_SEQUENCE_COSPROPERTYSERVICE_PROPERTYTYPES_CH_)
#define __TAO_UNBOUNDED_OBJECT_SEQUENCE_COSPROPERTYSERVICE_PROPERTYTYPES_CH_

    class _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes : public TAO_Unbounded_Base_Sequence
    {
    public:
      // = Initialization and termination methods.
      
      _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes (void);
      _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes (CORBA::ULong maximum);
      _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes (CORBA::ULong maximum,
        CORBA::ULong length,
        CORBA::TypeCode* *value,
        CORBA::Boolean release = 0);
      _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes(const _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes &rhs);
      virtual ~_TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes (void);
      _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes &operator= (const _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes &rhs);
      TAO_Pseudo_Object_Manager<CORBA::TypeCode,CORBA::TypeCode_var> operator[] (CORBA::ULong index) const;
      static CORBA::TypeCode **allocbuf (CORBA::ULong nelems);
      static void freebuf (CORBA::TypeCode **buffer);
      // The Base_Sequence functions, please see tao/Sequence.h
      virtual void _allocate_buffer (CORBA::ULong length);
      virtual void _deallocate_buffer (void);
      CORBA::TypeCode* *get_buffer (CORBA::Boolean orphan = 0);
      const CORBA::TypeCode* *get_buffer (void) const;
      virtual void _shrink_buffer (CORBA::ULong nl, CORBA::ULong ol);
      
    };

#endif /* end #if !defined */


#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYTYPES_CH_)
#define _COSPROPERTYSERVICE_PROPERTYTYPES_CH_

  // *************************************************************
  // PropertyTypes
  // *************************************************************
  
  class TAO_ORBSVCS_Export PropertyTypes : public 
#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    _TAO_Unbounded_Object_Sequence_CosPropertyService_PropertyTypes
#else /* TAO_USE_SEQUENCE_TEMPLATES */
    TAO_Unbounded_Pseudo_Sequence<CORBA::TypeCode,CORBA::TypeCode_var>
#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  {
  public:
    PropertyTypes (void); // default ctor
    PropertyTypes (CORBA::ULong max); // uses max size
    PropertyTypes (
      CORBA::ULong max, 
      CORBA::ULong length, 
      CORBA::TypeCode_ptr *buffer, 
      CORBA::Boolean release=0
    );
    PropertyTypes (const PropertyTypes &); // copy ctor
    ~PropertyTypes (void); // dtor
  };
  typedef PropertyTypes *PropertyTypes_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYTYPES___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYTYPES___VAR_CH_

// *************************************************************
  // class CosPropertyService::PropertyTypes_var
  // *************************************************************

  class TAO_ORBSVCS_Export PropertyTypes_var
  {
  public:
    PropertyTypes_var (void); // default constructor
    PropertyTypes_var (PropertyTypes *);
    PropertyTypes_var (const PropertyTypes_var &); // copy constructor
    ~PropertyTypes_var (void); // destructor
    
    PropertyTypes_var &operator= (PropertyTypes *);
    PropertyTypes_var &operator= (const PropertyTypes_var &);
    PropertyTypes *operator-> (void);
    const PropertyTypes *operator-> (void) const;
    
    operator const PropertyTypes &() const;
    operator PropertyTypes &();
    operator PropertyTypes &() const;
    TAO_Pseudo_Object_Manager<CORBA::TypeCode,CORBA::TypeCode_var> operator[] (CORBA::ULong index);
    // in, inout, out, _retn 
    const PropertyTypes &in (void) const;
    PropertyTypes &inout (void);
    PropertyTypes *&out (void);
    PropertyTypes *_retn (void);
    PropertyTypes *ptr (void) const;

  private:
    PropertyTypes *ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYTYPES___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYTYPES___OUT_CH_

  class TAO_ORBSVCS_Export PropertyTypes_out
  {
  public:
    PropertyTypes_out (PropertyTypes *&);
    PropertyTypes_out (PropertyTypes_var &);
    PropertyTypes_out (const PropertyTypes_out &);
    PropertyTypes_out &operator= (const PropertyTypes_out &);
    PropertyTypes_out &operator= (PropertyTypes *);
    operator PropertyTypes *&();
    PropertyTypes *&ptr (void);
    PropertyTypes *operator-> (void);
    TAO_Pseudo_Object_Manager<CORBA::TypeCode,CORBA::TypeCode_var> operator[] (CORBA::ULong index);
    
  private:
    PropertyTypes *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyTypes_var &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyTypes;

  class PropertyNamesIterator;
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___PTR_CH_

typedef PropertyNamesIterator *PropertyNamesIterator_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___VAR_CH_

  class TAO_ORBSVCS_Export PropertyNamesIterator_var
  {
  public:
    PropertyNamesIterator_var (void); // default constructor
    PropertyNamesIterator_var (PropertyNamesIterator_ptr);
    PropertyNamesIterator_var (const PropertyNamesIterator_var &); // copy constructor
    ~PropertyNamesIterator_var (void); // destructor
    
    PropertyNamesIterator_var &operator= (PropertyNamesIterator_ptr);
    PropertyNamesIterator_var &operator= (const PropertyNamesIterator_var &);
    PropertyNamesIterator_ptr operator-> (void) const;
    
    operator const PropertyNamesIterator_ptr &() const;
    operator PropertyNamesIterator_ptr &();
    // in, inout, out, _retn 
    PropertyNamesIterator_ptr in (void) const;
    PropertyNamesIterator_ptr &inout (void);
    PropertyNamesIterator_ptr &out (void);
    PropertyNamesIterator_ptr _retn (void);
    PropertyNamesIterator_ptr ptr (void) const;

  private:
    PropertyNamesIterator_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___OUT_CH_

  class TAO_ORBSVCS_Export PropertyNamesIterator_out
  {
  public:
    PropertyNamesIterator_out (PropertyNamesIterator_ptr &);
    PropertyNamesIterator_out (PropertyNamesIterator_var &);
    PropertyNamesIterator_out (const PropertyNamesIterator_out &);
    PropertyNamesIterator_out &operator= (const PropertyNamesIterator_out &);
    PropertyNamesIterator_out &operator= (const PropertyNamesIterator_var &);
    PropertyNamesIterator_out &operator= (PropertyNamesIterator_ptr);
    operator PropertyNamesIterator_ptr &();
    PropertyNamesIterator_ptr &ptr (void);
    PropertyNamesIterator_ptr operator-> (void);
    
  private:
    PropertyNamesIterator_ptr &ptr_;
  };


#endif /* end #if !defined */

  class PropertiesIterator;
  
#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___PTR_CH_

typedef PropertiesIterator *PropertiesIterator_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___VAR_CH_

  class TAO_ORBSVCS_Export PropertiesIterator_var
  {
  public:
    PropertiesIterator_var (void); // default constructor
    PropertiesIterator_var (PropertiesIterator_ptr);
    PropertiesIterator_var (const PropertiesIterator_var &); // copy constructor
    ~PropertiesIterator_var (void); // destructor
    
    PropertiesIterator_var &operator= (PropertiesIterator_ptr);
    PropertiesIterator_var &operator= (const PropertiesIterator_var &);
    PropertiesIterator_ptr operator-> (void) const;
    
    operator const PropertiesIterator_ptr &() const;
    operator PropertiesIterator_ptr &();
    // in, inout, out, _retn 
    PropertiesIterator_ptr in (void) const;
    PropertiesIterator_ptr &inout (void);
    PropertiesIterator_ptr &out (void);
    PropertiesIterator_ptr _retn (void);
    PropertiesIterator_ptr ptr (void) const;

  private:
    PropertiesIterator_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___OUT_CH_

  class TAO_ORBSVCS_Export PropertiesIterator_out
  {
  public:
    PropertiesIterator_out (PropertiesIterator_ptr &);
    PropertiesIterator_out (PropertiesIterator_var &);
    PropertiesIterator_out (const PropertiesIterator_out &);
    PropertiesIterator_out &operator= (const PropertiesIterator_out &);
    PropertiesIterator_out &operator= (const PropertiesIterator_var &);
    PropertiesIterator_out &operator= (PropertiesIterator_ptr);
    operator PropertiesIterator_ptr &();
    PropertiesIterator_ptr &ptr (void);
    PropertiesIterator_ptr operator-> (void);
    
  private:
    PropertiesIterator_ptr &ptr_;
  };


#endif /* end #if !defined */

  class PropertySetFactory;
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___PTR_CH_

typedef PropertySetFactory *PropertySetFactory_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___VAR_CH_

  class TAO_ORBSVCS_Export PropertySetFactory_var
  {
  public:
    PropertySetFactory_var (void); // default constructor
    PropertySetFactory_var (PropertySetFactory_ptr);
    PropertySetFactory_var (const PropertySetFactory_var &); // copy constructor
    ~PropertySetFactory_var (void); // destructor
    
    PropertySetFactory_var &operator= (PropertySetFactory_ptr);
    PropertySetFactory_var &operator= (const PropertySetFactory_var &);
    PropertySetFactory_ptr operator-> (void) const;
    
    operator const PropertySetFactory_ptr &() const;
    operator PropertySetFactory_ptr &();
    // in, inout, out, _retn 
    PropertySetFactory_ptr in (void) const;
    PropertySetFactory_ptr &inout (void);
    PropertySetFactory_ptr &out (void);
    PropertySetFactory_ptr _retn (void);
    PropertySetFactory_ptr ptr (void) const;

  private:
    PropertySetFactory_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___OUT_CH_

  class TAO_ORBSVCS_Export PropertySetFactory_out
  {
  public:
    PropertySetFactory_out (PropertySetFactory_ptr &);
    PropertySetFactory_out (PropertySetFactory_var &);
    PropertySetFactory_out (const PropertySetFactory_out &);
    PropertySetFactory_out &operator= (const PropertySetFactory_out &);
    PropertySetFactory_out &operator= (const PropertySetFactory_var &);
    PropertySetFactory_out &operator= (PropertySetFactory_ptr);
    operator PropertySetFactory_ptr &();
    PropertySetFactory_ptr &ptr (void);
    PropertySetFactory_ptr operator-> (void);
    
  private:
    PropertySetFactory_ptr &ptr_;
  };


#endif /* end #if !defined */

  class PropertySetDef;
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___PTR_CH_

typedef PropertySetDef *PropertySetDef_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___VAR_CH_

  class TAO_ORBSVCS_Export PropertySetDef_var
  {
  public:
    PropertySetDef_var (void); // default constructor
    PropertySetDef_var (PropertySetDef_ptr);
    PropertySetDef_var (const PropertySetDef_var &); // copy constructor
    ~PropertySetDef_var (void); // destructor
    
    PropertySetDef_var &operator= (PropertySetDef_ptr);
    PropertySetDef_var &operator= (const PropertySetDef_var &);
    PropertySetDef_ptr operator-> (void) const;
    
    operator const PropertySetDef_ptr &() const;
    operator PropertySetDef_ptr &();
    // in, inout, out, _retn 
    PropertySetDef_ptr in (void) const;
    PropertySetDef_ptr &inout (void);
    PropertySetDef_ptr &out (void);
    PropertySetDef_ptr _retn (void);
    PropertySetDef_ptr ptr (void) const;

  private:
    PropertySetDef_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___OUT_CH_

  class TAO_ORBSVCS_Export PropertySetDef_out
  {
  public:
    PropertySetDef_out (PropertySetDef_ptr &);
    PropertySetDef_out (PropertySetDef_var &);
    PropertySetDef_out (const PropertySetDef_out &);
    PropertySetDef_out &operator= (const PropertySetDef_out &);
    PropertySetDef_out &operator= (const PropertySetDef_var &);
    PropertySetDef_out &operator= (PropertySetDef_ptr);
    operator PropertySetDef_ptr &();
    PropertySetDef_ptr &ptr (void);
    PropertySetDef_ptr operator-> (void);
    
  private:
    PropertySetDef_ptr &ptr_;
  };


#endif /* end #if !defined */

  class PropertySet;
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___PTR_CH_

typedef PropertySet *PropertySet_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___VAR_CH_

  class TAO_ORBSVCS_Export PropertySet_var
  {
  public:
    PropertySet_var (void); // default constructor
    PropertySet_var (PropertySet_ptr);
    PropertySet_var (const PropertySet_var &); // copy constructor
    ~PropertySet_var (void); // destructor
    
    PropertySet_var &operator= (PropertySet_ptr);
    PropertySet_var &operator= (const PropertySet_var &);
    PropertySet_ptr operator-> (void) const;
    
    operator const PropertySet_ptr &() const;
    operator PropertySet_ptr &();
    // in, inout, out, _retn 
    PropertySet_ptr in (void) const;
    PropertySet_ptr &inout (void);
    PropertySet_ptr &out (void);
    PropertySet_ptr _retn (void);
    PropertySet_ptr ptr (void) const;

  private:
    PropertySet_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___OUT_CH_

  class TAO_ORBSVCS_Export PropertySet_out
  {
  public:
    PropertySet_out (PropertySet_ptr &);
    PropertySet_out (PropertySet_var &);
    PropertySet_out (const PropertySet_out &);
    PropertySet_out &operator= (const PropertySet_out &);
    PropertySet_out &operator= (const PropertySet_var &);
    PropertySet_out &operator= (PropertySet_ptr);
    operator PropertySet_ptr &();
    PropertySet_ptr &ptr (void);
    PropertySet_ptr operator-> (void);
    
  private:
    PropertySet_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_CONSTRAINTNOTSUPPORTED___PTR_CH_)
#define _COSPROPERTYSERVICE_CONSTRAINTNOTSUPPORTED___PTR_CH_

  class ConstraintNotSupported;
  typedef ConstraintNotSupported *ConstraintNotSupported_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_CONSTRAINTNOTSUPPORTED_CH_)
#define _COSPROPERTYSERVICE_CONSTRAINTNOTSUPPORTED_CH_

  class TAO_ORBSVCS_Export ConstraintNotSupported : public CORBA::UserException
  {
  public:
    
    ConstraintNotSupported (void); // default ctor
    ConstraintNotSupported (const ConstraintNotSupported &); // copy ctor
    ~ConstraintNotSupported (void); // dtor
        ConstraintNotSupported &operator= (const ConstraintNotSupported &);


    virtual void _raise (void);

    static ConstraintNotSupported *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::ConstraintNotSupported

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_ConstraintNotSupported;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_INVALIDPROPERTYNAME___PTR_CH_)
#define _COSPROPERTYSERVICE_INVALIDPROPERTYNAME___PTR_CH_

  class InvalidPropertyName;
  typedef InvalidPropertyName *InvalidPropertyName_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_INVALIDPROPERTYNAME_CH_)
#define _COSPROPERTYSERVICE_INVALIDPROPERTYNAME_CH_

  class TAO_ORBSVCS_Export InvalidPropertyName : public CORBA::UserException
  {
  public:
    
    InvalidPropertyName (void); // default ctor
    InvalidPropertyName (const InvalidPropertyName &); // copy ctor
    ~InvalidPropertyName (void); // dtor
        InvalidPropertyName &operator= (const InvalidPropertyName &);


    virtual void _raise (void);

    static InvalidPropertyName *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::InvalidPropertyName

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_InvalidPropertyName;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_CONFLICTINGPROPERTY___PTR_CH_)
#define _COSPROPERTYSERVICE_CONFLICTINGPROPERTY___PTR_CH_

  class ConflictingProperty;
  typedef ConflictingProperty *ConflictingProperty_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_CONFLICTINGPROPERTY_CH_)
#define _COSPROPERTYSERVICE_CONFLICTINGPROPERTY_CH_

  class TAO_ORBSVCS_Export ConflictingProperty : public CORBA::UserException
  {
  public:
    
    ConflictingProperty (void); // default ctor
    ConflictingProperty (const ConflictingProperty &); // copy ctor
    ~ConflictingProperty (void); // dtor
        ConflictingProperty &operator= (const ConflictingProperty &);


    virtual void _raise (void);

    static ConflictingProperty *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::ConflictingProperty

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_ConflictingProperty;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNOTFOUND___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNOTFOUND___PTR_CH_

  class PropertyNotFound;
  typedef PropertyNotFound *PropertyNotFound_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNOTFOUND_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNOTFOUND_CH_

  class TAO_ORBSVCS_Export PropertyNotFound : public CORBA::UserException
  {
  public:
    
    PropertyNotFound (void); // default ctor
    PropertyNotFound (const PropertyNotFound &); // copy ctor
    ~PropertyNotFound (void); // dtor
        PropertyNotFound &operator= (const PropertyNotFound &);


    virtual void _raise (void);

    static PropertyNotFound *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::PropertyNotFound

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyNotFound;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_UNSUPPORTEDTYPECODE___PTR_CH_)
#define _COSPROPERTYSERVICE_UNSUPPORTEDTYPECODE___PTR_CH_

  class UnsupportedTypeCode;
  typedef UnsupportedTypeCode *UnsupportedTypeCode_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_UNSUPPORTEDTYPECODE_CH_)
#define _COSPROPERTYSERVICE_UNSUPPORTEDTYPECODE_CH_

  class TAO_ORBSVCS_Export UnsupportedTypeCode : public CORBA::UserException
  {
  public:
    
    UnsupportedTypeCode (void); // default ctor
    UnsupportedTypeCode (const UnsupportedTypeCode &); // copy ctor
    ~UnsupportedTypeCode (void); // dtor
        UnsupportedTypeCode &operator= (const UnsupportedTypeCode &);


    virtual void _raise (void);

    static UnsupportedTypeCode *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::UnsupportedTypeCode

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_UnsupportedTypeCode;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_UNSUPPORTEDPROPERTY___PTR_CH_)
#define _COSPROPERTYSERVICE_UNSUPPORTEDPROPERTY___PTR_CH_

  class UnsupportedProperty;
  typedef UnsupportedProperty *UnsupportedProperty_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_UNSUPPORTEDPROPERTY_CH_)
#define _COSPROPERTYSERVICE_UNSUPPORTEDPROPERTY_CH_

  class TAO_ORBSVCS_Export UnsupportedProperty : public CORBA::UserException
  {
  public:
    
    UnsupportedProperty (void); // default ctor
    UnsupportedProperty (const UnsupportedProperty &); // copy ctor
    ~UnsupportedProperty (void); // dtor
        UnsupportedProperty &operator= (const UnsupportedProperty &);


    virtual void _raise (void);

    static UnsupportedProperty *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::UnsupportedProperty

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_UnsupportedProperty;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_UNSUPPORTEDMODE___PTR_CH_)
#define _COSPROPERTYSERVICE_UNSUPPORTEDMODE___PTR_CH_

  class UnsupportedMode;
  typedef UnsupportedMode *UnsupportedMode_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_UNSUPPORTEDMODE_CH_)
#define _COSPROPERTYSERVICE_UNSUPPORTEDMODE_CH_

  class TAO_ORBSVCS_Export UnsupportedMode : public CORBA::UserException
  {
  public:
    
    UnsupportedMode (void); // default ctor
    UnsupportedMode (const UnsupportedMode &); // copy ctor
    ~UnsupportedMode (void); // dtor
        UnsupportedMode &operator= (const UnsupportedMode &);


    virtual void _raise (void);

    static UnsupportedMode *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::UnsupportedMode

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_UnsupportedMode;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_FIXEDPROPERTY___PTR_CH_)
#define _COSPROPERTYSERVICE_FIXEDPROPERTY___PTR_CH_

  class FixedProperty;
  typedef FixedProperty *FixedProperty_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_FIXEDPROPERTY_CH_)
#define _COSPROPERTYSERVICE_FIXEDPROPERTY_CH_

  class TAO_ORBSVCS_Export FixedProperty : public CORBA::UserException
  {
  public:
    
    FixedProperty (void); // default ctor
    FixedProperty (const FixedProperty &); // copy ctor
    ~FixedProperty (void); // dtor
        FixedProperty &operator= (const FixedProperty &);


    virtual void _raise (void);

    static FixedProperty *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::FixedProperty

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_FixedProperty;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_READONLYPROPERTY___PTR_CH_)
#define _COSPROPERTYSERVICE_READONLYPROPERTY___PTR_CH_

  class ReadOnlyProperty;
  typedef ReadOnlyProperty *ReadOnlyProperty_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_READONLYPROPERTY_CH_)
#define _COSPROPERTYSERVICE_READONLYPROPERTY_CH_

  class TAO_ORBSVCS_Export ReadOnlyProperty : public CORBA::UserException
  {
  public:
    
    ReadOnlyProperty (void); // default ctor
    ReadOnlyProperty (const ReadOnlyProperty &); // copy ctor
    ~ReadOnlyProperty (void); // dtor
        ReadOnlyProperty &operator= (const ReadOnlyProperty &);


    virtual void _raise (void);

    static ReadOnlyProperty *_narrow (CORBA::Exception *);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::ReadOnlyProperty

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_ReadOnlyProperty;


#endif /* end #if !defined */

  enum ExceptionReason
  {
        invalid_property_name,
        conflicting_property,
        property_not_found,
        unsupported_type_code,
        unsupported_property,
        unsupported_mode,
        fixed_property,
        read_only_property  };
  typedef ExceptionReason &ExceptionReason_out;
  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_ExceptionReason;

  struct TAO_ORBSVCS_Export PropertyException
  {
    ExceptionReason reason;
    TAO_String_Manager failing_property_name;
  };

  class TAO_ORBSVCS_Export PropertyException_var
  {
  public:
    PropertyException_var (void); // default constructor
    PropertyException_var (PropertyException *);
    PropertyException_var (const PropertyException_var &); // copy constructor
    ~PropertyException_var (void); // destructor
    
    PropertyException_var &operator= (PropertyException *);
    PropertyException_var &operator= (const PropertyException_var &);
    PropertyException *operator-> (void);
    const PropertyException *operator-> (void) const;
    
    operator const PropertyException &() const;
    operator PropertyException &();
    operator PropertyException &() const;
    // in, inout, out, _retn 
    const PropertyException &in (void) const;
    PropertyException &inout (void);
    PropertyException *&out (void);
    PropertyException *_retn (void);
    PropertyException *ptr (void) const;

  private:
    PropertyException *ptr_;
  };

  class TAO_ORBSVCS_Export PropertyException_out
  {
  public:
    PropertyException_out (PropertyException *&);
    PropertyException_out (PropertyException_var &);
    PropertyException_out (const PropertyException_out &);
    PropertyException_out &operator= (const PropertyException_out &);
    PropertyException_out &operator= (PropertyException *);
    operator PropertyException *&();
    PropertyException *&ptr (void);
    PropertyException *operator-> (void);
    
  private:
    PropertyException *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyException_var &);
  };

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyException;


#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    
#if !defined (__TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTYEXCEPTIONS_CH_)
#define __TAO_UNBOUNDED_SEQUENCE_COSPROPERTYSERVICE_PROPERTYEXCEPTIONS_CH_

    class TAO_EXPORT_NESTED_MACRO _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions : public TAO_Unbounded_Base_Sequence
    {
    public:
      // = Initialization and termination methods.
      
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions (void); // Default constructor.
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions (CORBA::ULong maximum); 
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions (CORBA::ULong maximum,
        CORBA::ULong length,
        PropertyException *data,
        CORBA::Boolean release = 0);
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions (const _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions &rhs);
      _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions &operator= (const _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions &rhs);
      virtual ~_TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions (void); // Dtor.
      // = Accessors.
      PropertyException &operator[] (CORBA::ULong i);
      const PropertyException &operator[] (CORBA::ULong i) const;
      // = Static operations.
      static PropertyException *allocbuf (CORBA::ULong size);
      static void freebuf (PropertyException *buffer);
      virtual void _allocate_buffer (CORBA::ULong length);
      virtual void _deallocate_buffer (void);
      // Implement the TAO_Base_Sequence methods (see Sequence.h)
      
      PropertyException *get_buffer (CORBA::Boolean orphan = 0);
      const PropertyException *get_buffer (void) const;
      void replace (CORBA::ULong max,
        CORBA::ULong length,
        PropertyException *data,
        CORBA::Boolean release);
    };

#endif /* end #if !defined */


#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  
#if !defined (_COSPROPERTYSERVICE_PROPERTYEXCEPTIONS_CH_)
#define _COSPROPERTYSERVICE_PROPERTYEXCEPTIONS_CH_

  // *************************************************************
  // PropertyExceptions
  // *************************************************************
  
  class TAO_ORBSVCS_Export PropertyExceptions : public 
#if !defined (TAO_USE_SEQUENCE_TEMPLATES)
    _TAO_Unbounded_Sequence_CosPropertyService_PropertyExceptions
#else /* TAO_USE_SEQUENCE_TEMPLATES */
    TAO_Unbounded_Sequence<PropertyException>
#endif /* !TAO_USE_SEQUENCE_TEMPLATES */ 
  {
  public:
    PropertyExceptions (void); // default ctor
    PropertyExceptions (CORBA::ULong max); // uses max size
    PropertyExceptions (
      CORBA::ULong max, 
      CORBA::ULong length, 
      PropertyException *buffer, 
      CORBA::Boolean release=0
    );
    PropertyExceptions (const PropertyExceptions &); // copy ctor
    ~PropertyExceptions (void); // dtor
  };
  typedef PropertyExceptions *PropertyExceptions_ptr;

#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYEXCEPTIONS___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYEXCEPTIONS___VAR_CH_

// *************************************************************
  // class CosPropertyService::PropertyExceptions_var
  // *************************************************************

  class TAO_ORBSVCS_Export PropertyExceptions_var
  {
  public:
    PropertyExceptions_var (void); // default constructor
    PropertyExceptions_var (PropertyExceptions *);
    PropertyExceptions_var (const PropertyExceptions_var &); // copy constructor
    ~PropertyExceptions_var (void); // destructor
    
    PropertyExceptions_var &operator= (PropertyExceptions *);
    PropertyExceptions_var &operator= (const PropertyExceptions_var &);
    PropertyExceptions *operator-> (void);
    const PropertyExceptions *operator-> (void) const;
    
    operator const PropertyExceptions &() const;
    operator PropertyExceptions &();
    operator PropertyExceptions &() const;
    PropertyException &operator[] (CORBA::ULong index);
    // in, inout, out, _retn 
    const PropertyExceptions &in (void) const;
    PropertyExceptions &inout (void);
    PropertyExceptions *&out (void);
    PropertyExceptions *_retn (void);
    PropertyExceptions *ptr (void) const;

  private:
    PropertyExceptions *ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYEXCEPTIONS___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYEXCEPTIONS___OUT_CH_

  class TAO_ORBSVCS_Export PropertyExceptions_out
  {
  public:
    PropertyExceptions_out (PropertyExceptions *&);
    PropertyExceptions_out (PropertyExceptions_var &);
    PropertyExceptions_out (const PropertyExceptions_out &);
    PropertyExceptions_out &operator= (const PropertyExceptions_out &);
    PropertyExceptions_out &operator= (PropertyExceptions *);
    operator PropertyExceptions *&();
    PropertyExceptions *&ptr (void);
    PropertyExceptions *operator-> (void);
    PropertyException &operator[] (CORBA::ULong index);
    
  private:
    PropertyExceptions *&ptr_;
    // assignment from T_var not allowed
    void operator= (const PropertyExceptions_var &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyExceptions;


#if !defined (_COSPROPERTYSERVICE_MULTIPLEEXCEPTIONS___PTR_CH_)
#define _COSPROPERTYSERVICE_MULTIPLEEXCEPTIONS___PTR_CH_

  class MultipleExceptions;
  typedef MultipleExceptions *MultipleExceptions_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_MULTIPLEEXCEPTIONS_CH_)
#define _COSPROPERTYSERVICE_MULTIPLEEXCEPTIONS_CH_

  class TAO_ORBSVCS_Export MultipleExceptions : public CORBA::UserException
  {
  public:
        PropertyExceptions exceptions;

    MultipleExceptions (void); // default ctor
    MultipleExceptions (const MultipleExceptions &); // copy ctor
    ~MultipleExceptions (void); // dtor
        MultipleExceptions &operator= (const MultipleExceptions &);


    virtual void _raise (void);

    static MultipleExceptions *_narrow (CORBA::Exception *);

    MultipleExceptions(
      const PropertyExceptions & _tao_exceptions);


    // = TAO extension
    static CORBA::Exception *_alloc (void);

  }; // exception CosPropertyService::MultipleExceptions

    TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_MultipleExceptions;


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___PTR_CH_

  class PropertySetFactory;
  typedef PropertySetFactory *PropertySetFactory_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___VAR_CH_

  class TAO_ORBSVCS_Export PropertySetFactory_var
  {
  public:
    PropertySetFactory_var (void); // default constructor
    PropertySetFactory_var (PropertySetFactory_ptr);
    PropertySetFactory_var (const PropertySetFactory_var &); // copy constructor
    ~PropertySetFactory_var (void); // destructor
    
    PropertySetFactory_var &operator= (PropertySetFactory_ptr);
    PropertySetFactory_var &operator= (const PropertySetFactory_var &);
    PropertySetFactory_ptr operator-> (void) const;
    
    operator const PropertySetFactory_ptr &() const;
    operator PropertySetFactory_ptr &();
    // in, inout, out, _retn 
    PropertySetFactory_ptr in (void) const;
    PropertySetFactory_ptr &inout (void);
    PropertySetFactory_ptr &out (void);
    PropertySetFactory_ptr _retn (void);
    PropertySetFactory_ptr ptr (void) const;

  private:
    PropertySetFactory_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___OUT_CH_

  class TAO_ORBSVCS_Export PropertySetFactory_out
  {
  public:
    PropertySetFactory_out (PropertySetFactory_ptr &);
    PropertySetFactory_out (PropertySetFactory_var &);
    PropertySetFactory_out (const PropertySetFactory_out &);
    PropertySetFactory_out &operator= (const PropertySetFactory_out &);
    PropertySetFactory_out &operator= (const PropertySetFactory_var &);
    PropertySetFactory_out &operator= (PropertySetFactory_ptr);
    operator PropertySetFactory_ptr &();
    PropertySetFactory_ptr &ptr (void);
    PropertySetFactory_ptr operator-> (void);
    
  private:
    PropertySetFactory_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY_CH_

class TAO_ORBSVCS_Export PropertySetFactory : public virtual ACE_CORBA_1 (Object)
  {
  public:
  #if !defined(__GNUC__) || !defined (ACE_HAS_GNUG_PRE_2_8)
    typedef PropertySetFactory_ptr _ptr_type;
    typedef PropertySetFactory_var _var_type;
  #endif /* ! __GNUC__ || g++ >= 2.8 */

    // the static operations
    static PropertySetFactory_ptr _duplicate (PropertySetFactory_ptr obj);
    static PropertySetFactory_ptr _narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySetFactory_ptr _unchecked_narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySetFactory_ptr _nil (void)
      {
        return (CosPropertyService::PropertySetFactory_ptr)0;
      }

    virtual PropertySet_ptr create_propertyset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual PropertySet_ptr create_constrained_propertyset (
        const PropertyTypes & allowed_property_types,
        const Properties & allowed_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      ));

    virtual PropertySet_ptr create_initial_propertyset (
        const Properties & initial_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::Boolean _is_a (
        const CORBA::Char *type_id, 
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    virtual const char* _interface_repository_id (void) const;

  protected:
    PropertySetFactory (void);
    PropertySetFactory (TAO_Stub *objref, 
        TAO_ServantBase *_tao_servant = 0, 
        CORBA::Boolean _tao_collocated = 0
      );
    virtual ~PropertySetFactory (void);
  private:
    PropertySetFactory (const PropertySetFactory &);
    void operator= (const PropertySetFactory &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertySetFactory;


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___PTR_CH_

  class PropertySetDefFactory;
  typedef PropertySetDefFactory *PropertySetDefFactory_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___VAR_CH_

  class TAO_ORBSVCS_Export PropertySetDefFactory_var
  {
  public:
    PropertySetDefFactory_var (void); // default constructor
    PropertySetDefFactory_var (PropertySetDefFactory_ptr);
    PropertySetDefFactory_var (const PropertySetDefFactory_var &); // copy constructor
    ~PropertySetDefFactory_var (void); // destructor
    
    PropertySetDefFactory_var &operator= (PropertySetDefFactory_ptr);
    PropertySetDefFactory_var &operator= (const PropertySetDefFactory_var &);
    PropertySetDefFactory_ptr operator-> (void) const;
    
    operator const PropertySetDefFactory_ptr &() const;
    operator PropertySetDefFactory_ptr &();
    // in, inout, out, _retn 
    PropertySetDefFactory_ptr in (void) const;
    PropertySetDefFactory_ptr &inout (void);
    PropertySetDefFactory_ptr &out (void);
    PropertySetDefFactory_ptr _retn (void);
    PropertySetDefFactory_ptr ptr (void) const;

  private:
    PropertySetDefFactory_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___OUT_CH_

  class TAO_ORBSVCS_Export PropertySetDefFactory_out
  {
  public:
    PropertySetDefFactory_out (PropertySetDefFactory_ptr &);
    PropertySetDefFactory_out (PropertySetDefFactory_var &);
    PropertySetDefFactory_out (const PropertySetDefFactory_out &);
    PropertySetDefFactory_out &operator= (const PropertySetDefFactory_out &);
    PropertySetDefFactory_out &operator= (const PropertySetDefFactory_var &);
    PropertySetDefFactory_out &operator= (PropertySetDefFactory_ptr);
    operator PropertySetDefFactory_ptr &();
    PropertySetDefFactory_ptr &ptr (void);
    PropertySetDefFactory_ptr operator-> (void);
    
  private:
    PropertySetDefFactory_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY_CH_

class TAO_ORBSVCS_Export PropertySetDefFactory : public virtual ACE_CORBA_1 (Object)
  {
  public:
  #if !defined(__GNUC__) || !defined (ACE_HAS_GNUG_PRE_2_8)
    typedef PropertySetDefFactory_ptr _ptr_type;
    typedef PropertySetDefFactory_var _var_type;
  #endif /* ! __GNUC__ || g++ >= 2.8 */

    // the static operations
    static PropertySetDefFactory_ptr _duplicate (PropertySetDefFactory_ptr obj);
    static PropertySetDefFactory_ptr _narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySetDefFactory_ptr _unchecked_narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySetDefFactory_ptr _nil (void)
      {
        return (CosPropertyService::PropertySetDefFactory_ptr)0;
      }

    virtual PropertySetDef_ptr create_propertysetdef (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual PropertySetDef_ptr create_constrained_propertysetdef (
        const PropertyTypes & allowed_property_types,
        const PropertyDefs & allowed_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      ));

    virtual PropertySetDef_ptr create_initial_propertysetdef (
        const PropertyDefs & initial_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::Boolean _is_a (
        const CORBA::Char *type_id, 
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    virtual const char* _interface_repository_id (void) const;

  protected:
    PropertySetDefFactory (void);
    PropertySetDefFactory (TAO_Stub *objref, 
        TAO_ServantBase *_tao_servant = 0, 
        CORBA::Boolean _tao_collocated = 0
      );
    virtual ~PropertySetDefFactory (void);
  private:
    PropertySetDefFactory (const PropertySetDefFactory &);
    void operator= (const PropertySetDefFactory &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertySetDefFactory;


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___PTR_CH_

  class PropertySet;
  typedef PropertySet *PropertySet_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___VAR_CH_

  class TAO_ORBSVCS_Export PropertySet_var
  {
  public:
    PropertySet_var (void); // default constructor
    PropertySet_var (PropertySet_ptr);
    PropertySet_var (const PropertySet_var &); // copy constructor
    ~PropertySet_var (void); // destructor
    
    PropertySet_var &operator= (PropertySet_ptr);
    PropertySet_var &operator= (const PropertySet_var &);
    PropertySet_ptr operator-> (void) const;
    
    operator const PropertySet_ptr &() const;
    operator PropertySet_ptr &();
    // in, inout, out, _retn 
    PropertySet_ptr in (void) const;
    PropertySet_ptr &inout (void);
    PropertySet_ptr &out (void);
    PropertySet_ptr _retn (void);
    PropertySet_ptr ptr (void) const;

  private:
    PropertySet_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___OUT_CH_

  class TAO_ORBSVCS_Export PropertySet_out
  {
  public:
    PropertySet_out (PropertySet_ptr &);
    PropertySet_out (PropertySet_var &);
    PropertySet_out (const PropertySet_out &);
    PropertySet_out &operator= (const PropertySet_out &);
    PropertySet_out &operator= (const PropertySet_var &);
    PropertySet_out &operator= (PropertySet_ptr);
    operator PropertySet_ptr &();
    PropertySet_ptr &ptr (void);
    PropertySet_ptr operator-> (void);
    
  private:
    PropertySet_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSET_CH_

class TAO_ORBSVCS_Export PropertySet : public virtual ACE_CORBA_1 (Object)
  {
  public:
  #if !defined(__GNUC__) || !defined (ACE_HAS_GNUG_PRE_2_8)
    typedef PropertySet_ptr _ptr_type;
    typedef PropertySet_var _var_type;
  #endif /* ! __GNUC__ || g++ >= 2.8 */

    // the static operations
    static PropertySet_ptr _duplicate (PropertySet_ptr obj);
    static PropertySet_ptr _narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySet_ptr _unchecked_narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySet_ptr _nil (void)
      {
        return (CosPropertyService::PropertySet_ptr)0;
      }

    virtual void define_property (
        const char * property_name,
        const CORBA::Any & property_value,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::ReadOnlyProperty
      ));

    virtual void define_properties (
        const Properties & nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::ULong get_number_of_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void get_all_property_names (
        CORBA::ULong how_many,
        PropertyNames_out property_names,
        PropertyNamesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Any * get_property_value (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    virtual CORBA::Boolean get_properties (
        const PropertyNames & property_names,
        Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void get_all_properties (
        CORBA::ULong how_many,
        Properties_out nproperties,
        PropertiesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void delete_property (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::FixedProperty
      ));

    virtual void delete_properties (
        const PropertyNames & property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::Boolean delete_all_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean is_property_defined (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName
      ));

    virtual CORBA::Boolean _is_a (
        const CORBA::Char *type_id, 
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    virtual const char* _interface_repository_id (void) const;

  protected:
    PropertySet (void);
    PropertySet (TAO_Stub *objref, 
        TAO_ServantBase *_tao_servant = 0, 
        CORBA::Boolean _tao_collocated = 0
      );
    virtual ~PropertySet (void);
  private:
    PropertySet (const PropertySet &);
    void operator= (const PropertySet &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertySet;


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___PTR_CH_

  class PropertySetDef;
  typedef PropertySetDef *PropertySetDef_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___VAR_CH_

  class TAO_ORBSVCS_Export PropertySetDef_var
  {
  public:
    PropertySetDef_var (void); // default constructor
    PropertySetDef_var (PropertySetDef_ptr);
    PropertySetDef_var (const PropertySetDef_var &); // copy constructor
    ~PropertySetDef_var (void); // destructor
    
    PropertySetDef_var &operator= (PropertySetDef_ptr);
    PropertySetDef_var &operator= (const PropertySetDef_var &);
    PropertySetDef_ptr operator-> (void) const;
    
    operator const PropertySetDef_ptr &() const;
    operator PropertySetDef_ptr &();
    // in, inout, out, _retn 
    PropertySetDef_ptr in (void) const;
    PropertySetDef_ptr &inout (void);
    PropertySetDef_ptr &out (void);
    PropertySetDef_ptr _retn (void);
    PropertySetDef_ptr ptr (void) const;

  private:
    PropertySetDef_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___OUT_CH_

  class TAO_ORBSVCS_Export PropertySetDef_out
  {
  public:
    PropertySetDef_out (PropertySetDef_ptr &);
    PropertySetDef_out (PropertySetDef_var &);
    PropertySetDef_out (const PropertySetDef_out &);
    PropertySetDef_out &operator= (const PropertySetDef_out &);
    PropertySetDef_out &operator= (const PropertySetDef_var &);
    PropertySetDef_out &operator= (PropertySetDef_ptr);
    operator PropertySetDef_ptr &();
    PropertySetDef_ptr &ptr (void);
    PropertySetDef_ptr operator-> (void);
    
  private:
    PropertySetDef_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF_CH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF_CH_

class TAO_ORBSVCS_Export PropertySetDef: public virtual PropertySet
  {
  public:
  #if !defined(__GNUC__) || !defined (ACE_HAS_GNUG_PRE_2_8)
    typedef PropertySetDef_ptr _ptr_type;
    typedef PropertySetDef_var _var_type;
  #endif /* ! __GNUC__ || g++ >= 2.8 */

    // the static operations
    static PropertySetDef_ptr _duplicate (PropertySetDef_ptr obj);
    static PropertySetDef_ptr _narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySetDef_ptr _unchecked_narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertySetDef_ptr _nil (void)
      {
        return (CosPropertyService::PropertySetDef_ptr)0;
      }

    virtual void get_allowed_property_types (
        PropertyTypes_out property_types,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void get_allowed_properties (
        PropertyDefs_out property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void define_property_with_mode (
        const char * property_name,
        const CORBA::Any & property_value,
        PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::UnsupportedMode,
        CosPropertyService::ReadOnlyProperty
      ));

    virtual void define_properties_with_modes (
        const PropertyDefs & property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual PropertyModeType get_property_mode (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    virtual CORBA::Boolean get_property_modes (
        const PropertyNames & property_names,
        PropertyModes_out property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void set_property_mode (
        const char * property_name,
        PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::UnsupportedMode
      ));

    virtual void set_property_modes (
        const PropertyModes & property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::Boolean _is_a (
        const CORBA::Char *type_id, 
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    virtual const char* _interface_repository_id (void) const;

  protected:
    PropertySetDef (void);
    PropertySetDef (TAO_Stub *objref, 
        TAO_ServantBase *_tao_servant = 0, 
        CORBA::Boolean _tao_collocated = 0
      );
    virtual ~PropertySetDef (void);
  private:
    PropertySetDef (const PropertySetDef &);
    void operator= (const PropertySetDef &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertySetDef;


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___PTR_CH_

  class PropertyNamesIterator;
  typedef PropertyNamesIterator *PropertyNamesIterator_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___VAR_CH_

  class TAO_ORBSVCS_Export PropertyNamesIterator_var
  {
  public:
    PropertyNamesIterator_var (void); // default constructor
    PropertyNamesIterator_var (PropertyNamesIterator_ptr);
    PropertyNamesIterator_var (const PropertyNamesIterator_var &); // copy constructor
    ~PropertyNamesIterator_var (void); // destructor
    
    PropertyNamesIterator_var &operator= (PropertyNamesIterator_ptr);
    PropertyNamesIterator_var &operator= (const PropertyNamesIterator_var &);
    PropertyNamesIterator_ptr operator-> (void) const;
    
    operator const PropertyNamesIterator_ptr &() const;
    operator PropertyNamesIterator_ptr &();
    // in, inout, out, _retn 
    PropertyNamesIterator_ptr in (void) const;
    PropertyNamesIterator_ptr &inout (void);
    PropertyNamesIterator_ptr &out (void);
    PropertyNamesIterator_ptr _retn (void);
    PropertyNamesIterator_ptr ptr (void) const;

  private:
    PropertyNamesIterator_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___OUT_CH_

  class TAO_ORBSVCS_Export PropertyNamesIterator_out
  {
  public:
    PropertyNamesIterator_out (PropertyNamesIterator_ptr &);
    PropertyNamesIterator_out (PropertyNamesIterator_var &);
    PropertyNamesIterator_out (const PropertyNamesIterator_out &);
    PropertyNamesIterator_out &operator= (const PropertyNamesIterator_out &);
    PropertyNamesIterator_out &operator= (const PropertyNamesIterator_var &);
    PropertyNamesIterator_out &operator= (PropertyNamesIterator_ptr);
    operator PropertyNamesIterator_ptr &();
    PropertyNamesIterator_ptr &ptr (void);
    PropertyNamesIterator_ptr operator-> (void);
    
  private:
    PropertyNamesIterator_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR_CH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR_CH_

class TAO_ORBSVCS_Export PropertyNamesIterator : public virtual ACE_CORBA_1 (Object)
  {
  public:
  #if !defined(__GNUC__) || !defined (ACE_HAS_GNUG_PRE_2_8)
    typedef PropertyNamesIterator_ptr _ptr_type;
    typedef PropertyNamesIterator_var _var_type;
  #endif /* ! __GNUC__ || g++ >= 2.8 */

    // the static operations
    static PropertyNamesIterator_ptr _duplicate (PropertyNamesIterator_ptr obj);
    static PropertyNamesIterator_ptr _narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertyNamesIterator_ptr _unchecked_narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertyNamesIterator_ptr _nil (void)
      {
        return (CosPropertyService::PropertyNamesIterator_ptr)0;
      }

    virtual void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_one (
        CORBA::String_out property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_n (
        CORBA::ULong how_many,
        PropertyNames_out property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean _is_a (
        const CORBA::Char *type_id, 
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    virtual const char* _interface_repository_id (void) const;

  protected:
    PropertyNamesIterator (void);
    PropertyNamesIterator (TAO_Stub *objref, 
        TAO_ServantBase *_tao_servant = 0, 
        CORBA::Boolean _tao_collocated = 0
      );
    virtual ~PropertyNamesIterator (void);
  private:
    PropertyNamesIterator (const PropertyNamesIterator &);
    void operator= (const PropertyNamesIterator &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertyNamesIterator;


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___PTR_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___PTR_CH_

  class PropertiesIterator;
  typedef PropertiesIterator *PropertiesIterator_ptr;
  
#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___VAR_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___VAR_CH_

  class TAO_ORBSVCS_Export PropertiesIterator_var
  {
  public:
    PropertiesIterator_var (void); // default constructor
    PropertiesIterator_var (PropertiesIterator_ptr);
    PropertiesIterator_var (const PropertiesIterator_var &); // copy constructor
    ~PropertiesIterator_var (void); // destructor
    
    PropertiesIterator_var &operator= (PropertiesIterator_ptr);
    PropertiesIterator_var &operator= (const PropertiesIterator_var &);
    PropertiesIterator_ptr operator-> (void) const;
    
    operator const PropertiesIterator_ptr &() const;
    operator PropertiesIterator_ptr &();
    // in, inout, out, _retn 
    PropertiesIterator_ptr in (void) const;
    PropertiesIterator_ptr &inout (void);
    PropertiesIterator_ptr &out (void);
    PropertiesIterator_ptr _retn (void);
    PropertiesIterator_ptr ptr (void) const;

  private:
    PropertiesIterator_ptr ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___OUT_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___OUT_CH_

  class TAO_ORBSVCS_Export PropertiesIterator_out
  {
  public:
    PropertiesIterator_out (PropertiesIterator_ptr &);
    PropertiesIterator_out (PropertiesIterator_var &);
    PropertiesIterator_out (const PropertiesIterator_out &);
    PropertiesIterator_out &operator= (const PropertiesIterator_out &);
    PropertiesIterator_out &operator= (const PropertiesIterator_var &);
    PropertiesIterator_out &operator= (PropertiesIterator_ptr);
    operator PropertiesIterator_ptr &();
    PropertiesIterator_ptr &ptr (void);
    PropertiesIterator_ptr operator-> (void);
    
  private:
    PropertiesIterator_ptr &ptr_;
  };


#endif /* end #if !defined */


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR_CH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR_CH_

class TAO_ORBSVCS_Export PropertiesIterator : public virtual ACE_CORBA_1 (Object)
  {
  public:
  #if !defined(__GNUC__) || !defined (ACE_HAS_GNUG_PRE_2_8)
    typedef PropertiesIterator_ptr _ptr_type;
    typedef PropertiesIterator_var _var_type;
  #endif /* ! __GNUC__ || g++ >= 2.8 */

    // the static operations
    static PropertiesIterator_ptr _duplicate (PropertiesIterator_ptr obj);
    static PropertiesIterator_ptr _narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertiesIterator_ptr _unchecked_narrow (
        CORBA::Object_ptr obj,
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    static PropertiesIterator_ptr _nil (void)
      {
        return (CosPropertyService::PropertiesIterator_ptr)0;
      }

    virtual void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_one (
        Property_out aproperty,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_n (
        CORBA::ULong how_many,
        Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean _is_a (
        const CORBA::Char *type_id, 
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    virtual const char* _interface_repository_id (void) const;

  protected:
    PropertiesIterator (void);
    PropertiesIterator (TAO_Stub *objref, 
        TAO_ServantBase *_tao_servant = 0, 
        CORBA::Boolean _tao_collocated = 0
      );
    virtual ~PropertiesIterator (void);
  private:
    PropertiesIterator (const PropertiesIterator &);
    void operator= (const PropertiesIterator &);
  };


#endif /* end #if !defined */

  TAO_NAMESPACE_STORAGE_CLASS CORBA::TypeCode_ptr _tc_PropertiesIterator;


}; // module CosPropertyService

void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::Property &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::Property*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::Property *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyModeType);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyModeType &);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyDef &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyDef*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyDef *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyMode &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyMode*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyMode *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyNames &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyNames*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyNames *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::Properties &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::Properties*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::Properties *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyDefs &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyDefs*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyDefs *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyModes &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyModes*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyModes *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyTypes &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyTypes*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyTypes *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::ConstraintNotSupported &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::ConstraintNotSupported*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::ConstraintNotSupported *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::InvalidPropertyName &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::InvalidPropertyName*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::InvalidPropertyName *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::ConflictingProperty &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::ConflictingProperty*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::ConflictingProperty *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyNotFound &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyNotFound*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyNotFound *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::UnsupportedTypeCode &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::UnsupportedTypeCode*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::UnsupportedTypeCode *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::UnsupportedProperty &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::UnsupportedProperty*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::UnsupportedProperty *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::UnsupportedMode &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::UnsupportedMode*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::UnsupportedMode *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::FixedProperty &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::FixedProperty*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::FixedProperty *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::ReadOnlyProperty &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::ReadOnlyProperty*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::ReadOnlyProperty *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::ExceptionReason);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::ExceptionReason &);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyException &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyException*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyException *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::PropertyExceptions &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyExceptions*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyExceptions *&);
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, const CosPropertyService::MultipleExceptions &); // copying version
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::MultipleExceptions*); // noncopying version
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::MultipleExceptions *&);
extern TAO_ORBSVCS_Export CosPropertyService::PropertySetFactory_ptr (*_TAO_collocation_CosPropertyService_PropertySetFactory_Stub_Factory_function_pointer) (
    CORBA::Object_ptr obj
  );
// Any operators for interface CosPropertyService::PropertySetFactory
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertySetFactory_ptr);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertySetFactory *&);
extern TAO_ORBSVCS_Export CosPropertyService::PropertySetDefFactory_ptr (*_TAO_collocation_CosPropertyService_PropertySetDefFactory_Stub_Factory_function_pointer) (
    CORBA::Object_ptr obj
  );
// Any operators for interface CosPropertyService::PropertySetDefFactory
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertySetDefFactory_ptr);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertySetDefFactory *&);
extern TAO_ORBSVCS_Export CosPropertyService::PropertySet_ptr (*_TAO_collocation_CosPropertyService_PropertySet_Stub_Factory_function_pointer) (
    CORBA::Object_ptr obj
  );
// Any operators for interface CosPropertyService::PropertySet
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertySet_ptr);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertySet *&);
extern TAO_ORBSVCS_Export CosPropertyService::PropertySetDef_ptr (*_TAO_collocation_CosPropertyService_PropertySetDef_Stub_Factory_function_pointer) (
    CORBA::Object_ptr obj
  );
// Any operators for interface CosPropertyService::PropertySetDef
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertySetDef_ptr);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertySetDef *&);
extern TAO_ORBSVCS_Export CosPropertyService::PropertyNamesIterator_ptr (*_TAO_collocation_CosPropertyService_PropertyNamesIterator_Stub_Factory_function_pointer) (
    CORBA::Object_ptr obj
  );
// Any operators for interface CosPropertyService::PropertyNamesIterator
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertyNamesIterator_ptr);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertyNamesIterator *&);
extern TAO_ORBSVCS_Export CosPropertyService::PropertiesIterator_ptr (*_TAO_collocation_CosPropertyService_PropertiesIterator_Stub_Factory_function_pointer) (
    CORBA::Object_ptr obj
  );
// Any operators for interface CosPropertyService::PropertiesIterator
void TAO_ORBSVCS_Export operator<<= (CORBA::Any &, CosPropertyService::PropertiesIterator_ptr);
CORBA::Boolean TAO_ORBSVCS_Export operator>>= (const CORBA::Any &, CosPropertyService::PropertiesIterator *&);

#ifndef __ACE_INLINE__

CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::Property &);
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::Property &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::PropertyModeType &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::PropertyModeType &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::PropertyDef &);
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::PropertyDef &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::PropertyMode &);
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::PropertyMode &);

#if !defined _TAO_CDR_OP_CosPropertyService_PropertyNames_H_
#define _TAO_CDR_OP_CosPropertyService_PropertyNames_H_

CORBA::Boolean TAO_ORBSVCS_Export operator<< (
    TAO_OutputCDR &,
    const CosPropertyService::PropertyNames &
  );
CORBA::Boolean TAO_ORBSVCS_Export operator>> (
    TAO_InputCDR &,
    CosPropertyService::PropertyNames &
  );

#endif /* _TAO_CDR_OP_CosPropertyService_PropertyNames_H_ */


#if !defined _TAO_CDR_OP_CosPropertyService_Properties_H_
#define _TAO_CDR_OP_CosPropertyService_Properties_H_

CORBA::Boolean TAO_ORBSVCS_Export operator<< (
    TAO_OutputCDR &,
    const CosPropertyService::Properties &
  );
CORBA::Boolean TAO_ORBSVCS_Export operator>> (
    TAO_InputCDR &,
    CosPropertyService::Properties &
  );

#endif /* _TAO_CDR_OP_CosPropertyService_Properties_H_ */


#if !defined _TAO_CDR_OP_CosPropertyService_PropertyDefs_H_
#define _TAO_CDR_OP_CosPropertyService_PropertyDefs_H_

CORBA::Boolean TAO_ORBSVCS_Export operator<< (
    TAO_OutputCDR &,
    const CosPropertyService::PropertyDefs &
  );
CORBA::Boolean TAO_ORBSVCS_Export operator>> (
    TAO_InputCDR &,
    CosPropertyService::PropertyDefs &
  );

#endif /* _TAO_CDR_OP_CosPropertyService_PropertyDefs_H_ */


#if !defined _TAO_CDR_OP_CosPropertyService_PropertyModes_H_
#define _TAO_CDR_OP_CosPropertyService_PropertyModes_H_

CORBA::Boolean TAO_ORBSVCS_Export operator<< (
    TAO_OutputCDR &,
    const CosPropertyService::PropertyModes &
  );
CORBA::Boolean TAO_ORBSVCS_Export operator>> (
    TAO_InputCDR &,
    CosPropertyService::PropertyModes &
  );

#endif /* _TAO_CDR_OP_CosPropertyService_PropertyModes_H_ */


#if !defined _TAO_CDR_OP_CosPropertyService_PropertyTypes_H_
#define _TAO_CDR_OP_CosPropertyService_PropertyTypes_H_

CORBA::Boolean TAO_ORBSVCS_Export operator<< (
    TAO_OutputCDR &,
    const CosPropertyService::PropertyTypes &
  );
CORBA::Boolean TAO_ORBSVCS_Export operator>> (
    TAO_InputCDR &,
    CosPropertyService::PropertyTypes &
  );

#endif /* _TAO_CDR_OP_CosPropertyService_PropertyTypes_H_ */

CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::ConstraintNotSupported &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::ConstraintNotSupported &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::InvalidPropertyName &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::InvalidPropertyName &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::ConflictingProperty &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::ConflictingProperty &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::PropertyNotFound &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::PropertyNotFound &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::UnsupportedTypeCode &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::UnsupportedTypeCode &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::UnsupportedProperty &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::UnsupportedProperty &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::UnsupportedMode &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::UnsupportedMode &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::FixedProperty &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::FixedProperty &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::ReadOnlyProperty &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::ReadOnlyProperty &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::ExceptionReason &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::ExceptionReason &);
CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::PropertyException &);
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::PropertyException &);

#if !defined _TAO_CDR_OP_CosPropertyService_PropertyExceptions_H_
#define _TAO_CDR_OP_CosPropertyService_PropertyExceptions_H_

CORBA::Boolean TAO_ORBSVCS_Export operator<< (
    TAO_OutputCDR &,
    const CosPropertyService::PropertyExceptions &
  );
CORBA::Boolean TAO_ORBSVCS_Export operator>> (
    TAO_InputCDR &,
    CosPropertyService::PropertyExceptions &
  );

#endif /* _TAO_CDR_OP_CosPropertyService_PropertyExceptions_H_ */

CORBA::Boolean TAO_ORBSVCS_Export operator<< (TAO_OutputCDR &, const CosPropertyService::MultipleExceptions &); // 
CORBA::Boolean TAO_ORBSVCS_Export operator>> (TAO_InputCDR &, CosPropertyService::MultipleExceptions &);
CORBA::Boolean TAO_ORBSVCS_Export
operator<< (TAO_OutputCDR &, const CosPropertyService::PropertySetFactory_ptr );
CORBA::Boolean TAO_ORBSVCS_Export
operator>> (TAO_InputCDR &, CosPropertyService::PropertySetFactory_ptr &);
CORBA::Boolean TAO_ORBSVCS_Export
operator<< (TAO_OutputCDR &, const CosPropertyService::PropertySetDefFactory_ptr );
CORBA::Boolean TAO_ORBSVCS_Export
operator>> (TAO_InputCDR &, CosPropertyService::PropertySetDefFactory_ptr &);
CORBA::Boolean TAO_ORBSVCS_Export
operator<< (TAO_OutputCDR &, const CosPropertyService::PropertySet_ptr );
CORBA::Boolean TAO_ORBSVCS_Export
operator>> (TAO_InputCDR &, CosPropertyService::PropertySet_ptr &);
CORBA::Boolean TAO_ORBSVCS_Export
operator<< (TAO_OutputCDR &, const CosPropertyService::PropertySetDef_ptr );
CORBA::Boolean TAO_ORBSVCS_Export
operator>> (TAO_InputCDR &, CosPropertyService::PropertySetDef_ptr &);
CORBA::Boolean TAO_ORBSVCS_Export
operator<< (TAO_OutputCDR &, const CosPropertyService::PropertyNamesIterator_ptr );
CORBA::Boolean TAO_ORBSVCS_Export
operator>> (TAO_InputCDR &, CosPropertyService::PropertyNamesIterator_ptr &);
CORBA::Boolean TAO_ORBSVCS_Export
operator<< (TAO_OutputCDR &, const CosPropertyService::PropertiesIterator_ptr );
CORBA::Boolean TAO_ORBSVCS_Export
operator>> (TAO_InputCDR &, CosPropertyService::PropertiesIterator_ptr &);

#endif /* __ACE_INLINE__ */


#if defined (__ACE_INLINE__)
#include "CosPropertyServiceC.i"
#endif /* defined INLINE */

#if defined(_MSC_VER)
#pragma warning(default:4250)
#endif /* _MSC_VER */

#endif /* ifndef */
