/* -*- C++ -*- */

// ******  Code generated by the The ACE ORB (TAO) IDL Compiler *******
// TAO and the TAO IDL Compiler have been developed by the Center for
// Distributed Object Computing at Washington University, St. Louis.
//
// Information about TAO is available at:
//                 http://www.cs.wustl.edu/~schmidt/TAO.html

#ifndef _TAO_IDL_COSPROPERTYSERVICES_H_
#define _TAO_IDL_COSPROPERTYSERVICES_H_

#include "CosPropertyServiceC.h"


#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#if defined(_MSC_VER)
#pragma warning(disable:4250)
#endif /* _MSC_VER */

TAO_NAMESPACE  POA_CosPropertyService
{
  class PropertySetFactory;
  typedef PropertySetFactory *PropertySetFactory_ptr;
  class TAO_ORBSVCS_Export PropertySetFactory :  public virtual PortableServer::ServantBase
  {
  protected:
    PropertySetFactory (void);

  public:
    PropertySetFactory (const PropertySetFactory& rhs);
    virtual ~PropertySetFactory (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    CosPropertyService::PropertySetFactory *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual CosPropertyService::PropertySet_ptr create_propertyset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void create_propertyset_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CosPropertyService::PropertySet_ptr create_constrained_propertyset (
        const CosPropertyService::PropertyTypes & allowed_property_types,
        const CosPropertyService::Properties & allowed_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      )) = 0;

    static void create_constrained_propertyset_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CosPropertyService::PropertySet_ptr create_initial_propertyset (
        const CosPropertyService::Properties & initial_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      )) = 0;

    static void create_initial_propertyset_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETFACTORY___THRU_POA_COLLOCATED_SH_)
#define _COSPROPERTYSERVICE_PROPERTYSETFACTORY___THRU_POA_COLLOCATED_SH_

  class TAO_ORBSVCS_Export _tao_thru_poa_collocated_PropertySetFactory     : public virtual CosPropertyService::PropertySetFactory
  {
  public:
    _tao_thru_poa_collocated_PropertySetFactory (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual CosPropertyService::PropertySet_ptr create_propertyset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CosPropertyService::PropertySet_ptr create_constrained_propertyset (
        const CosPropertyService::PropertyTypes & allowed_property_types,
        const CosPropertyService::Properties & allowed_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      ));

    virtual CosPropertyService::PropertySet_ptr create_initial_propertyset (
        const CosPropertyService::Properties & initial_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class TAO_ORBSVCS_Export PropertySetFactory_tie : public PropertySetFactory
  {
  public:
    PropertySetFactory_tie (T &t);
    // the T& ctor
    PropertySetFactory_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    PropertySetFactory_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    PropertySetFactory_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~PropertySetFactory_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    CosPropertyService::PropertySet_ptr create_propertyset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CosPropertyService::PropertySet_ptr create_constrained_propertyset (
        const CosPropertyService::PropertyTypes & allowed_property_types,
        const CosPropertyService::Properties & allowed_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      ));

    CosPropertyService::PropertySet_ptr create_initial_propertyset (
        const CosPropertyService::Properties & initial_properties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    PropertySetFactory_tie (const PropertySetFactory_tie &);
    void operator= (const PropertySetFactory_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

  class PropertySetDefFactory;
  typedef PropertySetDefFactory *PropertySetDefFactory_ptr;
  class TAO_ORBSVCS_Export PropertySetDefFactory :  public virtual PortableServer::ServantBase
  {
  protected:
    PropertySetDefFactory (void);

  public:
    PropertySetDefFactory (const PropertySetDefFactory& rhs);
    virtual ~PropertySetDefFactory (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    CosPropertyService::PropertySetDefFactory *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual CosPropertyService::PropertySetDef_ptr create_propertysetdef (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void create_propertysetdef_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CosPropertyService::PropertySetDef_ptr create_constrained_propertysetdef (
        const CosPropertyService::PropertyTypes & allowed_property_types,
        const CosPropertyService::PropertyDefs & allowed_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      )) = 0;

    static void create_constrained_propertysetdef_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CosPropertyService::PropertySetDef_ptr create_initial_propertysetdef (
        const CosPropertyService::PropertyDefs & initial_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      )) = 0;

    static void create_initial_propertysetdef_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___THRU_POA_COLLOCATED_SH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEFFACTORY___THRU_POA_COLLOCATED_SH_

  class TAO_ORBSVCS_Export _tao_thru_poa_collocated_PropertySetDefFactory     : public virtual CosPropertyService::PropertySetDefFactory
  {
  public:
    _tao_thru_poa_collocated_PropertySetDefFactory (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual CosPropertyService::PropertySetDef_ptr create_propertysetdef (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CosPropertyService::PropertySetDef_ptr create_constrained_propertysetdef (
        const CosPropertyService::PropertyTypes & allowed_property_types,
        const CosPropertyService::PropertyDefs & allowed_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      ));

    virtual CosPropertyService::PropertySetDef_ptr create_initial_propertysetdef (
        const CosPropertyService::PropertyDefs & initial_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class TAO_ORBSVCS_Export PropertySetDefFactory_tie : public PropertySetDefFactory
  {
  public:
    PropertySetDefFactory_tie (T &t);
    // the T& ctor
    PropertySetDefFactory_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    PropertySetDefFactory_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    PropertySetDefFactory_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~PropertySetDefFactory_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    CosPropertyService::PropertySetDef_ptr create_propertysetdef (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CosPropertyService::PropertySetDef_ptr create_constrained_propertysetdef (
        const CosPropertyService::PropertyTypes & allowed_property_types,
        const CosPropertyService::PropertyDefs & allowed_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::ConstraintNotSupported
      ));

    CosPropertyService::PropertySetDef_ptr create_initial_propertysetdef (
        const CosPropertyService::PropertyDefs & initial_property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    PropertySetDefFactory_tie (const PropertySetDefFactory_tie &);
    void operator= (const PropertySetDefFactory_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

  class PropertySet;
  typedef PropertySet *PropertySet_ptr;
  class TAO_ORBSVCS_Export PropertySet :  public virtual PortableServer::ServantBase
  {
  protected:
    PropertySet (void);

  public:
    PropertySet (const PropertySet& rhs);
    virtual ~PropertySet (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    CosPropertyService::PropertySet *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual void define_property (
        const char * property_name,
        const CORBA::Any & property_value,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::ReadOnlyProperty
      )) = 0;

    static void define_property_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void define_properties (
        const CosPropertyService::Properties & nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      )) = 0;

    static void define_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::ULong get_number_of_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_number_of_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void get_all_property_names (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CosPropertyService::PropertyNamesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_all_property_names_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Any * get_property_value (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      )) = 0;

    static void get_property_value_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean get_properties (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void get_all_properties (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CosPropertyService::PropertiesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_all_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void delete_property (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::FixedProperty
      )) = 0;

    static void delete_property_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void delete_properties (
        const CosPropertyService::PropertyNames & property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      )) = 0;

    static void delete_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean delete_all_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void delete_all_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean is_property_defined (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName
      )) = 0;

    static void is_property_defined_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_COSPROPERTYSERVICE_PROPERTYSET___THRU_POA_COLLOCATED_SH_)
#define _COSPROPERTYSERVICE_PROPERTYSET___THRU_POA_COLLOCATED_SH_

  class TAO_ORBSVCS_Export _tao_thru_poa_collocated_PropertySet     : public virtual CosPropertyService::PropertySet
  {
  public:
    _tao_thru_poa_collocated_PropertySet (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual void define_property (
        const char * property_name,
        const CORBA::Any & property_value,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::ReadOnlyProperty
      ));

    virtual void define_properties (
        const CosPropertyService::Properties & nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::ULong get_number_of_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void get_all_property_names (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CosPropertyService::PropertyNamesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Any * get_property_value (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    virtual CORBA::Boolean get_properties (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void get_all_properties (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CosPropertyService::PropertiesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void delete_property (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::FixedProperty
      ));

    virtual void delete_properties (
        const CosPropertyService::PropertyNames & property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CORBA::Boolean delete_all_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean is_property_defined (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class TAO_ORBSVCS_Export PropertySet_tie : public PropertySet
  {
  public:
    PropertySet_tie (T &t);
    // the T& ctor
    PropertySet_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    PropertySet_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    PropertySet_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~PropertySet_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    void define_property (
        const char * property_name,
        const CORBA::Any & property_value,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::ReadOnlyProperty
      ));

    void define_properties (
        const CosPropertyService::Properties & nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    CORBA::ULong get_number_of_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void get_all_property_names (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CosPropertyService::PropertyNamesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Any * get_property_value (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    CORBA::Boolean get_properties (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void get_all_properties (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CosPropertyService::PropertiesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void delete_property (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::FixedProperty
      ));

    void delete_properties (
        const CosPropertyService::PropertyNames & property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    CORBA::Boolean delete_all_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Boolean is_property_defined (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    PropertySet_tie (const PropertySet_tie &);
    void operator= (const PropertySet_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

  class PropertySetDef;
  typedef PropertySetDef *PropertySetDef_ptr;
  class TAO_ORBSVCS_Export PropertySetDef : public virtual PropertySet
  {
  protected:
    PropertySetDef (void);

  public:
    PropertySetDef (const PropertySetDef& rhs);
    virtual ~PropertySetDef (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    CosPropertyService::PropertySetDef *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual void get_allowed_property_types (
        CosPropertyService::PropertyTypes_out property_types,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_allowed_property_types_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void get_allowed_properties (
        CosPropertyService::PropertyDefs_out property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_allowed_properties_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void define_property_with_mode (
        const char * property_name,
        const CORBA::Any & property_value,
        CosPropertyService::PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::UnsupportedMode,
        CosPropertyService::ReadOnlyProperty
      )) = 0;

    static void define_property_with_mode_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void define_properties_with_modes (
        const CosPropertyService::PropertyDefs & property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      )) = 0;

    static void define_properties_with_modes_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CosPropertyService::PropertyModeType get_property_mode (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      )) = 0;

    static void get_property_mode_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean get_property_modes (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::PropertyModes_out property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void get_property_modes_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void set_property_mode (
        const char * property_name,
        CosPropertyService::PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::UnsupportedMode
      )) = 0;

    static void set_property_mode_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void set_property_modes (
        const CosPropertyService::PropertyModes & property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      )) = 0;

    static void set_property_modes_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void define_property_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void define_properties_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void get_number_of_properties_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void get_all_property_names_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void get_property_value_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void get_properties_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void get_all_properties_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void delete_property_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void delete_properties_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void delete_all_properties_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );

    static void is_property_defined_skel (
        CORBA::ServerRequest &req, 
        void *obj,
        void *context,
        CORBA::Environment &env =
          TAO_default_environment ()
      );


  };


#if !defined (_COSPROPERTYSERVICE_PROPERTYSETDEF___THRU_POA_COLLOCATED_SH_)
#define _COSPROPERTYSERVICE_PROPERTYSETDEF___THRU_POA_COLLOCATED_SH_

  class TAO_ORBSVCS_Export _tao_thru_poa_collocated_PropertySetDef     : public virtual CosPropertyService::PropertySetDef,
      public virtual _tao_thru_poa_collocated_PropertySet
  {
  public:
    _tao_thru_poa_collocated_PropertySetDef (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual void get_allowed_property_types (
        CosPropertyService::PropertyTypes_out property_types,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void get_allowed_properties (
        CosPropertyService::PropertyDefs_out property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void define_property_with_mode (
        const char * property_name,
        const CORBA::Any & property_value,
        CosPropertyService::PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::UnsupportedMode,
        CosPropertyService::ReadOnlyProperty
      ));

    virtual void define_properties_with_modes (
        const CosPropertyService::PropertyDefs & property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    virtual CosPropertyService::PropertyModeType get_property_mode (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    virtual CORBA::Boolean get_property_modes (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::PropertyModes_out property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void set_property_mode (
        const char * property_name,
        CosPropertyService::PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::UnsupportedMode
      ));

    virtual void set_property_modes (
        const CosPropertyService::PropertyModes & property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class TAO_ORBSVCS_Export PropertySetDef_tie : public PropertySetDef
  {
  public:
    PropertySetDef_tie (T &t);
    // the T& ctor
    PropertySetDef_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    PropertySetDef_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    PropertySetDef_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~PropertySetDef_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    void get_allowed_property_types (
        CosPropertyService::PropertyTypes_out property_types,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void get_allowed_properties (
        CosPropertyService::PropertyDefs_out property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void define_property_with_mode (
        const char * property_name,
        const CORBA::Any & property_value,
        CosPropertyService::PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::UnsupportedMode,
        CosPropertyService::ReadOnlyProperty
      ));

    void define_properties_with_modes (
        const CosPropertyService::PropertyDefs & property_defs,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    CosPropertyService::PropertyModeType get_property_mode (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    CORBA::Boolean get_property_modes (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::PropertyModes_out property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void set_property_mode (
        const char * property_name,
        CosPropertyService::PropertyModeType property_mode,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::UnsupportedMode
      ));

    void set_property_modes (
        const CosPropertyService::PropertyModes & property_modes,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    void define_property (
        const char * property_name,
        const CORBA::Any & property_value,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::ConflictingProperty,
        CosPropertyService::UnsupportedTypeCode,
        CosPropertyService::UnsupportedProperty,
        CosPropertyService::ReadOnlyProperty
      ));

    void define_properties (
        const CosPropertyService::Properties & nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    CORBA::ULong get_number_of_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void get_all_property_names (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CosPropertyService::PropertyNamesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Any * get_property_value (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName
      ));

    CORBA::Boolean get_properties (
        const CosPropertyService::PropertyNames & property_names,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void get_all_properties (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CosPropertyService::PropertiesIterator_out rest,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void delete_property (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::PropertyNotFound,
        CosPropertyService::InvalidPropertyName,
        CosPropertyService::FixedProperty
      ));

    void delete_properties (
        const CosPropertyService::PropertyNames & property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::MultipleExceptions
      ));

    CORBA::Boolean delete_all_properties (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Boolean is_property_defined (
        const char * property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException,
        CosPropertyService::InvalidPropertyName
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    PropertySetDef_tie (const PropertySetDef_tie &);
    void operator= (const PropertySetDef_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

  class PropertyNamesIterator;
  typedef PropertyNamesIterator *PropertyNamesIterator_ptr;
  class TAO_ORBSVCS_Export PropertyNamesIterator :  public virtual PortableServer::ServantBase
  {
  protected:
    PropertyNamesIterator (void);

  public:
    PropertyNamesIterator (const PropertyNamesIterator& rhs);
    virtual ~PropertyNamesIterator (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    CosPropertyService::PropertyNamesIterator *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void reset_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean next_one (
        CORBA::String_out property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void next_one_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean next_n (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void next_n_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void destroy_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___THRU_POA_COLLOCATED_SH_)
#define _COSPROPERTYSERVICE_PROPERTYNAMESITERATOR___THRU_POA_COLLOCATED_SH_

  class TAO_ORBSVCS_Export _tao_thru_poa_collocated_PropertyNamesIterator     : public virtual CosPropertyService::PropertyNamesIterator
  {
  public:
    _tao_thru_poa_collocated_PropertyNamesIterator (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_one (
        CORBA::String_out property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_n (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class TAO_ORBSVCS_Export PropertyNamesIterator_tie : public PropertyNamesIterator
  {
  public:
    PropertyNamesIterator_tie (T &t);
    // the T& ctor
    PropertyNamesIterator_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    PropertyNamesIterator_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    PropertyNamesIterator_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~PropertyNamesIterator_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Boolean next_one (
        CORBA::String_out property_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Boolean next_n (
        CORBA::ULong how_many,
        CosPropertyService::PropertyNames_out property_names,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    PropertyNamesIterator_tie (const PropertyNamesIterator_tie &);
    void operator= (const PropertyNamesIterator_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

  class PropertiesIterator;
  typedef PropertiesIterator *PropertiesIterator_ptr;
  class TAO_ORBSVCS_Export PropertiesIterator :  public virtual PortableServer::ServantBase
  {
  protected:
    PropertiesIterator (void);

  public:
    PropertiesIterator (const PropertiesIterator& rhs);
    virtual ~PropertiesIterator (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    CosPropertyService::PropertiesIterator *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void reset_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean next_one (
        CosPropertyService::Property_out aproperty,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void next_one_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual CORBA::Boolean next_n (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void next_n_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void destroy_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_COSPROPERTYSERVICE_PROPERTIESITERATOR___THRU_POA_COLLOCATED_SH_)
#define _COSPROPERTYSERVICE_PROPERTIESITERATOR___THRU_POA_COLLOCATED_SH_

  class TAO_ORBSVCS_Export _tao_thru_poa_collocated_PropertiesIterator     : public virtual CosPropertyService::PropertiesIterator
  {
  public:
    _tao_thru_poa_collocated_PropertiesIterator (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_one (
        CosPropertyService::Property_out aproperty,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual CORBA::Boolean next_n (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class TAO_ORBSVCS_Export PropertiesIterator_tie : public PropertiesIterator
  {
  public:
    PropertiesIterator_tie (T &t);
    // the T& ctor
    PropertiesIterator_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    PropertiesIterator_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    PropertiesIterator_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~PropertiesIterator_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    void reset (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Boolean next_one (
        CosPropertyService::Property_out aproperty,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    CORBA::Boolean next_n (
        CORBA::ULong how_many,
        CosPropertyService::Properties_out nproperties,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void destroy (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    PropertiesIterator_tie (const PropertiesIterator_tie &);
    void operator= (const PropertiesIterator_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

};

#include "CosPropertyServiceS_T.h"

#if defined (__ACE_INLINE__)
#include "CosPropertyServiceS.i"
#endif /* defined INLINE */

#if defined(_MSC_VER)
#pragma warning(default:4250)
#endif /* _MSC_VER */

#endif /* ifndef */
