/******************************************************************************
*                                                                             *
*  File: SimpleEvent.h                                                        *
*                                                                             *
*  Description: An concrete class for representing simple events.             *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.2 $

   $Log: SimpleEvent.h,v $
   Revision 1.1.1.2  2000/09/30 16:06:35  yamane
   Patches for Windows

   Revision 1.1.1.1  1999/10/12 00:43:29  f-kon
   Version compatible with TAO 1.0

   Revision 1.1.1.1  1999/04/01 18:16:36  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.3  1999/02/22 22:20:44  f-kon
   Introduced NiceConfigurator and LockingConfigurator and performed several
   fixes on dynamic reconfiguration.

   Revision 1.2  1999/01/26 18:22:20  mroman
   DomainConfigurator running on Windows NT

   Revision 1.1  1999/01/07 22:43:18  f-kon
   Added TAOConfigurator and new DCP commands

******************************************************************************/

#include "ComponentEvent.h"

class SIMPLECONF_2K_Export SimpleEvent : public ComponentEvent {
  private:   
    /* A message that describes the event in more detail. */
    char *description_;
    /* The event type. */
    int type_;
    
  public:
    SimpleEvent (int type, const char *description = 0);
    ~SimpleEvent ();

    inline int type () const { return type_;}
  
    /* Converts the event into a String.
     * @return a string describing the event.
     */
    const char *toString() const;
};
