#if !defined(_DynamicConfigurator_h__)
#define		 _DynamicConfigurator_h__

#include "tao/corba.h"

#include "dynamicConfiguratorS.h"
#include "dynamicTAO/src/ace/ACE_Persistent_Repository.h"

#include "dynamicConfigurator_export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

class DYNCONF_2K_Export DynamicConfigurator_i: public POA_DynamicConfigurator 
{
private:
	ACE_Persistent_Repository *dc_pers_rep_;

	int count_strings(const char *buf);
	void copy_to_string(const char *buf,char **dyn_arr);

public:

	static const int MAX_STRINGS;
	static const int MAX_BUFFER;

	DynamicConfigurator_i();
	~DynamicConfigurator_i(void);

  virtual DynamicConfigurator::stringList * list_categories (CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual DynamicConfigurator::stringList * list_implementations (const char * categoryName,
                                                                  CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));

  virtual CORBA::Boolean have_implementation (const char * categoryName,
                                              const char * impName,
                                              CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual DynamicConfigurator::stringList * list_loaded_implementations (CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException
    ));
  
  virtual char * get_impl_info (const char * implName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual DynamicConfigurator::stringList * list_domain_components (CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException
    ));
  
  virtual DynamicConfigurator::stringList * list_hooks (const char * componentName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));

  
  virtual char * get_comp_info (const char * componentName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual CORBA::Long load_implementation (const char * categoryName, 
                                           const char * impName, 
                                           const char * params,     
                                           TwoK::Configuration::CCFactory_ptr factory,
                                           TwoK::Configuration::ComponentConfigurator_out cc, 
                                           CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual void hook_implementation (const char * impName,
                                    const char * componentName,
                                    const char * hookName,
                                    CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));

  virtual void suspend_implementation (const char * impName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual void resume_implementation (const char * impName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual void remove_implementation (const char * impName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual void configure_implementation (const char * impName, const char * message, CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual char * get_hooked_comp (const char * componentName,const char * hookName,CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual void upload_implementation (const char * categoryName, const char * impName, const DynamicConfigurator::implCode &binCode, CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
  
  virtual void delete_implementation (const char * categoryName, const char * impName, CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));

  virtual void download_implementation (const char * categoryName, char *& impName, DynamicConfigurator::implCode_out binCode, CORBA::Environment &ACE_TRY_ENV )
    ACE_THROW_SPEC ((
      CORBA::SystemException,
      DynamicConfigurator::SERVICE_ERROR
    ));
};


#endif

