#if !defined(_DynamicConfigurator_h__)
#define		 _DynamicConfigurator_h__

#include "tao/corba.h"

#include "dynamicConfiguratorS_.h"
#include "dynamicTAO/src/ace/ACE_Persistent_Repository.h"

class DynamicTAO_Export DynamicConfigurator_i: public POA_DynamicConfigurator 
{
private:
	ACE_Persistent_Repository *dc_pers_rep_;

	int count_strings(const char *buf);
	void copy_to_string(const char *buf,char **dyn_arr);

public:

	static const int MAX_STRINGS;
	static const int MAX_BUFFER;

	DynamicConfigurator_i();
	~DynamicConfigurator_i(void);

  virtual DynamicConfigurator::stringList * list_categories (CORBA::Environment &_tao_environment);
  
  virtual DynamicConfigurator::stringList * list_implementations (const char * categoryName,CORBA::Environment &_tao_environment);
  
  virtual DynamicConfigurator::stringList * list_loaded_implementations (CORBA::Environment &_tao_environment);
  
  virtual char * get_impl_info (const char * implName,CORBA::Environment &_tao_environment);
  
  virtual DynamicConfigurator::stringList * list_domain_components (CORBA::Environment &_tao_environment);
  
  virtual DynamicConfigurator::stringList * list_hooks (const char * componentName,CORBA::Environment &_tao_environment);
  
  virtual char * get_comp_info (const char * componentName,CORBA::Environment &_tao_environment);
  
  virtual void load_implementation (const char * categoryName, const char * impName, const char * params, CORBA::Environment &_tao_environment);
  
  virtual void hook_implementation (const char * impName,const char * componentName,const char * hookName,CORBA::Environment &_tao_environment);

  virtual void suspend_implementation (const char * impName,CORBA::Environment &_tao_environment);
  
  virtual void resume_implementation (const char * impName,CORBA::Environment &_tao_environment);
  
  virtual void remove_implementation (const char * impName,CORBA::Environment &_tao_environment);
  
  virtual void configure_implementation (const char * impName, const char * message, CORBA::Environment &_tao_environment);
  
  virtual char * get_hooked_comp (const char * componentName,const char * hookName,CORBA::Environment &_tao_environment);
  
  virtual DynamicConfigurator::stringList * get_usage (const char * request,CORBA::Environment &_tao_environment);

  virtual void upload_implementation (const char * categoryName, const char * impName, const DynamicConfigurator::implCode &binCode, CORBA::Environment &_tao_environment);
  
  virtual void delete_implementation (const char * categoryName, const char * impName, CORBA::Environment &_tao_environment);
};


#endif
