/******************************************************************************
*                                                                             *
*  File: client_i.h                                                           *
*                                                                             *
*  Description: A test client for the ComponentConfigurator object.           *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1.1.1 $
 $Log: client_i.h,v $
 Revision 1.1.1.1  1999/10/12 00:43:29  f-kon
 Version compatible with TAO 1.0

 Revision 1.1.1.1  1999/09/22 04:51:47  yamane
 Adding MonitoringService

 Revision 1.1  1999/02/22 22:29:15  f-kon
 *** empty log message ***


******************************************************************************/
#ifndef HELLO_CLIENT_I_H
#define HELLO_CLIENT_I_H

#include "ace/Get_Opt.h"
//#include "ace/Profile_Timer.h"
#include "tao/corba.h"

#include "helloC.h"

#include "results.h"

class HelloClient
{
public:
  // = Constructor and destructor.
  HelloClient (void);
  ~HelloClient (void);

  void run ();
  // Execute client example code.

  int init (int argc, char **argv);
  // Initialize the client communication endpoint with server.

  void fini ();
  // Shuts down the local ORB.

private:
  int read_ior (char *filename);
  // Function to read the cc factory ior from a file.

  int parse_args (void);
  // Parses the arguments passed on the command line.

  int argc_;
  // # of arguments on the command line.

  char **argv_;
  // arguments from command line.

  char *hello_key_;
  // Key of hello obj ref.

  hello_var hello_;
  // hello pointer.

  CORBA::Environment env_;
  // Environment variable.

  CORBA::ORB_var orb_;
  // Remember our orb.

  ACE_HANDLE f_handle_;
  // File handle to read the IOR.

  Results results_;

};

#endif
