/******************************************************************************
*                                                                             *
*  File: server.cpp                                                           *
*                                                                             *
*  Description: A test server for the Hello object.                           *
*               Based on the TAO Cubit example.                               *
*                                                                             *

******************************************************************************/

#include "server_i.h"

int
main (int argc, char *argv[])
{
  HelloServer helloServ;

  ACE_DEBUG ((LM_DEBUG,
              "\n\tTest:SERVER\n\n"));
  TAO_TRY
    {
      if (helloServ.init (argc, argv, TAO_TRY_ENV) == -1)
        return 1;
      else
        {
          helloServ.run (TAO_TRY_ENV);
          TAO_CHECK_ENV;
        }
    }
  TAO_CATCH (CORBA::SystemException, sysex)
    {
      ACE_UNUSED_ARG (sysex);
      TAO_TRY_ENV.print_exception ("System Exception");
      return -1;
    }
  TAO_CATCH (CORBA::UserException, userex)
    {
      ACE_UNUSED_ARG (userex);
      TAO_TRY_ENV.print_exception ("User Exception");
      return -1;
    }
  TAO_ENDTRY;
  return 0;
}
