/******************************************************************************
*                                                                             *
*  File: server_i.h                                                           *
*                                                                             *
*  Description: A test server for the Hello World experiment.                 *
*               Based on the TAO Cubit example.                               *
*                                                                             *
*  Project: 2K - Automatic Configuration                                      *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************
 Revision Control Information
 $Revision: 1.1.1.1 $
 $Log: server_i.h,v $
 Revision 1.1.1.1  1999/10/12 00:43:29  f-kon
 Version compatible with TAO 1.0

 Revision 1.1.1.1  1999/09/22 04:51:47  yamane
 Adding MonitoringService

 Revision 1.1  1999/02/22 22:29:16  f-kon
 *** empty log message ***


******************************************************************************/

#if !defined (CC_SERVER_I_H)
#define CC_SERVER_I_H

#include "ace/Get_Opt.h"
#include "tao/TAO.h"

#include "hello_i.h"

class HelloServer
{
public:
  // = Initialization and termination methods.
  HelloServer (void);
  // Default constructor

  ~HelloServer (void);
  // Destructor

  int init (int argc,
            char **argv,
	    CORBA::Environment& env);

  int run (CORBA::Environment& env);
  // Run the orb 

private:
  int parse_args (void);
  // Parses the commandline arguments.

  FILE* ior_output_file_;
  // File to output the cubit factory IOR.

  TAO_ORB_Manager orb_manager_;
  // The ORB manager.

  hello_i *hello_impl_;

  int argc_;
  // Number of commandline arguments.

  char **argv_;
  // commandline arguments.
};

#endif /* _C_SERVER_H */
