//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Date_Entry.cpp
//
// DESCRIPTION:
//      This class implements one entry which contains information about
//      one method call.
// 
//***************************************************************************


#include "Data_Entry.h"

// Constructor
Data_Entry::Data_Entry()
{
  OP_NAME = "";
  TIME_STAMP = 0;
  DELAY = 0;
  CLIENT_IP = "";
}

// Constructor
Data_Entry::Data_Entry (char* op_name, CORBA::ULong time_stamp,
	      CORBA::ULong delay, char* client_ip)
{  
  //ACE_OS::printf("In Data_Entry::Data_Entry(...)  \n");
  OP_NAME = op_name;
  TIME_STAMP = time_stamp;
  DELAY = delay;
  CLIENT_IP = client_ip;
}

// Constructor
Data_Entry::Data_Entry(Data_Entry* e)
{
  //ACE_OS::printf("In Data_Entry::Data_Entry(Data_Entry*)  \n");
  OP_NAME = ACE_OS::strdup(e->getOpname());
  TIME_STAMP = e->getTimestamp();
  DELAY = e->getDelay();
  CLIENT_IP = e->getClientIP();
  //ACE_OS::printf("end of data_entry\n");
}

// Copy one entry into another entry
void Data_Entry::copy(Data_Entry* e)
{
  //ACE_OS::printf("In Data_Entry::copy()\n");
  OP_NAME = ACE_OS::strdup(e->getOpname());
  TIME_STAMP = e->getTimestamp();
  DELAY = e->getDelay();
  CLIENT_IP = ACE_OS::strdup(e->getClientIP());
  //ACE_OS::printf("After copy, (%s) (%d) (%d) (%s)\n", OP_NAME, TIME_STAMP, DELAY, CLIENT_IP);
}

Data_Entry::~Data_Entry()
{
  //ACE_OS::printf("Data_Entry::~Data_Entry()\n");
  delete OP_NAME;
  delete CLIENT_IP;
}

// dump to a string
char* Data_Entry::toString()
{
  //ACE_OS::printf("In Data_Entry::toString().\n");
  static char result[100];

  ACE_OS::sprintf(result, "%s %s %d %d", OP_NAME, CLIENT_IP, 
		  TIME_STAMP, DELAY);
  return result;
}


