//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Date_Entry.h
//
// DESCRIPTION:
//      This class implements one entry which contains information about
//      one method call.
// 
//***************************************************************************

#ifndef DATA_ENTRY_H
#define DATA_ENTRY_H

#include "tao/corba.h"

class Data_Entry
{
public:
  // Constructors
  Data_Entry ();
  Data_Entry (char* op_name, CORBA::ULong time_stamp,
	      CORBA::ULong delay, char* client_ip);
  Data_Entry (Data_Entry* e);
  
  ~Data_Entry ();

  // Copy operator
  void  copy(Data_Entry *e);

  // Returns the string which contains all the fields in the entry
  char* toString();

  // Return operation name
  char* getOpname() { return OP_NAME; }
  // Return time stamp
  CORBA::ULong getTimestamp() { return TIME_STAMP; }
  // Return delay
  CORBA::ULong getDelay() { return DELAY; }
  // Return client machine ip
  char* getClientIP() { return CLIENT_IP; }

private:
  char* OP_NAME;
  CORBA::ULong TIME_STAMP;
  CORBA::ULong DELAY;  // in microseconds
  char* CLIENT_IP;
};

#endif

