//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Date_EntryList.h
//
// DESCRIPTION:
//      This class implements a list of entries which contain information about
//      method calls on a particular object.
// 
//***************************************************************************

#ifndef DATA_ENTRYLIST_H
#define DATA_ENTRYLIST_H

#include "Data_Entry.h"

class Data_EntryList
{
public:
  // Constructors
  Data_EntryList ();
  Data_EntryList (int size);
  Data_EntryList (char* name);
  Data_EntryList (char* name, int size);
  ~Data_EntryList ();

  // reset the object name
  void reset(char* name);

  // insert an entry into the list
  int insertEntry(Data_Entry* d);

  // Get the number of entries in the list.
  int getCount();

  // Get the maximum size of the list.
  int getSize();

  // Returns the object name for the list
  char* getObjName();

  // Dump to file all the entries in this list
  void dump(FILE* fd);

  // Check if it is over the water_mark.
  int over_water_mark(int watermark);

private:
  char* ob_name;
  int numofEntry;
  int sizeoflist;
  Data_Entry* entries;
};

#endif

