//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Date_Manager.cpp
//
// DESCRIPTION:
//      This class implements the data manager that takes care of the
//      information being sent from the interceptor.
// 
//***************************************************************************

#include "Data_Manager.h"

// Constructor
Data_Manager::Data_Manager()
{
  entryCount = 0;
  objCount = 0;
  size = 120;
  buffer = new Data_EntryList[120];
  filename = (char *) "default.log";
}

// Constructor
Data_Manager::Data_Manager(int s)
{
  entryCount = 0;
  objCount = 0;
  size = s;
  buffer = new Data_EntryList[s];  
  filename = (char *) "default.log";
}
  

Data_Manager::~Data_Manager()
{
  //ACE_OS::printf("Data_Manager::~Data_Manager()\n");
  //for (int i=0; i<objCount; i++)
  //  delete buffer[i];
  delete [] buffer;
}

// Find the index of the object name
int Data_Manager::find(char* name)
{
  //ACE_OS::printf("In Data_Manager::find(). Looking for %s %d\n", name, objCount);
  for (int i=0; i<objCount; i++)
    if (!strcmp(buffer[i].getObjName(), name))
      return i;
  return -1;
}

// Insert an new entry into the storage buffer
void Data_Manager::insertNewEntry(char* ob_name, Data_Entry* e)
{ 
  //ACE_OS::printf("Data_Manager::insertNewEntry().\n");
  int index = find(ob_name);
  //ACE_OS::printf("<<index is %d>>\n",index);
  if (index>=0)
    {
      //ACE_OS::printf("++++++old one.\n");
      buffer[index].insertEntry(e);
      entryCount++;
    }
  else
    {
      //ACE_OS::printf("------new one. objCount is %d \n", objCount);
      buffer[objCount].reset(ob_name);
      buffer[objCount].insertEntry(e);
      objCount++;
      entryCount++;
    }
}

// Dump the storage server to file
void Data_Manager::dumpToFile()
{
  //ACE_OS::printf("Data_Manager::dumpToFile().\n");
  ACE_OS::printf("<STORAGE> Dumping data to file.\n");
  for (int i=0; i<objCount; i++)
    {
      filename[0]='\0';
      ACE_OS::strcpy(filename, "OBJ/");
      ACE_OS::strcat(filename, ACE_OS::strdup(buffer[i].getObjName()));
      ACE_OS::strcat(filename, ".log");
      fd = fopen(filename, "a");
      buffer[i].dump(fd);
      fclose(fd);
    }
  objCount=0;
}

// Check if it has reached the water_mark.
int Data_Manager::over_water_mark(char *objname, int watermark)
{
  //ACE_OS::printf("in Data_Manager::over_water_mark().\n");
  int index = find(objname);
  //  ACE_OS::printf(">>>>index is %d\n", index);
  if (index>=0)
    return buffer[index].over_water_mark(watermark);
  else
    return -1;
}
      
