//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Date_Manager.h
//
// DESCRIPTION:
//      This class implements the data manager that takes care of the 
//      the information being sent from the interceptor.
// 
//***************************************************************************

#ifndef STORAGEMANAGER_H
#define STORAGEMANAGER_H

#include "Data_EntryList.h"
#include "tao/corba.h"
  
class Data_Manager
{
public:
  // Constructors
  Data_Manager ();
  Data_Manager (int size);
  ~Data_Manager ();
  
  // Insert a new entry for a object into the storage buffer
  void insertNewEntry(char* ob_name, Data_Entry* e);
  // Dump the storage buffer to file
  void dumpToFile();
  // Get how many objects are in the storage buffer
  int getObjCount() { return objCount; }
  // Get total number of entries in the storage buffer
  int getEntryCount() { return entryCount; }
  // Get maximum size of buffer for each object
  int getSize() { return size; }
  // Check to see if the water_mark has been reached.
  int over_water_mark(char* objname, int watermark);
  
private:

  // find the index of a particular object name in the buffer
  int find(char* ob_name);

  int objCount;

  Data_EntryList* buffer;

  int entryCount;

  int size;

  char* filename; 

  FILE* fd;

};

#endif

