/* -*- C++ -*- */

// ******  Code generated by the The ACE ORB (TAO) IDL Compiler *******
// TAO and the TAO IDL Compiler have been developed by the Center for
// Distributed Object Computing at Washington University, St. Louis.
//
// Information about TAO is available at:
//                 http://www.cs.wustl.edu/~schmidt/TAO.html

#ifndef _TAO_IDL_STORAGES_H_
#define _TAO_IDL_STORAGES_H_

#include "StorageC.h"


#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#if defined(_MSC_VER)
#pragma warning(disable:4250)
#endif /* _MSC_VER */

TAO_NAMESPACE  POA_M_STORAGE
{
  class Storage;
  typedef Storage *Storage_ptr;
  class  Storage :  public virtual PortableServer::ServantBase
  {
  protected:
    Storage (void);

  public:
    Storage (const Storage& rhs);
    virtual ~Storage (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    M_STORAGE::Storage *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual void add_single_entry (
        const M_STORAGE::entry & e,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void add_single_entry_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void add_multiple_entries (
        const M_STORAGE::entrySeq & es,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void add_multiple_entries_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void set_water_mark (
        CORBA::UShort m,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void set_water_mark_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_M_STORAGE_STORAGE___THRU_POA_COLLOCATED_SH_)
#define _M_STORAGE_STORAGE___THRU_POA_COLLOCATED_SH_

  class  _tao_thru_poa_collocated_Storage     : public virtual M_STORAGE::Storage
  {
  public:
    _tao_thru_poa_collocated_Storage (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual void add_single_entry (
        const M_STORAGE::entry & e,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void add_multiple_entries (
        const M_STORAGE::entrySeq & es,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual void set_water_mark (
        CORBA::UShort m,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  Storage_tie : public Storage
  {
  public:
    Storage_tie (T &t);
    // the T& ctor
    Storage_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    Storage_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    Storage_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~Storage_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    void add_single_entry (
        const M_STORAGE::entry & e,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void add_multiple_entries (
        const M_STORAGE::entrySeq & es,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    void set_water_mark (
        CORBA::UShort m,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    Storage_tie (const Storage_tie &);
    void operator= (const Storage_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

  class QueryInfo;
  typedef QueryInfo *QueryInfo_ptr;
  class  QueryInfo :  public virtual PortableServer::ServantBase
  {
  protected:
    QueryInfo (void);

  public:
    QueryInfo (const QueryInfo& rhs);
    virtual ~QueryInfo (void);


    virtual CORBA::Boolean _is_a (
        const char* logical_type_id,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void* _downcast (
        const char* logical_type_id
      );

    static void _is_a_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    static void _non_existent_skel (
        CORBA::ServerRequest &req,
        void *obj,
        void *context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual void _dispatch (
        CORBA::ServerRequest &_tao_req,
        void *_tao_context,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    M_STORAGE::QueryInfo *_this (
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual const char* _interface_repository_id (void) const;

    virtual M_STORAGE::ReturnInfo * query_num_calls_1 (
        const char * ob_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_num_calls_1_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_num_calls_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_num_calls_2_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_last_delay (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_last_delay_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_last_delay_from (
        const char * ob_name,
        const char * op_name,
        const char * ip,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_last_delay_from_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_average_delay (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_average_delay_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_mr_client_machine_1 (
        const char * ob_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_mr_client_machine_1_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_mr_client_machine_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_mr_client_machine_2_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_all_client_machines (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_all_client_machines_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_last_timestamp_1 (
        const char * ob_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_last_timestamp_1_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_last_timestamp_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_last_timestamp_2_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_average_delay_from_1 (
        const char * ob_name,
        const char * ip,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_average_delay_from_1_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );

    virtual M_STORAGE::ReturnInfo * query_average_delay_from_2 (
        const char * ob_name,
        const char * op_name,
        const char * ip,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      )) = 0;

    static void query_average_delay_from_2_skel (
        CORBA::ServerRequest &_tao_req, 
        void *_tao_obj, 
        void *_tao_context, 
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      );


  };


#if !defined (_M_STORAGE_QUERYINFO___THRU_POA_COLLOCATED_SH_)
#define _M_STORAGE_QUERYINFO___THRU_POA_COLLOCATED_SH_

  class  _tao_thru_poa_collocated_QueryInfo     : public virtual M_STORAGE::QueryInfo
  {
  public:
    _tao_thru_poa_collocated_QueryInfo (
        TAO_Stub *stub
      );
    virtual CORBA::Boolean _is_a(
        const CORBA::Char *logical_type_id,
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
    virtual CORBA::Boolean _non_existent(
        CORBA_Environment &ACE_TRY_ENV = TAO_default_environment ()
      );
    
        virtual M_STORAGE::ReturnInfo * query_num_calls_1 (
        const char * ob_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_num_calls_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_last_delay (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_last_delay_from (
        const char * ob_name,
        const char * op_name,
        const char * ip,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_average_delay (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_mr_client_machine_1 (
        const char * ob_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_mr_client_machine_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_all_client_machines (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_last_timestamp_1 (
        const char * ob_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_last_timestamp_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_average_delay_from_1 (
        const char * ob_name,
        const char * ip,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    virtual M_STORAGE::ReturnInfo * query_average_delay_from_2 (
        const char * ob_name,
        const char * op_name,
        const char * ip,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

  };


#endif /* end #if !defined */

  
#if defined (ACE_HAS_USING_KEYWORD)
  // TIE class: Refer to CORBA v2.2, Section 20.34.4
  template <class T>
  class  QueryInfo_tie : public QueryInfo
  {
  public:
    QueryInfo_tie (T &t);
    // the T& ctor
    QueryInfo_tie (T &t, PortableServer::POA_ptr poa);
    // ctor taking a POA
    QueryInfo_tie (T *tp, CORBA::Boolean release=1);
    // ctor taking pointer and an ownership flag
    QueryInfo_tie (T *tp, PortableServer::POA_ptr poa, CORBA::Boolean release=1);
    // ctor with T*, ownership flag and a POA
    ~QueryInfo_tie (void);
    // dtor
    
    // TIE specific functions
    T *_tied_object (void);
    // return the underlying object
    void _tied_object (T &obj);
    // set the underlying object
    void _tied_object (T *obj, CORBA::Boolean release=1);
    // set the underlying object and the ownership flag
    CORBA::Boolean _is_owner (void);
    // do we own it
    void _is_owner (CORBA::Boolean b);
    // set the ownership
    
    // overridden ServantBase operations
    PortableServer::POA_ptr _default_POA (
        CORBA::Environment &env = 
          TAO_default_environment ()
      );
    M_STORAGE::ReturnInfo * query_num_calls_1 (
        const char * ob_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_num_calls_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_last_delay (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_last_delay_from (
        const char * ob_name,
        const char * op_name,
        const char * ip,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_average_delay (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_mr_client_machine_1 (
        const char * ob_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_mr_client_machine_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_all_client_machines (
        const char * ob_name,
        const char * op_name,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_last_timestamp_1 (
        const char * ob_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_last_timestamp_2 (
        const char * ob_name,
        const char * op_name,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_average_delay_from_1 (
        const char * ob_name,
        const char * ip,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

    M_STORAGE::ReturnInfo * query_average_delay_from_2 (
        const char * ob_name,
        const char * op_name,
        const char * ip,
        CORBA::ULong starttime,
        CORBA::ULong endtime,
        CORBA::Environment &ACE_TRY_ENV = 
          TAO_default_environment ()
      )
      ACE_THROW_SPEC ((
        CORBA::SystemException
      ));

private:
    T *ptr_;
    PortableServer::POA_var poa_;
    CORBA::Boolean rel_;
    
    // copy and assignment are not allowed
    QueryInfo_tie (const QueryInfo_tie &);
    void operator= (const QueryInfo_tie &);
  };

#endif /* ACE_HAS_USING_KEYWORD */

};

#include "StorageS_T.h"

#if defined (__ACE_INLINE__)
#include "StorageS.i"
#endif /* defined INLINE */

#if defined(_MSC_VER)
#pragma warning(default:4250)
#endif /* _MSC_VER */

#endif /* ifndef */
