//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Storage_i.h
//
// DESCRIPTION:
//      This class implements the Storage interface server skeleton in
//      Storage.idl. It receives entries from the interceptor and
//      delegate the task of managing to the data manager.
// 
//***************************************************************************

#ifndef STORAGE_I_H
#define STORAGE_I_H

#include "StorageS.h"
#include "Data_Manager.h"

class Storage_i : public POA_M_STORAGE::Storage
{
public:
  Storage_i ();
  ~Storage_i ();
  
  // Add one entry to the storage server. This function is not used in this project.
  // But it can be useful in other situations.
  void add_single_entry(const M_STORAGE::entry &_e,
			CORBA::Environment &_tao_environment);

  // Add multiple entries to the storage server. This function is called by the
  // Monitoring Interceptor.
  void add_multiple_entries(const M_STORAGE::entrySeq &_es,
			    CORBA::Environment &_tao_environment);

  // This function resets the water_mark for the storage buffer. The water_mark
  // tells the data manager how often it should move data from the buffer to the
  // log files.
  void set_water_mark(CORBA::UShort m,
		      CORBA::Environment &_tao_environment);
private:

  // Check the water_mark. If over the water_mark, dump data to files.
  void check_water_mark(char* objname, CORBA::Environment &_tao_environment);

  Data_Manager *manager;
  CORBA::UShort watermark;
};

#endif

