//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Client_i.h
//
// DESCRIPTION:
//      This is the client program for the storage server.
// 
//***************************************************************************

#ifndef STORAGE_CLIENT_I_H
#define STORAGE_CLIENT_I_H

#include "ace/Get_Opt.h"
//#include "ace/Profile_Timer.h"
#include "tao/corba.h"

#include "StorageC.h"
//#include "QueryInfoC.h"

class StorageClient
{
public:
  // = Constructor and destructor.
  StorageClient (void);
  ~StorageClient (void);

  void run ();
  // Execute client example code.

  int init (int argc, char **argv);
  // Initialize the client communication endpoint with server.

  void fini ();
  // Shuts down the local ORB.

private:
  int read_ior (char *filename);
  // Function to read the cc factory ior from a file.

  void displayMenu();

  int parse_args (void);
  // Parses the arguments passed on the command line.
 
  int init_naming_service();
  // Initialize naming service and get ior for the server

  int argc_;
  // # of arguments on the command line.

  char **argv_;
  // arguments from command line.

  char *Storage_key_;
  // Key of hello obj ref.

  M_STORAGE::Storage_var storage_;
  // hello pointer.

  M_STORAGE::QueryInfo_var query_info_;

  CORBA::Environment env_;
  // Environment variable.

  CORBA::ORB_var orb_;
  // Remember our orb.

  ACE_HANDLE f_handle_;
  // File handle to read the IOR.

};

#endif
