//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      server.cpp
//
// DESCRIPTION:
//      This class is the server program for the storage server.
// 
//***************************************************************************

#include "server_i.h"

int
main (int argc, char *argv[])
{
  StorageServer StorageServ;

  ACE_DEBUG ((LM_DEBUG,
              "\n\tStorage:SERVER\n\n"));
  TAO_TRY
    {
      if (StorageServ.init (argc, argv, TAO_TRY_ENV) == -1)
        return -1;
      else
        {
          StorageServ.run (TAO_TRY_ENV);
          TAO_CHECK_ENV;
        }
    }
  TAO_CATCH (CORBA::SystemException, sysex)
    {
      ACE_UNUSED_ARG (sysex);
      TAO_TRY_ENV.print_exception ("System Exception");
      return -1;
    }
  TAO_CATCH (CORBA::UserException, userex)
    {
      ACE_UNUSED_ARG (userex);
      TAO_TRY_ENV.print_exception ("User Exception");
      return -1;
    }
  TAO_ENDTRY;
  return 0;
}
