//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      server_i.h
//
// DESCRIPTION:
//      This class is the server program for the storage server.
// 
//***************************************************************************

#if !defined (CC_SERVER_I_H)
#define CC_SERVER_I_H

#include "ace/Get_Opt.h"
#include "tao/TAO.h"
#include "ace/Log_Msg.h"
#include "Storage_i.h"
#include "QueryInfo_i.h"
#include "orbsvcs/CosNamingC.h"
#include "orbsvcs/Naming/Naming_Utils.h"

class StorageServer
{
public:
  // = Initialization and termination methods.
  StorageServer (void);
  // Default constructor

  ~StorageServer (void);
  // Destructor

  int init (int argc,
            char **argv,
	    CORBA::Environment& env);

  int run (CORBA::Environment& env);
  // Run the orb 

private:
  int parse_args (void);
  // Parses the commandline arguments.

  int init_naming_service(CORBA::Environment&);

  FILE* ior_output_file_;
  // File to output the cubit factory IOR.

  TAO_ORB_Manager orb_manager_;
  // The ORB manager.
  
  TAO_Naming_Server my_name_server_;
  // An instance of the name server used for registering the factory
  // objects.
  
  Storage_i storage_impl_;

  QueryInfo_i query_impl_;

  M_STORAGE::Storage_var factory;
  // Factory_var to register with NamingService.

  M_STORAGE::QueryInfo_var factory_query;

  CosNaming::NamingContext_var Storage_context_;
  // Naming context for the cubit_factory.
  CosNaming::NamingContext_var QueryInfo_context_;

  CosNaming::NamingContext_var naming_context_;
  // Naming context for the Naming Service.

  int argc_;
  // Number of commandline arguments.

  char **argv_;
  // commandline arguments.
};

#endif /* _C_SERVER_H */
