// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Reactive_Strategy_Factory.cpp
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Reactive_Strategy_Factory.cpp,v 1.1.1.2 2000/09/30 17:35:53 yamane Exp $
// ============================================================================

#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "Reactive_Strategy_Factory.h"

const char * const Reactive_Strategy_Factory::infoStr  = "Single-threaded Reactive Strategy";

int
Reactive_Strategy_Factory::init (int argc, char *argv[])
{
  localConfigurator (new SimpleConfigurator ("Reactive Strategy", this));
  localConfigurator ()->info (infoStr);
  return 0;
}

int
Reactive_Strategy_Factory::open (void)
{
  return 0;
#if 0
  TAO_ORB_Core *orb_core = TAO_ORB_Core_instance ();

  return reactive_strategy_.open (orb_core->reactor ());
#endif
}

int Reactive_Strategy_Factory::info (char **info_string, size_t length) const
{
  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, infoStr, length);
  return ACE_OS::strlen (*info_string);
}


void *
Reactive_Strategy_Factory::strategy (void)
{
  int activate_server_connections = 1;
  return (void *)activate_server_connections;
#if 0
  return &reactive_strategy_;
#endif
}


ACE_FACTORY_DEFINE (CONCURRENCY_STRATEGY, Reactive_Strategy_Factory)



//MACRO EXPANDED

/*extern "C" void _gobble_Reactive_Strategy_Factory (void *p) 
{ 
	Reactive_Strategy_Factory *_p = (Reactive_Strategy_Factory *) p; 
	delete _p; 
} 


extern "C" ACE_Service_Object *_make_Reactive_Strategy_Factory (ACE_Service_Object_Exterminator *gobbler) 
{ 
	ACE_TRACE (Reactive_Strategy_Factory); 
	
	if (gobbler != 0) 
		*gobbler = (ACE_Service_Object_Exterminator) _gobble_Reactive_Strategy_Factory; 
	return new Reactive_Strategy_Factory;
}*/
