// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Reactive_Strategy_Factory.h
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Reactive_Strategy_Factory.h,v 1.1.1.2 2000/09/30 17:36:25 yamane Exp $
// ============================================================================

#if !defined (REACTIVE_STRATEGY_FACTORY_H)
#  define REACTIVE_STRATEGY_FACTORY_H

#include "Concurrency_Strategy_export.h"

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"

class Reactive_Strategy_Factory : public Simple_Strategy_Factory
  // = TITLE
  //    It's simply a factory for the TAO Reactive Strategy.
{
public:
  // = Initialization and termination methods.

  int init (int argc, char *argv[]);

  int open (void);

  int info (char **info_string, size_t length) const;

  // = Factory method
  void *strategy (void);
  // Returns the reactive strategy.

#if 0
  ACE_Reactive_Strategy<TAO_Server_Connection_Handler> reactive_strategy_;
  // The threaded strategy used for passively establishing
  // connections.
#endif
private:
  static const char * const infoStr;
};

ACE_FACTORY_DECLARE (CONCURRENCY_STRATEGY, Reactive_Strategy_Factory)

//EXPANDED MACRO: extern "C" ACE_Export ACE_Service_Object *_make_Reactive_Strategy_Factory (ACE_Service_Object_Exterminator*);


#endif /* REACTIVE_STRATEGY_FACTORY_H */
