// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Thread_Strategy_Factory.h
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Thread_Pool_Strategy_Factory.h,v 1.1.1.1 1999/10/12 00:43:29 f-kon Exp $
// ============================================================================

#if !defined (THREAD_STRATEGY_FACTORY_H)
#  define THREAD_STRATEGY_FACTORY_H

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"
#include "thread_pool_strategy.h"

class Thread_Pool_Strategy_Factory : public Simple_Strategy_Factory
  // = TITLE
  //    It's simply a factory for the TAO Thread Pool Strategy.
{
public:
  // = Initialization and termination methods.
  Thread_Pool_Strategy_Factory (void);
  // Constructor.

  ~Thread_Pool_Strategy_Factory(void);
  // Destructor.

  int init (int argc, char *argv[]);

  int open (void);

  int info (char **info_string, size_t length) const;

  // = Factory method
  void *strategy (void);
  // Return the threaded strategy.

  ACE_Thread_Pool_Strategy<TAO_Server_Connection_Handler> thread_pool_strategy_;
  // The threaded strategy used for passively establishing
  // connections.

  int fini();

private:

  u_long thread_flags_; // Look at default_server.cpp to see how to use this.
  // Default thread flags passed to thr_create().

  int pool_size_;
  int low_wm_;
  int high_wm_;
  
  static const char * const infoStr;
};

ACE_FACTORY_DECLARE (ACE, Thread_Pool_Strategy_Factory)


#endif /* THREAD_STRATEGY_FACTORY_H */









