// ============================================================================
//
// = LIBRARY
//    Thread_Strategy
// 
// = FILENAME
//     Thread_Strategy_Factory.cpp
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Thread_Strategy_Factory.cpp,v 1.1.1.3 2000/09/30 17:36:59 yamane Exp $
// ============================================================================

#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "Thread_Strategy_Factory.h"


const char * const Thread_Strategy_Factory::infoStr  = "Thread-per-Connection Strategy";

Thread_Strategy_Factory::Thread_Strategy_Factory (void) 
  : thread_flags_ (0)
{
}

int
Thread_Strategy_Factory::init (int argc, char *argv[])
{
  localConfigurator (new SimpleConfigurator ("Thread Strategy", this));
  localConfigurator ()->info (infoStr);
  return 0;
}


int Thread_Strategy_Factory::info (char **info_string, size_t length) const
{
  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, infoStr, length);
  return ACE_OS::strlen (*info_string);
}




void *
Thread_Strategy_Factory::strategy (void)
{
  int activate_server_connections = 1;
  return (void *)activate_server_connections;
#if 0
  return &threaded_strategy_;
#endif
}

ACE_FACTORY_DEFINE (CONCURRENCY_STRATEGY, Thread_Strategy_Factory)

#if 0
#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Concurrency_Strategy<TAO_Server_Connection_Handler>;
#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Concurrency_Strategy<TAO_Server_Connection_Handler>
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */
#endif

