// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Thread_Strategy_Factory.h
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Thread_Strategy_Factory.h,v 1.1.1.2 2000/09/30 17:37:33 yamane Exp $
// ============================================================================

#if !defined (THREAD_STRATEGY_FACTORY_H)
#  define THREAD_STRATEGY_FACTORY_H

#include "Concurrency_Strategy_export.h"

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"

class Thread_Strategy_Factory : public Simple_Strategy_Factory
  // = TITLE
  //    It's simply a factory for the TAO Thread Strategy.
{
public:
  // = Initialization and termination methods.
  Thread_Strategy_Factory (void);
  // Constructor.

  int init (int argc, char *argv[]);
  
  int info (char **info_string, size_t length) const;

  // = Factory method
  void *strategy (void);
  // Return the threaded strategy.

#if 0
  ACE_Thread_Strategy<TAO_Server_Connection_Handler> threaded_strategy_;
  // The threaded strategy used for passively establishing
  // connections.
#endif
 private:

  u_long thread_flags_; // Look at default_server.cpp to see how to use this.
  // Default thread flags passed to thr_create().

  static const char * const infoStr;
};

ACE_FACTORY_DECLARE (CONCURRENCY_STRATEGY, Thread_Strategy_Factory)


#endif /* THREAD_STRATEGY_FACTORY_H */









