// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//      JVM_Strategy_Factory
// 
// = FILENAME
//     JVM_Strategy_Factory.h
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: JVM_Strategy_Factory.h,v 1.1.1.1 1999/10/12 00:43:30 f-kon Exp $
// ============================================================================

#if !defined (JAVA_INT_STRATEGY_FACTORY_H_)
#  define JAVA_INT_STRATEGY_FACTORY_H_

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"
#include "JVM_Strategy.h"

class JVM_Strategy_Factory : public Simple_Strategy_Factory
{
public:
  // = Initialization and termination methods.
  JVM_Strategy_Factory (void);
  // Constructor.

  ~JVM_Strategy_Factory(void);
  // Destructor.

  int init (int argc, char *argv[]);

  int open (void);

  int info (char **info_string, size_t length) const;

  int configure (char *message_string);

  // = Factory method
  void *strategy (void);

    // add a configure method that will receive exec commands
  
private:

  JVM_Strategy jvm_strategy_;

  static const char * const infoStr;
};

ACE_FACTORY_DECLARE (ACE, JVM_Strategy_Factory)


#endif /* THREAD_STRATEGY_FACTORY_H */

