// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Java_Int_Strategy_Factory.h
//
// = AUTHOR
//     Manuel Roman (mroman@cs.uiuc.edu)
//
// = VERSION
//     $Id: java_int_Strategy_Factory.h,v 1.1.1.1 1999/10/12 00:43:30 f-kon Exp $
// ============================================================================

#if !defined (JAVA_INT_STRATEGY_FACTORY_H_)
#  define JAVA_INT_STRATEGY_FACTORY_H_

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"
#include "java_int_strategy.h"

class Java_Int_Strategy_Factory : public Simple_Strategy_Factory
{
public:
  // = Initialization and termination methods.
  Java_Int_Strategy_Factory (void);
  // Constructor.

  ~Java_Int_Strategy_Factory(void);
  // Destructor.

  int init (int argc, char *argv[]);

  int open (void);

  int info (char **info_string, size_t length) const;

  // = Factory method
  void *strategy (void);
  // Return the threaded strategy.
  
  int fini();

private:

  Java_Interpreting_Strategy java_int_strategy_;

  static const char * const infoStr;
};

ACE_FACTORY_DECLARE (ACE, Java_Int_Strategy_Factory)


#endif /* THREAD_STRATEGY_FACTORY_H */









