#include "java_int_strategy.h"

int Java_Interpreting_Strategy::open()
{
	ACE_OS::printf("Opening JVM\n");
	
	JNI_GetDefaultJavaVMInitArgs(&vm_args);
    
	//sprintf(classpath, "%s%c%s",
    //vm_args.classpath, PATH_SEPARATOR, USER_CLASSPATH);
	vm_args.classpath = CLASSPATH;
    
	/* Create the Java VM */
	res = JNI_CreateJavaVM(&jvm,&env,&vm_args);

	if (res < 0) 
	{
		ACE_OS::printf("Can't create Java VM\n");
		return 0;
	}

	return 1;
}


unsigned char Java_Interpreting_Strategy::interpret(char *code, char *argstr)
{   
	//ACE_OS::printf("JVM::interpret- - - Code:%s\n",code);
	//ACE_OS::printf("JVM::Env --- %d\n",env);


	jint res = (*jvm).AttachCurrentThread(&env, NULL);
    if (res < 0) {
		ACE_OS::printf("Thread attach failed\n");
       return 0;
    }

	
	cls = (*env).FindClass(code);

	if (cls == 0) 
	{
		ACE_OS::printf("Can't find the %s class\n",code);
	   (*jvm).DetachCurrentThread();
		return 0;
    }
   
	mid = (*env).GetStaticMethodID(cls, "main", "([Ljava/lang/String;)Z");
	
	if (mid == 0) 
	{
		ACE_OS::printf("Can't find main method\n");
		(*jvm).DetachCurrentThread();
		return 0;
	}
    
	jstr = (*env).NewStringUTF(argstr);
		
	if (jstr == 0) 
	{
		cerr<< "Out of memory\n";
		(*jvm).DetachCurrentThread();
		return 0;
	}
    
	args = (*env).NewObjectArray(1, (*env).FindClass("java/lang/String"), jstr);
    
	if (args == 0) 
	{
		ACE_OS::printf("Out of memory\n");
		(*jvm).DetachCurrentThread();
		return 0;
	}
	
	//unsigned char r=(*env).CallStaticBooleanMethod(cls, mid, args);
	unsigned char r=(*env).CallStaticBooleanMethod(cls, mid, args);
	
	(*jvm).DetachCurrentThread();
	return r;
}


void Java_Interpreting_Strategy::dump(void) const 
{
  ACE_TRACE ("JAVA_INTERPRETING_STRATEGY::dump");
}

