// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Java_Int_Strategy_Factory.cpp
//
// = AUTHOR
//     Manuel Roman (mroman1@cs.uiuc.edu)
//

#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "java_int_Strategy_Factory.h"

const char * const Java_Int_Strategy_Factory::infoStr  = "An implementation of the Java Virtual Machine that can be \r\n used to execute Java bytecode";

Java_Int_Strategy_Factory::Java_Int_Strategy_Factory (void) 
{
}

Java_Int_Strategy_Factory::~Java_Int_Strategy_Factory(void)
{
}
	

int Java_Int_Strategy_Factory::init (int argc, char *argv[])
{	
  configurator (new SimpleConfigurator ("Java Interpreter Strategy", this));
  configurator ()->info (infoStr);
  java_int_strategy_.open();
  return 1;
}


int
Java_Int_Strategy_Factory::open (void)
{
  //TAO_ORB_Core *orb_core = TAO_ORB_Core_instance ();

  return 1;
}



int Java_Int_Strategy_Factory::info (char **info_string, size_t length) const
{
  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, "Java interpreting strategy\r\n", length);
  return ACE_OS::strlen (*info_string);
}



void *
Java_Int_Strategy_Factory::strategy (void)
{
  return &java_int_strategy_;
}


int
Java_Int_Strategy_Factory::fini(void)
{
	return 1;
}



ACE_FACTORY_DEFINE (ACE, Java_Int_Strategy_Factory)


//#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
//template class ACE_Concurrency_Strategy<TAO_Server_Connection_Handler>;
//#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
//#pragma instantiate ACE_Concurrency_Strategy<TAO_Server_Connection_Handler>
//#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */


