//**************************************************************************
// Author: 
//      Jina Mao      
// 
// Date:
//      May 3, 1999
//
// File:
//      Monitoring_Strategy.h
//
// Description:
//      The monitoring strategy inplements the interceptor which
// gets the request and send it to the storage server.
// 
//***************************************************************************

#if !defined(MONITORING_STRATEGY_H_)
#define MONITORING_STRATEGY_H_

#include "Monitoring_Strategy_export.h"
#include "performance_monitoring_strategy.h"
#include "ace/Env_Value_T.h"
#include "ace/Read_Buffer.h"
#include "orbsvcs/orbsvcs/CosNamingC.h"
#include "orbsvcs/orbsvcs/Naming/Naming_Utils.h"
#include "tao/Timeprobe.h"
#include "tao/corba.h"
#include "StorageC.h"
#include "ace/Containers_T.h"
// #include <sys/wait.h>

#include "ace/SString.h"
#include "My_NameSet.h"
#include "ace/Strategies.h"

class Monitoring_Strategy: public Performance_Monitoring_Strategy
{
public:
#if 0
  Monitoring_Strategy(){};
  ~Monitoring_Strategy(){};
#endif

  // This function does initialization when the interceptor is loaded.
  // It contacts the name service for the address of the storage server, and etc.
  int open();

  // This function is called whenever there is a method invocation comes into the ORB.
  // It first checks to see if it needs to monitor the invocation, if yes, it collects
  // information and send it to the storage server.
  void analyze(TAO_ORB_Core *orb_core, TAO_GIOP_ServerRequest &request, ACE_SOCK_Stream &peer, 
	       CORBA::Environment &env);

  // This function is called when the user sends a reconfiguration message through
  // the dynamic configurator interface.
  void reconfigure(char*);
	
  void dump (void) const {};

private:

  int read_ior(char*);

  // This function is called by the separate thread to send 
  // information to the storage server.
  static void entry_point(void* arg_env);

  static M_STORAGE::entrySeq* return_entries() { return entries; }

  char *Storage_key_;

  // Storage server
  static M_STORAGE::Storage_var storage_;
  
  CORBA::Environment env_;

  CORBA::ORB_var orb_;

  ACE_HANDLE f_handle_;

  // Name set which keeps track of all object names that need to be monitored
  My_NameSet* names;

  int findit;

  // data structure for buffering packets until it is full
  static M_STORAGE::entrySeq* entries;

  int counter;

  static int firsttime;
  static ACE_Semaphore *sem_;
  static ACE_Mutex mutex_;

};

#endif
