//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Monitoring_Strategy_Factory.cpp
//
// DESCRIPTION:
//      The monitoring strategy inplements the interceptor which
//      gets the request and send it to the storage server.
// 
//***************************************************************************
#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "Monitoring_Strategy_Factory.h"

const char * const Monitoring_Strategy_Factory::infoStr  
   = "This is Jina's Monitoring Interceptor";

#if 0
Monitoring_Strategy_Factory::Monitoring_Strategy_Factory(void) 
 : Simple_Strategy_Factory()
{
}

Monitoring_Strategy_Factory::~Monitoring_Strategy_Factory(void)
{
}
#endif

int Monitoring_Strategy_Factory::init (int argc, char *argv[])
{	
  localConfigurator (new SimpleConfigurator ("Monitoring Strategy", this));
  localConfigurator ()->info (infoStr);
  
  monitoring_strategy_.open();
  
  return 0;
}

#if 0
int
Monitoring_Strategy_Factory::open (void)
{
  return 0;
}
#endif


int Monitoring_Strategy_Factory::info (char **info_string, size_t length) const
{

  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, "Monitoring Strategy\r\n", length);
  return ACE_OS::strlen (*info_string);
}


void *
Monitoring_Strategy_Factory::strategy (void)
{
  return &monitoring_strategy_;
}

int 
Monitoring_Strategy_Factory::configure (char *messageString)
{
  ACE_OS::printf("Received config message <%s>\n", messageString);
  monitoring_strategy_.reconfigure(messageString);
  return 1;
}

int
Monitoring_Strategy_Factory::fini(void)
{
  return 1;
}


ACE_FACTORY_DEFINE (MONITORING_STRATEGY, Monitoring_Strategy_Factory)




