//**************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      Monitoring_Strategy_Factory.h
//
// DESCRIPTION:
//      The monitoring strategy inplements the interceptor which
//      gets the request and send it to the storage server.
// 
//***************************************************************************
#if !defined (MONITORING_STRATEGY_FACTORY_H_)
#define MONITORING_STRATEGY_FACTORY_H_

#include "Monitoring_Strategy_export.h"

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"
#include "Monitoring_Strategy.h"

class Monitoring_Strategy_Factory : public Simple_Strategy_Factory
{
public:
#if 0 
  Monitoring_Strategy_Factory (void);
  // Constructor.

  ~Monitoring_Strategy_Factory (void);
  // Destructor.

  int open (void);
#endif

  // = Initialization and termination methods.
  int init (int argc, char *argv[]);

  int info (char **info_string, size_t length) const;

  // = Factory method
  void *strategy (void);
  
  int configure (char *messageString);

  int fini();

private:

  Monitoring_Strategy monitoring_strategy_;
  static const char * const infoStr;
  
};

ACE_FACTORY_DECLARE (MONITORING_STRATEGY, Monitoring_Strategy_Factory)


#endif /* THREAD_STRATEGY_FACTORY_H */
