//**********************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      My_NameSet.cpp
//
// DESCRIPTION:
//      This class implements the name set mentioned in the Monitoring_Strategy
//      class. It keeps track of the names of the object that need to be monitored.
//**********************************************************************************
#include "My_NameSet.h"

// Initialize the array
My_NameSet::My_NameSet()
{
  num=0;
  for (int i=0; i<MAXNUM; i++)
    S[i][0]='\0';
}

My_NameSet::~My_NameSet()
{
//  delete S;
}

// Remove a name from the name set. It does not decrement
// the counter num. It just reset the string to be null.
int My_NameSet::remove(const char* s)
{
  //ACE_OS::printf("in remove.\n");
  int i;
  for (i=0; i<num; i++)
    {
      if (!ACE_OS::strcmp(S[i], s))
	{
	  S[i][0]='\0';
	  return 1;
	}
    }
//  if (i==num)
    return 0;
}

// Remove all the names in the set.
void My_NameSet::reset()
{
  //ACE_OS::printf("in reset().\n");
  for (int i=0; i<num; i++)
    S[i][0]='\0';
  num = 0;
}

// Find a name in the name set. If found, return 1, else return 0.
int My_NameSet::find(const char* s)
{
  //ACE_OS::printf("In find().\n");
  int i;
  for (i=0; i<num; i++)
    {
      if (ACE_OS::strcmp(S[i], s)==0)
	return 1;
    }
//  if (i==num)
    return 0;
}

// Insert a name into the name set.
int My_NameSet::insert(const char* s)
{
  //ACE_OS::printf("In insert().\n");
  int yes=0;
  if (num >= MAXNUM)
    {
      return -1;
      ACE_OS::printf("Name set full. Try increase the size of the name set in the source code.");
    }
  else if (!(find(s)))
    {
      for (int i=0; i<num; i++)
	{
	  if (S[i][0] =='\0')
	  {  
	    ACE_OS::strcpy(S[i], s);
	    yes = 1;
	  }
	}

      if (yes == 0)
	{
	  ACE_OS::strcpy(S[num], s);
	  //ACE_OS::printf("copied %s into %s\n", s, S[num]);
	  num++;
	}
      return 1;
    }
  else
    return 0;
}

// Print all names in the name set.
void My_NameSet::dump()
{
  for (int i=0; i<num; i++)
    {
      if (!(S[i][0]=='\0'))
	ACE_OS::printf("%d- %s\n",i,S[i]);
    }
}
