//*********************************************************************************
// AUTHOR: 
//      Jina Mao      
// 
// DATE:
//      May 3, 1999
//
// FILE:
//      My_NameSet.h
//
// DESCRIPTION:
//      This class implements the name set mentioned in the Monitoring_Strategy
//      class. It keeps track of the object names that need to be monitored.
// 
//*********************************************************************************

#ifndef MY_NAMESET_H
#define MY_NAMESET_H

// Maximum number of names in the name set.
#define MAXNUM 50

#include "tao/corba.h"

class My_NameSet
{
public:
  My_NameSet ();
  ~My_NameSet ();
  
  // Insert a name to the name set.
  int insert(const char* s);

  // Remove a name to the name set.
  int remove(const char* s);

  // Remove all names in the name set.
  void reset();

  // Find a name in the set. If found, return 1, if not, return 0.
  int find(const char* s);

  // Print out all names in the set.
  void dump();

private:
  char S[50][MAXNUM];
  int num;
};

#endif
