#include "tao/corba.h"
#include "cherubim_security_strategy.h"	
#include "dynamicTAO/src/DynamicConfigurator/dynamicConfiguratorC_.h"
#include "dynamicTAO/src/ace/Dynamic_Service_Config.h"
#include "dynamicTAO/src/StrategyFactories/Interpreting/java_int_strategy.h"
	
int Cherubim_Security_Strategy::open()
{
  //ACE_OS::printf("Inside OPEN Cherubim Strategy\n");
  
  TAO_TRY
    {	
      CORBA::Object_var dynconf_obj =
        TAO_ORB_Core_instance()->orb()->resolve_initial_references ("DynamicConfigurator");
      
      if (CORBA::is_nil (dynconf_obj.in ()))
        ACE_ERROR_RETURN ((LM_ERROR," (%P|%t) Unable to resolve the DynConf Service.\n"),-1);
      
      DynamicConfigurator_var dyn_conf = 
        DynamicConfigurator::_narrow (dynconf_obj.in (),TAO_TRY_ENV);
      
      //ACE_OS::printf("After narrowing Cherubim Strategy\n");	
      
      //Load the service
      dyn_conf->load_implementation("Interpreting", "Java_Int_Strategy", 
                                    "", TAO_TRY_ENV);
      TAO_CHECK_ENV;
      
      //ACE_OS::printf("After loading service Cherubim Strategy\n");	
      
      //Now hook the service
      dyn_conf->hook_implementation("Interpreting:1", "Interpreter", 
                                    "Interpreting_Strategy",TAO_TRY_ENV);
      TAO_CHECK_ENV;
      
      ACE_OS::printf("After hooking Cherubim Strategy\n");	
    }
  TAO_CATCH (CORBA::SystemException, sysex)
    {
      ACE_UNUSED_ARG (sysex);
      TAO_TRY_ENV.print_exception ("System Exception");
      return -1;
    }
  TAO_ENDTRY;
  return 1;
}


int Cherubim_Security_Strategy::check(TAO_GIOP_ServerRequest &request)
{
  int length=0;
  char params[100];
  char key[100];

  if(request.principal()!=0)
    {
      if(request.principal()->id.get_buffer()!=0)
        length+=ACE_OS::strlen((char *)request.principal()->id.get_buffer());
    }

  length+=ACE_OS::strlen(request.operation());
	
  int i,j,max=request.object_key().length();
		
  j=0;
  i=max-1;

  while(request.object_key()[i]!='/')
    i--;
	
  i++; //Skip '/'

  length+=max-i;

  for(;i<max;i++)
    {
      key[j++]=request.object_key()[i];
    }
  key[j]='\0';

  ACE_OS::sprintf(params,"%s %s %s",(char *)request.principal()->id.get_buffer(),
                  key,request.operation());

  //	ACE_OS::printf("Check::Args---%s\n",params);
						        
  return ( (Java_Interpreting_Strategy*)Dynamic_Service_Config::instance()->domainConfigurator()->getHookedComponent("Interpreter"))->interpret("Servertest",params);
}
