// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Cherubim_Security_Strategy_Factory.cpp
//
// = AUTHOR
//     Manuel Roman (mroman1@cs.uiuc.edu)
//

#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "cherubim_security_strategy_factory.h"


const char * const Cherubim_Security_Strategy_Factory::infoStr  = "A flexible security strategy using Cherubim Active Capabilities";

Cherubim_Security_Strategy_Factory::Cherubim_Security_Strategy_Factory(void) 
{
}

Cherubim_Security_Strategy_Factory::~Cherubim_Security_Strategy_Factory(void)
{
}


int Cherubim_Security_Strategy_Factory::init (int argc, char *argv[])
{	
  configurator ( new SimpleConfigurator ("Cherubim Security Strategy", this));
  configurator ()->info (infoStr);
  cherubim_security_strategy_.open();

  return 1;
}


int
Cherubim_Security_Strategy_Factory::open (void)
{
  return 1;
}



int Cherubim_Security_Strategy_Factory::info (char **info_string, size_t length) const
{
  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, "Cherubim Security strategy\r\n", length);
  return ACE_OS::strlen (*info_string);
}



void *
Cherubim_Security_Strategy_Factory::strategy (void)
{
  return &cherubim_security_strategy_;
}


int
Cherubim_Security_Strategy_Factory::fini(void)
{
	return 1;
}


ACE_FACTORY_DEFINE (ACE, Cherubim_Security_Strategy_Factory)




