// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Cherubim_Security_Strategy_Factory.h
//
// = AUTHOR
//     Manuel Roman (mroman1@cs.uiuc.edu)
//
// ============================================================================

#if !defined (Cherubim_SECURITY_STRATEGY_FACTORY_H_)
#  define Cherubim_SECURITY_STRATEGY_FACTORY_H_

#include "ace/OS.h"
#include "dynamicTAO/src/ace/Simple_Strategy_Factory.h"
#include "cherubim_security_strategy.h"

class Cherubim_Security_Strategy_Factory : public Simple_Strategy_Factory
{
public:
  // = Initialization and termination methods.
  Cherubim_Security_Strategy_Factory (void);
  // Constructor.

  virtual ~Cherubim_Security_Strategy_Factory (void);
  // Destructor.

  int init (int argc, char *argv[]);

  int open (void);

  int info (char **info_string, size_t length) const;

  // = Factory method
  void *strategy (void);
  // Return the threaded strategy.
  
  int fini();

private:

  Cherubim_Security_Strategy cherubim_security_strategy_;

  static const char * const infoStr;
};

ACE_FACTORY_DECLARE (ACE, Cherubim_Security_Strategy_Factory)


#endif /* THREAD_STRATEGY_FACTORY_H */