// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Null_Security_Strategy_Factory.cpp
//
// = AUTHOR
//     Manuel Roman (mroman1@cs.uiuc.edu)
//

#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "null_security_strategy_factory.h"

const char * const Null_Security_Strategy_Factory::infoStr  = "Security for the client side. It bypasses the principal request";

Null_Security_Strategy_Factory::Null_Security_Strategy_Factory(void) 
{
}

Null_Security_Strategy_Factory::~Null_Security_Strategy_Factory(void)
{
}


int Null_Security_Strategy_Factory::init (int argc, char *argv[])
{	
  configurator (new SimpleConfigurator ("Null Security Strategy", this));
  configurator ()->info (infoStr);
  null_security_strategy_.open();
  return 1;
}


int
Null_Security_Strategy_Factory::open (void)
{
  return 1;
}



int Null_Security_Strategy_Factory::info (char **info_string, size_t length) const
{
  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, "Null Security strategy\r\n", length);
  return ACE_OS::strlen (*info_string);
}



void *
Null_Security_Strategy_Factory::strategy (void)
{
  return &null_security_strategy_;
}


int
Null_Security_Strategy_Factory::fini(void)
{
	return 1;
}



ACE_FACTORY_DEFINE (ACE, Null_Security_Strategy_Factory)




