// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Principal_Security_Strategy_Factory.cpp
//
// = AUTHOR
//     Manuel Roman (mroman1@cs.uiuc.edu)
//

#include "tao/corba.h"
#include "tao/ORB_Core.h"
#include "principal_security_strategy_factory.h"

const char * const Principal_Security_Strategy_Factory::infoStr  = "Adds the principal name to the client request";

Principal_Security_Strategy_Factory::Principal_Security_Strategy_Factory(void) 
{
}

Principal_Security_Strategy_Factory::~Principal_Security_Strategy_Factory(void)
{
}


int Principal_Security_Strategy_Factory::init (int argc, char *argv[])
{	
  configurator ( new SimpleConfigurator ("Principal Security Strategy", this) );
  configurator ()->info ();
  principal_security_strategy_.open();
  return 1;
}


int
Principal_Security_Strategy_Factory::open (void)
{
  return 1;
}



int Principal_Security_Strategy_Factory::info (char **info_string, size_t length) const
{
  if (*info_string == 0)
    return -1;

  ACE_OS::strncpy(*info_string, "Principal Security strategy\r\n", length);
  return ACE_OS::strlen (*info_string);
}



void *
Principal_Security_Strategy_Factory::strategy (void)
{
  return &principal_security_strategy_;
}


int
Principal_Security_Strategy_Factory::fini(void)
{
	return 1;
}


ACE_FACTORY_DEFINE (ACE, Principal_Security_Strategy_Factory)




