/******************************************************************************
*                                                                             *
*  File: DCP.cpp                                                              *
*                                                                             *
*  Description: Implementation of DCP, a protocol for configuring             *
*  distributed components.                                                    *
*                                                                             *
*  Project: 2K - dynamically configurable ORB.                                *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.1 $

   $Log: DCP.cpp,v $
   Revision 1.1.1.1  1999/10/12 00:43:30  f-kon
   Version compatible with TAO 1.0

   Revision 1.2  1999/04/07 20:09:00  f-kon
   added new DCP commands, upgrading to version 1.1

   Revision 1.1.1.1  1999/04/01 18:16:36  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.5  1999/03/03 16:12:08  f-kon
   Implemented DCP operation configure_implementation <loaded_implementation> <configuration_string>

   Revision 1.4  1999/01/11 23:13:48  f-kon
   Upgrade to DCP v1.0 and improvements to the PersistentRepository.

   Revision 1.3  1999/01/07 22:43:27  f-kon
   Added TAOConfigurator and new DCP commands

   Revision 1.2  1998/08/30 14:56:24  f-kon
   First modifications to try to make it work in Windows

******************************************************************************/

#include "DCP.h"

const char * const DCP::LIST_CATEGORIES = "list_categories";
const char * const DCP::LIST_IMPLEMENTATIONS = "list_implementations";
const char * const DCP::GET_LATEST_VERSION = "get_latest_version";
const char * const DCP::LIST_LOADED_IMPLEMENTATIONS = "list_loaded_implementations";
const char * const DCP::GET_IMPL_INFO = "get_impl_info";
const char * const DCP::LIST_DOMAIN_COMPONENTS = "list_domain_components";
const char * const DCP::LIST_HOOKS = "list_hooks";
const char * const DCP::GET_COMP_INFO = "get_comp_info";
const char * const DCP::GET_HOOKED_COMP = "get_hooked_comp";

const char * const DCP::ADD_HOOK = "add_hook";
const char * const DCP::REMOVE_HOOK = "remove_hook";
const char * const DCP::LOAD_IMPLEMENTATION = "load_implementation";
const char * const DCP::HOOK_IMPLEMENTATION = "hook_implementation";
const char * const DCP::SUSPEND_IMPLEMENTATION = "suspend_implementation";
const char * const DCP::RESUME_IMPLEMENTATION = "resume_implementation";
const char * const DCP::REMOVE_IMPLEMENTATION = "remove_implementation";

const char * const DCP::CONFIGURE_IMPLEMENTATION = "configure_implementation";

const char * const DCP::UPLOAD_IMPLEMENTATION = "upload_implementation";
const char * const DCP::DELETE_IMPLEMENTATION = "delete_implementation";

const char * const DCP::RESTART = "restart";
const char * const DCP::QUIT = "quit";
const char * const DCP::HELP = "help";


const char * const DCP_Reply::ACK = "ack\r\n\r\n";
const char * const DCP_Reply::NACK = "nack\r\n\r\n";
const char * const DCP_Reply::DEFERRED = "deferred\r\n\r\n";
const char * const DCP_Reply::UNKNOWN_REQUEST = "Unknown request.\r\n\r\n";
const char * const DCP_Reply::UNKNOWN_ENTITY = "Unknown entity.\r\n\r\n";
const char * const DCP_Reply::EMPTY = "Query returned empty result.\r\n\r\n";
const char * const DCP_Reply::MALFORMED_REQUEST = "Malformed request.\r\n\r\n";

