/******************************************************************************
*                                                                             *
*  File: DCP.h                                                                *
*                                                                             *
*  Description: Implementation of DCP, a protocol for configuring             *
*  distributed components (services).                                         *
*                                                                             *
*  Project: 2K - dynamically configurable ORB.                                *
*  Author: Fabio Kon (f-kon@cs.uiuc.edu)                                      *
*                                                                             *
*******************************************************************************

   Revision Control Information

   $Revision: 1.1.1.1 $

   $Log: DCP.h,v $
   Revision 1.1.1.1  1999/10/12 00:43:30  f-kon
   Version compatible with TAO 1.0

   Revision 1.2  1999/04/07 20:09:01  f-kon
   added new DCP commands, upgrading to version 1.1

   Revision 1.1.1.1  1999/04/01 18:16:36  f-kon
   This new 2K source tree contains the most up-to-date version of ACE and TAO
   and including the dynamicTAO code as well as some 2K tests and preliminary
   versions of some of its high-level systems.


   Revision 1.5  1999/03/03 16:12:09  f-kon
   Implemented DCP operation configure_implementation <loaded_implementation> <configuration_string>

   Revision 1.4  1999/01/11 23:13:49  f-kon
   Upgrade to DCP v1.0 and improvements to the PersistentRepository.

   Revision 1.3  1999/01/07 22:43:28  f-kon
   Added TAOConfigurator and new DCP commands

   Revision 1.2  1998/08/30 14:56:25  f-kon
   First modifications to try to make it work in Windows

******************************************************************************/

#ifndef DCP_H
#define DCP_H


class DCP {
 public:
  static const char * const LIST_CATEGORIES;		// implemented
  static const char * const LIST_IMPLEMENTATIONS;       // implemented
  static const char * const GET_LATEST_VERSION;         // implemented
  static const char * const LIST_LOADED_IMPLEMENTATIONS;// implemented
  static const char * const GET_IMPL_INFO;              // implemented
  static const char * const LIST_DOMAIN_COMPONENTS;     // implemented
  static const char * const LIST_HOOKS;                 // implemented
  static const char * const GET_COMP_INFO;              // implemented
  static const char * const GET_HOOKED_COMP;            // implemented

  static const char * const ADD_HOOK;                   // implemented
  static const char * const REMOVE_HOOK;                // implemented
  static const char * const LOAD_IMPLEMENTATION;        // implemented
  static const char * const HOOK_IMPLEMENTATION;        // implemented
  static const char * const SUSPEND_IMPLEMENTATION;     // implemented
  static const char * const RESUME_IMPLEMENTATION;      // implemented
  static const char * const REMOVE_IMPLEMENTATION;      // implemented

  static const char * const CONFIGURE_IMPLEMENTATION;

  static const char * const UPLOAD_IMPLEMENTATION;       // implemented
  static const char * const DELETE_IMPLEMENTATION;       // implemented

  static const char * const RESTART;                     // implemented
  static const char * const QUIT;                        // implemented
  static const char * const HELP;                        // implemented

 enum { major_version = 1, 
        minor_version = 1, 
        MAX_MESSAGE_SIZE = 1024};
};


class DCP_Reply {
 public:
  static const char * const ACK;
  static const char * const NACK;
  static const char * const DEFERRED;
  static const char * const UNKNOWN_REQUEST;
  static const char * const UNKNOWN_ENTITY;
  static const char * const EMPTY;
  static const char * const MALFORMED_REQUEST;
};

#endif
