/* -*- C++ -*- */
// $Id: Dynamic_Service_Config.i,v 1.1.1.2 1999/10/20 20:39:07 yamane Exp $

// Dynamic_Service_Config.i

// This is the primary entry point into the Dynamic_Service_Config (the
// constructor just handles simple initializations).

/*MANUEL: Changed ACE_INLINE for inline*/

ACE_INLINE int
Dynamic_Service_Config::open (int argc,
                              ASYS_TCHAR *argv[], 
                              LPCTSTR logger_key,
                              int ignore_static_svcs,
                              int ignore_default_svc_conf)
{
  ACE_TRACE ("Dynamic_Service_Config::open");
  Dynamic_Service_Config::parse_args (argc, argv);
  return Dynamic_Service_Config::open (argv[0], logger_key, 
                                       ignore_static_svcs, ignore_default_svc_conf);
}


ACE_INLINE void
Dynamic_Service_Config::netBroker (Net_Broker *netBroker)
{
  netBroker_ = netBroker;
}

ACE_INLINE Net_Broker *
Dynamic_Service_Config::netBroker ()
{
  return netBroker_;
}

ACE_INLINE void
Dynamic_Service_Config::netBroker2 (Net_Broker *netBroker2)
{
  netBroker2_ = netBroker2;
}

ACE_INLINE Net_Broker *
Dynamic_Service_Config::netBroker2 ()
{
  return netBroker2_;
}

ACE_INLINE SimpleConfigurator *
Dynamic_Service_Config::domainConfigurator ()
{
  return &domainConfigurator_;
}


//= The following methods simply delegates the execution to ACE_Service_Config.

// Load static services
ACE_INLINE int
Dynamic_Service_Config::load_static_svcs (void)
{
  return ACE_Service_Config::load_static_svcs ();
}

// processes the service configuration file.
ACE_INLINE int
Dynamic_Service_Config::process_directives (void)
{
  return ACE_Service_Config::process_directives ();
}

// Initialize and activate a static <svc_name> service.
ACE_INLINE int 
Dynamic_Service_Config::initialize (const char svc_name[], char parameters[])
{
  return ACE_Service_Config::initialize (svc_name, parameters);
}
