// ============================================================================
//
// = LIBRARY
//     ACE2k
// 
// = FILENAME
//     Simple_Strategy_Factory.cpp
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Simple_Strategy_Factory.cpp,v 1.1.1.3 1999/10/17 18:49:00 yamane Exp $
// ============================================================================

#include "Simple_Strategy_Factory.h"

Simple_Strategy_Factory::Simple_Strategy_Factory ()
  : localConfigurator_(0), thisTypeHasCorbaConfigurator_ (0)
{
}


int
Simple_Strategy_Factory::init (int argc, char *argv[])
{
  ACE_TRACE ("Simple_Strategy_Factory::init");
  
  localConfigurator_ = new SimpleConfigurator (0, this);
  thisTypeHasCorbaConfigurator_ = 0;
  return 0;
}

int
Simple_Strategy_Factory::info (char **info_string, size_t length) const
{
  ACE_TRACE ("Simple_Strategy_Factory::info");
  
  if (*info_string == 0)
    return -1;
  
  ACE_OS::strncpy(*info_string, "No information available.\r\n", length);
  return ACE_OS::strlen (*info_string);
  
}// info ()


int
Simple_Strategy_Factory::fini (void)
{
  ACE_TRACE ("Simple_Strategy_Factory::fini");
  // Calls the destructor on its configurator. The configurator then shall send
  // events to its clients.
  if (localConfigurator_ != 0)
    {
      delete localConfigurator_;
      localConfigurator_ = 0;
    }
  return 0;
}

int
Simple_Strategy_Factory::open (void)
{
  ACE_TRACE ("Simple_Strategy_Factory::open");
  return 0;
}



void *
Simple_Strategy_Factory::strategy (void)
{
  return 0;
}


// localConfigurator_ accessor methods
ComponentConfigurator *
Simple_Strategy_Factory::localConfigurator (void) 
{
  return localConfigurator_;
}

void 
Simple_Strategy_Factory::localConfigurator (ComponentConfigurator *c) 
{
  localConfigurator_ = c;
}

int 
Simple_Strategy_Factory::configure (char *message_string) 
{
  return 0;
}


