// This may look like C, but it's really -*- C++ -*-

// ============================================================================
//
// = LIBRARY
//     TAO2k
// 
// = FILENAME
//     Simple_Strategy_Factory.h
//
// = AUTHOR
//     Fabio Kon (f-kon@cs.uiuc.edu)
//
// = VERSION
//     $Id: Simple_Strategy_Factory.h,v 1.1.1.2 2000/09/30 18:15:08 yamane Exp $
// ============================================================================

#if !defined (SIMPLE_STRATEGY_FACTORY_H)
#  define     SIMPLE_STRATEGY_FACTORY_H

#include "dynamicTAO/src/ace/ace2k_export.h"

#include "ace/OS.h"
#include "ace/Service_Object.h"
#include "dynamicTAO/src/ComponentConfigurator/SimpleConfigurator.h"

class ACE_2K_Export Simple_Strategy_Factory : public ACE_Service_Object
  // = TITLE 
  // This is a wrapper that can be added to Strategies so they become
  // ACE Services and, then, can be stored in the ACE Service Repository.
{
public:
  Simple_Strategy_Factory ();

  // = Initialization and termination methods.

  virtual int init (int, char *[]);
  virtual int info (char **info_string, size_t length) const;
  virtual int fini (void);

  // this is used in some strategies when they are really going to be deployed.
  virtual int open (void);

  // = Factory method
  virtual  void *strategy (void);
  // Return the strategy.
  // It's a pitty we must return void * here. Probably, when rtti becomes
  // available, we can use it to make sure that we are doing the right thing.

  virtual ComponentConfigurator *localConfigurator (); 
  virtual void localConfigurator (ComponentConfigurator *c); 
  // accessor method for the strategy component configurator.

  virtual int configure (char *message_string);

  int typeHasCorbaConfigurator() { return thisTypeHasCorbaConfigurator_; }
protected:
  ComponentConfigurator *localConfigurator_;
  int thisTypeHasCorbaConfigurator_; // Note: this is used, while we cannot use
                                     // RTTI, to distinguish the type Simple_Strategy_Factory
                                     // from Component_Factory.
};

#endif /* SIMPLE_STRATEGY_FACTORY_H */









