#ifndef __SMARTPACKETREPLY_H
#define __SMARTPACKETREPLY_H

#ifndef __HOST_NODE
#define __HOST_NODE
#define MAX_HOST_NAME_LEN ACE_MAX_FULLY_QUALIFIED_NAME_LEN

class host_node
{
public:
  char name[MAX_HOST_NAME_LEN];
  int port;
};
#endif

#define MAX_REPLY_LEN 16*1024

class SmartPacketReply 
{

private: 
  char sprstream[MAX_REPLY_LEN];
  int sprstreamlen; // length of the smartpacketreply
  host_node cur_host; // current ORB identifier
  int host_dcp_present;

public:
  SmartPacketReply();
  void sethost(char *buf, int port);
  int initialize(char *stream, int len); 
  /* like SmartPacket::initialize() */
  void append(SmartPacketReply & spr);
  void append(char *, int);
  /* append a reply to this one */
  int toStream(char *stream);
  /* like SmartPacket::toStream() */
  void appendDCPoutput(const char*, int); 
};

#endif

/* 
   More generally I think we should have:
   appendDCPoutput(const char*) which I can call to append to the reply packet you
   are building
   
            SmartPacketReply
            ^/          \^
            /            \
           /              \
   appendSmartPacket   appendDCPoutput
   (from remote        (from local
   ORB)                execution)
*/
